
'''
    This is the pre-computed output of the following code:

    ```python
    import pprint

    _chrombigram_sets = []
    pcs = range(12)
    for r in range(13):
        pcsets = itertools.combinations(pcs, r)
        pcsets = [frozenset(x) for x in pcsets]
    for x in pcsets:
        _chrombigram_sets.append(x)

    pprint.pprint(_chrombigram_sets)
    ```
'''

chrombigram_sets = [
    frozenset(),
    frozenset({0}),
    frozenset({1}),
    frozenset({2}),
    frozenset({3}),
    frozenset({4}),
    frozenset({5}),
    frozenset({6}),
    frozenset({7}),
    frozenset({8}),
    frozenset({9}),
    frozenset({10}),
    frozenset({11}),
    frozenset({0, 1}),
    frozenset({0, 2}),
    frozenset({0, 3}),
    frozenset({0, 4}),
    frozenset({0, 5}),
    frozenset({0, 6}),
    frozenset({0, 7}),
    frozenset({0, 8}),
    frozenset({0, 9}),
    frozenset({0, 10}),
    frozenset({0, 11}),
    frozenset({1, 2}),
    frozenset({1, 3}),
    frozenset({1, 4}),
    frozenset({1, 5}),
    frozenset({1, 6}),
    frozenset({1, 7}),
    frozenset({8, 1}),
    frozenset({1, 9}),
    frozenset({1, 10}),
    frozenset({1, 11}),
    frozenset({2, 3}),
    frozenset({2, 4}),
    frozenset({2, 5}),
    frozenset({2, 6}),
    frozenset({2, 7}),
    frozenset({8, 2}),
    frozenset({9, 2}),
    frozenset({2, 10}),
    frozenset({2, 11}),
    frozenset({3, 4}),
    frozenset({3, 5}),
    frozenset({3, 6}),
    frozenset({3, 7}),
    frozenset({8, 3}),
    frozenset({9, 3}),
    frozenset({10, 3}),
    frozenset({11, 3}),
    frozenset({4, 5}),
    frozenset({4, 6}),
    frozenset({4, 7}),
    frozenset({8, 4}),
    frozenset({9, 4}),
    frozenset({10, 4}),
    frozenset({11, 4}),
    frozenset({5, 6}),
    frozenset({5, 7}),
    frozenset({8, 5}),
    frozenset({9, 5}),
    frozenset({10, 5}),
    frozenset({11, 5}),
    frozenset({6, 7}),
    frozenset({8, 6}),
    frozenset({9, 6}),
    frozenset({10, 6}),
    frozenset({11, 6}),
    frozenset({8, 7}),
    frozenset({9, 7}),
    frozenset({10, 7}),
    frozenset({11, 7}),
    frozenset({8, 9}),
    frozenset({8, 10}),
    frozenset({8, 11}),
    frozenset({9, 10}),
    frozenset({9, 11}),
    frozenset({10, 11}),
    frozenset({0, 1, 2}),
    frozenset({0, 1, 3}),
    frozenset({0, 1, 4}),
    frozenset({0, 1, 5}),
    frozenset({0, 1, 6}),
    frozenset({0, 1, 7}),
    frozenset({0, 1, 8}),
    frozenset({0, 1, 9}),
    frozenset({0, 1, 10}),
    frozenset({0, 1, 11}),
    frozenset({0, 2, 3}),
    frozenset({0, 2, 4}),
    frozenset({0, 2, 5}),
    frozenset({0, 2, 6}),
    frozenset({0, 2, 7}),
    frozenset({0, 8, 2}),
    frozenset({0, 9, 2}),
    frozenset({0, 2, 10}),
    frozenset({0, 2, 11}),
    frozenset({0, 3, 4}),
    frozenset({0, 3, 5}),
    frozenset({0, 3, 6}),
    frozenset({0, 3, 7}),
    frozenset({0, 8, 3}),
    frozenset({0, 9, 3}),
    frozenset({0, 10, 3}),
    frozenset({0, 11, 3}),
    frozenset({0, 4, 5}),
    frozenset({0, 4, 6}),
    frozenset({0, 4, 7}),
    frozenset({0, 8, 4}),
    frozenset({0, 9, 4}),
    frozenset({0, 10, 4}),
    frozenset({0, 11, 4}),
    frozenset({0, 5, 6}),
    frozenset({0, 5, 7}),
    frozenset({0, 8, 5}),
    frozenset({0, 9, 5}),
    frozenset({0, 10, 5}),
    frozenset({0, 11, 5}),
    frozenset({0, 6, 7}),
    frozenset({0, 8, 6}),
    frozenset({0, 9, 6}),
    frozenset({0, 10, 6}),
    frozenset({0, 11, 6}),
    frozenset({0, 8, 7}),
    frozenset({0, 9, 7}),
    frozenset({0, 10, 7}),
    frozenset({0, 11, 7}),
    frozenset({0, 8, 9}),
    frozenset({0, 8, 10}),
    frozenset({0, 8, 11}),
    frozenset({0, 9, 10}),
    frozenset({0, 9, 11}),
    frozenset({0, 10, 11}),
    frozenset({1, 2, 3}),
    frozenset({1, 2, 4}),
    frozenset({1, 2, 5}),
    frozenset({1, 2, 6}),
    frozenset({1, 2, 7}),
    frozenset({8, 1, 2}),
    frozenset({1, 2, 9}),
    frozenset({1, 2, 10}),
    frozenset({1, 2, 11}),
    frozenset({1, 3, 4}),
    frozenset({1, 3, 5}),
    frozenset({1, 3, 6}),
    frozenset({1, 3, 7}),
    frozenset({8, 1, 3}),
    frozenset({1, 3, 9}),
    frozenset({1, 10, 3}),
    frozenset({11, 1, 3}),
    frozenset({1, 4, 5}),
    frozenset({1, 4, 6}),
    frozenset({1, 4, 7}),
    frozenset({8, 1, 4}),
    frozenset({1, 4, 9}),
    frozenset({1, 10, 4}),
    frozenset({1, 11, 4}),
    frozenset({1, 5, 6}),
    frozenset({1, 5, 7}),
    frozenset({8, 1, 5}),
    frozenset({1, 5, 9}),
    frozenset({1, 10, 5}),
    frozenset({1, 11, 5}),
    frozenset({1, 6, 7}),
    frozenset({8, 1, 6}),
    frozenset({1, 6, 9}),
    frozenset({1, 10, 6}),
    frozenset({1, 11, 6}),
    frozenset({8, 1, 7}),
    frozenset({1, 9, 7}),
    frozenset({1, 10, 7}),
    frozenset({1, 11, 7}),
    frozenset({8, 1, 9}),
    frozenset({8, 1, 10}),
    frozenset({8, 1, 11}),
    frozenset({1, 10, 9}),
    frozenset({1, 11, 9}),
    frozenset({1, 10, 11}),
    frozenset({2, 3, 4}),
    frozenset({2, 3, 5}),
    frozenset({2, 3, 6}),
    frozenset({2, 3, 7}),
    frozenset({8, 2, 3}),
    frozenset({9, 2, 3}),
    frozenset({10, 2, 3}),
    frozenset({11, 2, 3}),
    frozenset({2, 4, 5}),
    frozenset({2, 4, 6}),
    frozenset({2, 4, 7}),
    frozenset({8, 2, 4}),
    frozenset({9, 2, 4}),
    frozenset({2, 10, 4}),
    frozenset({2, 11, 4}),
    frozenset({2, 5, 6}),
    frozenset({2, 5, 7}),
    frozenset({8, 2, 5}),
    frozenset({9, 2, 5}),
    frozenset({2, 10, 5}),
    frozenset({2, 11, 5}),
    frozenset({2, 6, 7}),
    frozenset({8, 2, 6}),
    frozenset({9, 2, 6}),
    frozenset({2, 10, 6}),
    frozenset({2, 11, 6}),
    frozenset({8, 2, 7}),
    frozenset({9, 2, 7}),
    frozenset({2, 10, 7}),
    frozenset({2, 11, 7}),
    frozenset({8, 9, 2}),
    frozenset({8, 2, 10}),
    frozenset({8, 2, 11}),
    frozenset({9, 2, 10}),
    frozenset({9, 2, 11}),
    frozenset({11, 2, 10}),
    frozenset({3, 4, 5}),
    frozenset({3, 4, 6}),
    frozenset({3, 4, 7}),
    frozenset({8, 3, 4}),
    frozenset({9, 3, 4}),
    frozenset({10, 3, 4}),
    frozenset({11, 3, 4}),
    frozenset({3, 5, 6}),
    frozenset({3, 5, 7}),
    frozenset({8, 3, 5}),
    frozenset({9, 3, 5}),
    frozenset({10, 3, 5}),
    frozenset({11, 3, 5}),
    frozenset({3, 6, 7}),
    frozenset({8, 3, 6}),
    frozenset({9, 3, 6}),
    frozenset({10, 3, 6}),
    frozenset({11, 3, 6}),
    frozenset({8, 3, 7}),
    frozenset({9, 3, 7}),
    frozenset({10, 3, 7}),
    frozenset({11, 3, 7}),
    frozenset({8, 9, 3}),
    frozenset({8, 10, 3}),
    frozenset({8, 11, 3}),
    frozenset({9, 10, 3}),
    frozenset({11, 9, 3}),
    frozenset({11, 10, 3}),
    frozenset({4, 5, 6}),
    frozenset({4, 5, 7}),
    frozenset({8, 4, 5}),
    frozenset({9, 4, 5}),
    frozenset({10, 4, 5}),
    frozenset({11, 4, 5}),
    frozenset({4, 6, 7}),
    frozenset({8, 4, 6}),
    frozenset({9, 4, 6}),
    frozenset({10, 4, 6}),
    frozenset({11, 4, 6}),
    frozenset({8, 4, 7}),
    frozenset({9, 4, 7}),
    frozenset({10, 4, 7}),
    frozenset({11, 4, 7}),
    frozenset({8, 9, 4}),
    frozenset({8, 10, 4}),
    frozenset({8, 11, 4}),
    frozenset({9, 10, 4}),
    frozenset({9, 11, 4}),
    frozenset({10, 11, 4}),
    frozenset({5, 6, 7}),
    frozenset({8, 5, 6}),
    frozenset({9, 5, 6}),
    frozenset({10, 5, 6}),
    frozenset({11, 5, 6}),
    frozenset({8, 5, 7}),
    frozenset({9, 5, 7}),
    frozenset({10, 5, 7}),
    frozenset({11, 5, 7}),
    frozenset({8, 9, 5}),
    frozenset({8, 10, 5}),
    frozenset({8, 11, 5}),
    frozenset({9, 10, 5}),
    frozenset({9, 11, 5}),
    frozenset({10, 11, 5}),
    frozenset({8, 6, 7}),
    frozenset({9, 6, 7}),
    frozenset({10, 6, 7}),
    frozenset({11, 6, 7}),
    frozenset({8, 9, 6}),
    frozenset({8, 10, 6}),
    frozenset({8, 11, 6}),
    frozenset({9, 10, 6}),
    frozenset({9, 11, 6}),
    frozenset({10, 11, 6}),
    frozenset({8, 9, 7}),
    frozenset({8, 10, 7}),
    frozenset({8, 11, 7}),
    frozenset({9, 10, 7}),
    frozenset({9, 11, 7}),
    frozenset({10, 11, 7}),
    frozenset({8, 9, 10}),
    frozenset({8, 9, 11}),
    frozenset({8, 10, 11}),
    frozenset({9, 10, 11}),
    frozenset({0, 1, 2, 3}),
    frozenset({0, 1, 2, 4}),
    frozenset({0, 1, 2, 5}),
    frozenset({0, 1, 2, 6}),
    frozenset({0, 1, 2, 7}),
    frozenset({0, 1, 2, 8}),
    frozenset({0, 1, 2, 9}),
    frozenset({0, 1, 2, 10}),
    frozenset({0, 1, 2, 11}),
    frozenset({0, 1, 3, 4}),
    frozenset({0, 1, 3, 5}),
    frozenset({0, 1, 3, 6}),
    frozenset({0, 1, 3, 7}),
    frozenset({0, 1, 3, 8}),
    frozenset({0, 1, 3, 9}),
    frozenset({0, 1, 10, 3}),
    frozenset({0, 1, 3, 11}),
    frozenset({0, 1, 4, 5}),
    frozenset({0, 1, 4, 6}),
    frozenset({0, 1, 4, 7}),
    frozenset({0, 1, 4, 8}),
    frozenset({0, 1, 4, 9}),
    frozenset({0, 1, 10, 4}),
    frozenset({0, 1, 11, 4}),
    frozenset({0, 1, 5, 6}),
    frozenset({0, 1, 5, 7}),
    frozenset({0, 1, 5, 8}),
    frozenset({0, 1, 5, 9}),
    frozenset({0, 1, 10, 5}),
    frozenset({0, 1, 11, 5}),
    frozenset({0, 1, 6, 7}),
    frozenset({0, 1, 6, 8}),
    frozenset({0, 1, 6, 9}),
    frozenset({0, 1, 10, 6}),
    frozenset({0, 1, 11, 6}),
    frozenset({0, 1, 8, 7}),
    frozenset({0, 1, 9, 7}),
    frozenset({0, 1, 10, 7}),
    frozenset({0, 1, 11, 7}),
    frozenset({0, 1, 8, 9}),
    frozenset({0, 1, 10, 8}),
    frozenset({0, 1, 11, 8}),
    frozenset({0, 1, 10, 9}),
    frozenset({0, 1, 11, 9}),
    frozenset({0, 1, 10, 11}),
    frozenset({0, 2, 3, 4}),
    frozenset({0, 2, 3, 5}),
    frozenset({0, 2, 3, 6}),
    frozenset({0, 2, 3, 7}),
    frozenset({0, 8, 2, 3}),
    frozenset({0, 9, 2, 3}),
    frozenset({0, 10, 2, 3}),
    frozenset({0, 11, 2, 3}),
    frozenset({0, 2, 4, 5}),
    frozenset({0, 2, 4, 6}),
    frozenset({0, 2, 4, 7}),
    frozenset({0, 8, 2, 4}),
    frozenset({0, 9, 2, 4}),
    frozenset({0, 2, 10, 4}),
    frozenset({0, 2, 11, 4}),
    frozenset({0, 2, 5, 6}),
    frozenset({0, 2, 5, 7}),
    frozenset({0, 8, 2, 5}),
    frozenset({0, 9, 2, 5}),
    frozenset({0, 2, 10, 5}),
    frozenset({0, 2, 11, 5}),
    frozenset({0, 2, 6, 7}),
    frozenset({0, 8, 2, 6}),
    frozenset({0, 9, 2, 6}),
    frozenset({0, 2, 10, 6}),
    frozenset({0, 2, 11, 6}),
    frozenset({0, 8, 2, 7}),
    frozenset({0, 9, 2, 7}),
    frozenset({0, 2, 10, 7}),
    frozenset({0, 2, 11, 7}),
    frozenset({0, 8, 2, 9}),
    frozenset({0, 8, 2, 10}),
    frozenset({0, 8, 2, 11}),
    frozenset({0, 9, 2, 10}),
    frozenset({0, 9, 2, 11}),
    frozenset({0, 11, 2, 10}),
    frozenset({0, 3, 4, 5}),
    frozenset({0, 3, 4, 6}),
    frozenset({0, 3, 4, 7}),
    frozenset({0, 8, 3, 4}),
    frozenset({0, 9, 3, 4}),
    frozenset({0, 10, 3, 4}),
    frozenset({0, 11, 3, 4}),
    frozenset({0, 3, 5, 6}),
    frozenset({0, 3, 5, 7}),
    frozenset({0, 8, 3, 5}),
    frozenset({0, 9, 3, 5}),
    frozenset({0, 10, 3, 5}),
    frozenset({0, 11, 3, 5}),
    frozenset({0, 3, 6, 7}),
    frozenset({0, 8, 3, 6}),
    frozenset({0, 9, 3, 6}),
    frozenset({0, 10, 3, 6}),
    frozenset({0, 11, 3, 6}),
    frozenset({0, 8, 3, 7}),
    frozenset({0, 9, 3, 7}),
    frozenset({0, 10, 3, 7}),
    frozenset({0, 11, 3, 7}),
    frozenset({0, 8, 3, 9}),
    frozenset({0, 8, 10, 3}),
    frozenset({0, 8, 3, 11}),
    frozenset({0, 9, 10, 3}),
    frozenset({0, 9, 3, 11}),
    frozenset({0, 11, 10, 3}),
    frozenset({0, 4, 5, 6}),
    frozenset({0, 4, 5, 7}),
    frozenset({0, 8, 4, 5}),
    frozenset({0, 9, 4, 5}),
    frozenset({0, 10, 4, 5}),
    frozenset({0, 11, 4, 5}),
    frozenset({0, 4, 6, 7}),
    frozenset({0, 8, 4, 6}),
    frozenset({0, 9, 4, 6}),
    frozenset({0, 10, 4, 6}),
    frozenset({0, 11, 4, 6}),
    frozenset({0, 8, 4, 7}),
    frozenset({0, 9, 4, 7}),
    frozenset({0, 10, 4, 7}),
    frozenset({0, 11, 4, 7}),
    frozenset({0, 8, 4, 9}),
    frozenset({0, 8, 10, 4}),
    frozenset({0, 8, 11, 4}),
    frozenset({0, 9, 10, 4}),
    frozenset({0, 9, 11, 4}),
    frozenset({0, 10, 11, 4}),
    frozenset({0, 5, 6, 7}),
    frozenset({0, 8, 5, 6}),
    frozenset({0, 9, 5, 6}),
    frozenset({0, 10, 5, 6}),
    frozenset({0, 11, 5, 6}),
    frozenset({0, 8, 5, 7}),
    frozenset({0, 9, 5, 7}),
    frozenset({0, 10, 5, 7}),
    frozenset({0, 11, 5, 7}),
    frozenset({0, 8, 5, 9}),
    frozenset({0, 8, 10, 5}),
    frozenset({0, 8, 11, 5}),
    frozenset({0, 9, 10, 5}),
    frozenset({0, 9, 11, 5}),
    frozenset({0, 10, 11, 5}),
    frozenset({0, 8, 6, 7}),
    frozenset({0, 9, 6, 7}),
    frozenset({0, 10, 6, 7}),
    frozenset({0, 11, 6, 7}),
    frozenset({0, 8, 6, 9}),
    frozenset({0, 8, 10, 6}),
    frozenset({0, 8, 11, 6}),
    frozenset({0, 9, 10, 6}),
    frozenset({0, 9, 11, 6}),
    frozenset({0, 10, 11, 6}),
    frozenset({0, 8, 9, 7}),
    frozenset({0, 8, 10, 7}),
    frozenset({0, 8, 11, 7}),
    frozenset({0, 9, 10, 7}),
    frozenset({0, 9, 11, 7}),
    frozenset({0, 10, 11, 7}),
    frozenset({0, 8, 10, 9}),
    frozenset({0, 8, 11, 9}),
    frozenset({0, 8, 10, 11}),
    frozenset({0, 9, 10, 11}),
    frozenset({1, 2, 3, 4}),
    frozenset({1, 2, 3, 5}),
    frozenset({1, 2, 3, 6}),
    frozenset({1, 2, 3, 7}),
    frozenset({8, 1, 2, 3}),
    frozenset({1, 2, 3, 9}),
    frozenset({10, 1, 2, 3}),
    frozenset({11, 1, 2, 3}),
    frozenset({1, 2, 4, 5}),
    frozenset({1, 2, 4, 6}),
    frozenset({1, 2, 4, 7}),
    frozenset({8, 1, 2, 4}),
    frozenset({1, 2, 4, 9}),
    frozenset({1, 2, 10, 4}),
    frozenset({1, 2, 11, 4}),
    frozenset({1, 2, 5, 6}),
    frozenset({1, 2, 5, 7}),
    frozenset({8, 1, 2, 5}),
    frozenset({1, 2, 5, 9}),
    frozenset({1, 2, 10, 5}),
    frozenset({1, 2, 11, 5}),
    frozenset({1, 2, 6, 7}),
    frozenset({8, 1, 2, 6}),
    frozenset({1, 2, 6, 9}),
    frozenset({1, 2, 10, 6}),
    frozenset({1, 2, 11, 6}),
    frozenset({8, 1, 2, 7}),
    frozenset({1, 2, 9, 7}),
    frozenset({1, 2, 10, 7}),
    frozenset({1, 2, 11, 7}),
    frozenset({8, 1, 2, 9}),
    frozenset({8, 1, 2, 10}),
    frozenset({8, 1, 2, 11}),
    frozenset({1, 2, 10, 9}),
    frozenset({1, 2, 11, 9}),
    frozenset({11, 1, 2, 10}),
    frozenset({1, 3, 4, 5}),
    frozenset({1, 3, 4, 6}),
    frozenset({1, 3, 4, 7}),
    frozenset({8, 1, 3, 4}),
    frozenset({1, 3, 4, 9}),
    frozenset({1, 10, 3, 4}),
    frozenset({11, 1, 3, 4}),
    frozenset({1, 3, 5, 6}),
    frozenset({1, 3, 5, 7}),
    frozenset({8, 1, 3, 5}),
    frozenset({1, 3, 5, 9}),
    frozenset({1, 10, 3, 5}),
    frozenset({11, 1, 3, 5}),
    frozenset({1, 3, 6, 7}),
    frozenset({8, 1, 3, 6}),
    frozenset({1, 3, 6, 9}),
    frozenset({1, 10, 3, 6}),
    frozenset({11, 1, 3, 6}),
    frozenset({8, 1, 3, 7}),
    frozenset({1, 3, 9, 7}),
    frozenset({1, 10, 3, 7}),
    frozenset({11, 1, 3, 7}),
    frozenset({8, 1, 3, 9}),
    frozenset({8, 1, 10, 3}),
    frozenset({8, 1, 3, 11}),
    frozenset({1, 10, 3, 9}),
    frozenset({11, 1, 3, 9}),
    frozenset({11, 1, 10, 3}),
    frozenset({1, 4, 5, 6}),
    frozenset({1, 4, 5, 7}),
    frozenset({8, 1, 4, 5}),
    frozenset({1, 4, 5, 9}),
    frozenset({1, 10, 4, 5}),
    frozenset({1, 11, 4, 5}),
    frozenset({1, 4, 6, 7}),
    frozenset({8, 1, 4, 6}),
    frozenset({1, 4, 6, 9}),
    frozenset({1, 10, 4, 6}),
    frozenset({1, 11, 4, 6}),
    frozenset({8, 1, 4, 7}),
    frozenset({1, 4, 9, 7}),
    frozenset({1, 10, 4, 7}),
    frozenset({1, 11, 4, 7}),
    frozenset({8, 1, 4, 9}),
    frozenset({8, 1, 10, 4}),
    frozenset({8, 1, 11, 4}),
    frozenset({1, 10, 4, 9}),
    frozenset({1, 11, 4, 9}),
    frozenset({1, 10, 11, 4}),
    frozenset({1, 5, 6, 7}),
    frozenset({8, 1, 5, 6}),
    frozenset({1, 5, 6, 9}),
    frozenset({1, 10, 5, 6}),
    frozenset({1, 11, 5, 6}),
    frozenset({8, 1, 5, 7}),
    frozenset({1, 5, 9, 7}),
    frozenset({1, 10, 5, 7}),
    frozenset({1, 11, 5, 7}),
    frozenset({8, 1, 5, 9}),
    frozenset({8, 1, 10, 5}),
    frozenset({8, 1, 11, 5}),
    frozenset({1, 10, 5, 9}),
    frozenset({1, 11, 5, 9}),
    frozenset({1, 10, 11, 5}),
    frozenset({8, 1, 6, 7}),
    frozenset({1, 9, 6, 7}),
    frozenset({1, 10, 6, 7}),
    frozenset({1, 11, 6, 7}),
    frozenset({8, 1, 6, 9}),
    frozenset({8, 1, 10, 6}),
    frozenset({8, 1, 11, 6}),
    frozenset({1, 10, 6, 9}),
    frozenset({1, 11, 6, 9}),
    frozenset({1, 10, 11, 6}),
    frozenset({8, 1, 9, 7}),
    frozenset({8, 1, 10, 7}),
    frozenset({8, 1, 11, 7}),
    frozenset({1, 10, 9, 7}),
    frozenset({1, 11, 9, 7}),
    frozenset({1, 10, 11, 7}),
    frozenset({8, 1, 10, 9}),
    frozenset({8, 1, 11, 9}),
    frozenset({8, 1, 10, 11}),
    frozenset({1, 10, 11, 9}),
    frozenset({2, 3, 4, 5}),
    frozenset({2, 3, 4, 6}),
    frozenset({2, 3, 4, 7}),
    frozenset({8, 2, 3, 4}),
    frozenset({9, 2, 3, 4}),
    frozenset({10, 2, 3, 4}),
    frozenset({11, 2, 3, 4}),
    frozenset({2, 3, 5, 6}),
    frozenset({2, 3, 5, 7}),
    frozenset({8, 2, 3, 5}),
    frozenset({9, 2, 3, 5}),
    frozenset({10, 2, 3, 5}),
    frozenset({11, 2, 3, 5}),
    frozenset({2, 3, 6, 7}),
    frozenset({8, 2, 3, 6}),
    frozenset({9, 2, 3, 6}),
    frozenset({10, 2, 3, 6}),
    frozenset({11, 2, 3, 6}),
    frozenset({8, 2, 3, 7}),
    frozenset({9, 2, 3, 7}),
    frozenset({10, 2, 3, 7}),
    frozenset({11, 2, 3, 7}),
    frozenset({8, 9, 2, 3}),
    frozenset({8, 10, 2, 3}),
    frozenset({8, 11, 2, 3}),
    frozenset({10, 9, 2, 3}),
    frozenset({11, 9, 2, 3}),
    frozenset({10, 11, 2, 3}),
    frozenset({2, 4, 5, 6}),
    frozenset({2, 4, 5, 7}),
    frozenset({8, 2, 4, 5}),
    frozenset({9, 2, 4, 5}),
    frozenset({2, 10, 4, 5}),
    frozenset({2, 11, 4, 5}),
    frozenset({2, 4, 6, 7}),
    frozenset({8, 2, 4, 6}),
    frozenset({9, 2, 4, 6}),
    frozenset({2, 10, 4, 6}),
    frozenset({2, 11, 4, 6}),
    frozenset({8, 2, 4, 7}),
    frozenset({9, 2, 4, 7}),
    frozenset({2, 10, 4, 7}),
    frozenset({2, 11, 4, 7}),
    frozenset({8, 9, 2, 4}),
    frozenset({8, 2, 10, 4}),
    frozenset({8, 2, 11, 4}),
    frozenset({9, 2, 10, 4}),
    frozenset({9, 2, 11, 4}),
    frozenset({11, 2, 10, 4}),
    frozenset({2, 5, 6, 7}),
    frozenset({8, 2, 5, 6}),
    frozenset({9, 2, 5, 6}),
    frozenset({2, 10, 5, 6}),
    frozenset({2, 11, 5, 6}),
    frozenset({8, 2, 5, 7}),
    frozenset({9, 2, 5, 7}),
    frozenset({2, 10, 5, 7}),
    frozenset({2, 11, 5, 7}),
    frozenset({8, 9, 2, 5}),
    frozenset({8, 2, 10, 5}),
    frozenset({8, 2, 11, 5}),
    frozenset({9, 2, 10, 5}),
    frozenset({9, 2, 11, 5}),
    frozenset({11, 2, 10, 5}),
    frozenset({8, 2, 6, 7}),
    frozenset({9, 2, 6, 7}),
    frozenset({2, 10, 6, 7}),
    frozenset({2, 11, 6, 7}),
    frozenset({8, 9, 2, 6}),
    frozenset({8, 2, 10, 6}),
    frozenset({8, 2, 11, 6}),
    frozenset({9, 2, 10, 6}),
    frozenset({9, 2, 11, 6}),
    frozenset({11, 2, 10, 6}),
    frozenset({8, 9, 2, 7}),
    frozenset({8, 2, 10, 7}),
    frozenset({8, 2, 11, 7}),
    frozenset({9, 2, 10, 7}),
    frozenset({9, 2, 11, 7}),
    frozenset({11, 2, 10, 7}),
    frozenset({8, 9, 2, 10}),
    frozenset({8, 9, 2, 11}),
    frozenset({8, 11, 2, 10}),
    frozenset({11, 9, 2, 10}),
    frozenset({3, 4, 5, 6}),
    frozenset({3, 4, 5, 7}),
    frozenset({8, 3, 4, 5}),
    frozenset({9, 3, 4, 5}),
    frozenset({10, 3, 4, 5}),
    frozenset({11, 3, 4, 5}),
    frozenset({3, 4, 6, 7}),
    frozenset({8, 3, 4, 6}),
    frozenset({9, 3, 4, 6}),
    frozenset({10, 3, 4, 6}),
    frozenset({11, 3, 4, 6}),
    frozenset({8, 3, 4, 7}),
    frozenset({9, 3, 4, 7}),
    frozenset({10, 3, 4, 7}),
    frozenset({11, 3, 4, 7}),
    frozenset({8, 9, 3, 4}),
    frozenset({8, 10, 3, 4}),
    frozenset({8, 11, 3, 4}),
    frozenset({9, 10, 3, 4}),
    frozenset({11, 9, 3, 4}),
    frozenset({11, 10, 3, 4}),
    frozenset({3, 5, 6, 7}),
    frozenset({8, 3, 5, 6}),
    frozenset({9, 3, 5, 6}),
    frozenset({10, 3, 5, 6}),
    frozenset({11, 3, 5, 6}),
    frozenset({8, 3, 5, 7}),
    frozenset({9, 3, 5, 7}),
    frozenset({10, 3, 5, 7}),
    frozenset({11, 3, 5, 7}),
    frozenset({8, 9, 3, 5}),
    frozenset({8, 10, 3, 5}),
    frozenset({8, 11, 3, 5}),
    frozenset({9, 10, 3, 5}),
    frozenset({11, 9, 3, 5}),
    frozenset({11, 10, 3, 5}),
    frozenset({8, 3, 6, 7}),
    frozenset({9, 3, 6, 7}),
    frozenset({10, 3, 6, 7}),
    frozenset({11, 3, 6, 7}),
    frozenset({8, 9, 3, 6}),
    frozenset({8, 10, 3, 6}),
    frozenset({8, 11, 3, 6}),
    frozenset({9, 10, 3, 6}),
    frozenset({11, 9, 3, 6}),
    frozenset({11, 10, 3, 6}),
    frozenset({8, 9, 3, 7}),
    frozenset({8, 10, 3, 7}),
    frozenset({8, 11, 3, 7}),
    frozenset({9, 10, 3, 7}),
    frozenset({11, 9, 3, 7}),
    frozenset({11, 10, 3, 7}),
    frozenset({8, 9, 10, 3}),
    frozenset({8, 9, 3, 11}),
    frozenset({8, 11, 10, 3}),
    frozenset({11, 9, 10, 3}),
    frozenset({4, 5, 6, 7}),
    frozenset({8, 4, 5, 6}),
    frozenset({9, 4, 5, 6}),
    frozenset({10, 4, 5, 6}),
    frozenset({11, 4, 5, 6}),
    frozenset({8, 4, 5, 7}),
    frozenset({9, 4, 5, 7}),
    frozenset({10, 4, 5, 7}),
    frozenset({11, 4, 5, 7}),
    frozenset({8, 9, 4, 5}),
    frozenset({8, 10, 4, 5}),
    frozenset({8, 11, 4, 5}),
    frozenset({9, 10, 4, 5}),
    frozenset({9, 11, 4, 5}),
    frozenset({10, 11, 4, 5}),
    frozenset({8, 4, 6, 7}),
    frozenset({9, 4, 6, 7}),
    frozenset({10, 4, 6, 7}),
    frozenset({11, 4, 6, 7}),
    frozenset({8, 9, 4, 6}),
    frozenset({8, 10, 4, 6}),
    frozenset({8, 11, 4, 6}),
    frozenset({9, 10, 4, 6}),
    frozenset({9, 11, 4, 6}),
    frozenset({10, 11, 4, 6}),
    frozenset({8, 9, 4, 7}),
    frozenset({8, 10, 4, 7}),
    frozenset({8, 11, 4, 7}),
    frozenset({9, 10, 4, 7}),
    frozenset({9, 11, 4, 7}),
    frozenset({10, 11, 4, 7}),
    frozenset({8, 9, 10, 4}),
    frozenset({8, 9, 11, 4}),
    frozenset({8, 10, 11, 4}),
    frozenset({9, 10, 11, 4}),
    frozenset({8, 5, 6, 7}),
    frozenset({9, 5, 6, 7}),
    frozenset({10, 5, 6, 7}),
    frozenset({11, 5, 6, 7}),
    frozenset({8, 9, 5, 6}),
    frozenset({8, 10, 5, 6}),
    frozenset({8, 11, 5, 6}),
    frozenset({9, 10, 5, 6}),
    frozenset({9, 11, 5, 6}),
    frozenset({10, 11, 5, 6}),
    frozenset({8, 9, 5, 7}),
    frozenset({8, 10, 5, 7}),
    frozenset({8, 11, 5, 7}),
    frozenset({9, 10, 5, 7}),
    frozenset({9, 11, 5, 7}),
    frozenset({10, 11, 5, 7}),
    frozenset({8, 9, 10, 5}),
    frozenset({8, 9, 11, 5}),
    frozenset({8, 10, 11, 5}),
    frozenset({9, 10, 11, 5}),
    frozenset({8, 9, 6, 7}),
    frozenset({8, 10, 6, 7}),
    frozenset({8, 11, 6, 7}),
    frozenset({9, 10, 6, 7}),
    frozenset({9, 11, 6, 7}),
    frozenset({10, 11, 6, 7}),
    frozenset({8, 9, 10, 6}),
    frozenset({8, 9, 11, 6}),
    frozenset({8, 10, 11, 6}),
    frozenset({9, 10, 11, 6}),
    frozenset({8, 9, 10, 7}),
    frozenset({8, 9, 11, 7}),
    frozenset({8, 10, 11, 7}),
    frozenset({9, 10, 11, 7}),
    frozenset({8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4}),
    frozenset({0, 1, 2, 3, 5}),
    frozenset({0, 1, 2, 3, 6}),
    frozenset({0, 1, 2, 3, 7}),
    frozenset({0, 1, 2, 3, 8}),
    frozenset({0, 1, 2, 3, 9}),
    frozenset({0, 1, 2, 3, 10}),
    frozenset({0, 1, 2, 3, 11}),
    frozenset({0, 1, 2, 4, 5}),
    frozenset({0, 1, 2, 4, 6}),
    frozenset({0, 1, 2, 4, 7}),
    frozenset({0, 1, 2, 4, 8}),
    frozenset({0, 1, 2, 4, 9}),
    frozenset({0, 1, 2, 4, 10}),
    frozenset({0, 1, 2, 4, 11}),
    frozenset({0, 1, 2, 5, 6}),
    frozenset({0, 1, 2, 5, 7}),
    frozenset({0, 1, 2, 5, 8}),
    frozenset({0, 1, 2, 5, 9}),
    frozenset({0, 1, 2, 5, 10}),
    frozenset({0, 1, 2, 5, 11}),
    frozenset({0, 1, 2, 6, 7}),
    frozenset({0, 1, 2, 6, 8}),
    frozenset({0, 1, 2, 6, 9}),
    frozenset({0, 1, 2, 6, 10}),
    frozenset({0, 1, 2, 6, 11}),
    frozenset({0, 1, 2, 7, 8}),
    frozenset({0, 1, 2, 7, 9}),
    frozenset({0, 1, 2, 7, 10}),
    frozenset({0, 1, 2, 7, 11}),
    frozenset({0, 1, 2, 8, 9}),
    frozenset({0, 1, 2, 8, 10}),
    frozenset({0, 1, 2, 8, 11}),
    frozenset({0, 1, 2, 9, 10}),
    frozenset({0, 1, 2, 9, 11}),
    frozenset({0, 1, 2, 10, 11}),
    frozenset({0, 1, 3, 4, 5}),
    frozenset({0, 1, 3, 4, 6}),
    frozenset({0, 1, 3, 4, 7}),
    frozenset({0, 1, 3, 4, 8}),
    frozenset({0, 1, 3, 4, 9}),
    frozenset({0, 1, 3, 4, 10}),
    frozenset({0, 1, 3, 4, 11}),
    frozenset({0, 1, 3, 5, 6}),
    frozenset({0, 1, 3, 5, 7}),
    frozenset({0, 1, 3, 5, 8}),
    frozenset({0, 1, 3, 5, 9}),
    frozenset({0, 1, 3, 5, 10}),
    frozenset({0, 1, 3, 5, 11}),
    frozenset({0, 1, 3, 6, 7}),
    frozenset({0, 1, 3, 6, 8}),
    frozenset({0, 1, 3, 6, 9}),
    frozenset({0, 1, 3, 6, 10}),
    frozenset({0, 1, 3, 6, 11}),
    frozenset({0, 1, 3, 7, 8}),
    frozenset({0, 1, 3, 7, 9}),
    frozenset({0, 1, 3, 7, 10}),
    frozenset({0, 1, 3, 7, 11}),
    frozenset({0, 1, 3, 8, 9}),
    frozenset({0, 1, 3, 8, 10}),
    frozenset({0, 1, 3, 8, 11}),
    frozenset({0, 1, 3, 9, 10}),
    frozenset({0, 1, 3, 9, 11}),
    frozenset({0, 1, 3, 10, 11}),
    frozenset({0, 1, 4, 5, 6}),
    frozenset({0, 1, 4, 5, 7}),
    frozenset({0, 1, 4, 5, 8}),
    frozenset({0, 1, 4, 5, 9}),
    frozenset({0, 1, 4, 5, 10}),
    frozenset({0, 1, 4, 5, 11}),
    frozenset({0, 1, 4, 6, 7}),
    frozenset({0, 1, 4, 6, 8}),
    frozenset({0, 1, 4, 6, 9}),
    frozenset({0, 1, 4, 6, 10}),
    frozenset({0, 1, 4, 6, 11}),
    frozenset({0, 1, 4, 7, 8}),
    frozenset({0, 1, 4, 7, 9}),
    frozenset({0, 1, 4, 7, 10}),
    frozenset({0, 1, 4, 7, 11}),
    frozenset({0, 1, 4, 8, 9}),
    frozenset({0, 1, 4, 8, 10}),
    frozenset({0, 1, 4, 8, 11}),
    frozenset({0, 1, 4, 9, 10}),
    frozenset({0, 1, 4, 9, 11}),
    frozenset({0, 1, 4, 10, 11}),
    frozenset({0, 1, 5, 6, 7}),
    frozenset({0, 1, 5, 6, 8}),
    frozenset({0, 1, 5, 6, 9}),
    frozenset({0, 1, 5, 6, 10}),
    frozenset({0, 1, 5, 6, 11}),
    frozenset({0, 1, 5, 7, 8}),
    frozenset({0, 1, 5, 7, 9}),
    frozenset({0, 1, 5, 7, 10}),
    frozenset({0, 1, 5, 7, 11}),
    frozenset({0, 1, 5, 8, 9}),
    frozenset({0, 1, 5, 8, 10}),
    frozenset({0, 1, 5, 8, 11}),
    frozenset({0, 1, 5, 9, 10}),
    frozenset({0, 1, 5, 9, 11}),
    frozenset({0, 1, 5, 10, 11}),
    frozenset({0, 1, 6, 7, 8}),
    frozenset({0, 1, 6, 7, 9}),
    frozenset({0, 1, 6, 7, 10}),
    frozenset({0, 1, 6, 7, 11}),
    frozenset({0, 1, 6, 8, 9}),
    frozenset({0, 1, 6, 8, 10}),
    frozenset({0, 1, 6, 8, 11}),
    frozenset({0, 1, 6, 9, 10}),
    frozenset({0, 1, 6, 9, 11}),
    frozenset({0, 1, 6, 10, 11}),
    frozenset({0, 1, 7, 8, 9}),
    frozenset({0, 1, 7, 8, 10}),
    frozenset({0, 1, 7, 8, 11}),
    frozenset({0, 1, 7, 9, 10}),
    frozenset({0, 1, 7, 9, 11}),
    frozenset({0, 1, 7, 10, 11}),
    frozenset({0, 1, 8, 9, 10}),
    frozenset({0, 1, 8, 9, 11}),
    frozenset({0, 1, 8, 10, 11}),
    frozenset({0, 1, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 5}),
    frozenset({0, 2, 3, 4, 6}),
    frozenset({0, 2, 3, 4, 7}),
    frozenset({0, 2, 3, 4, 8}),
    frozenset({0, 2, 3, 4, 9}),
    frozenset({0, 2, 3, 4, 10}),
    frozenset({0, 2, 3, 4, 11}),
    frozenset({0, 2, 3, 5, 6}),
    frozenset({0, 2, 3, 5, 7}),
    frozenset({0, 2, 3, 5, 8}),
    frozenset({0, 2, 3, 5, 9}),
    frozenset({0, 2, 3, 5, 10}),
    frozenset({0, 2, 3, 5, 11}),
    frozenset({0, 2, 3, 6, 7}),
    frozenset({0, 2, 3, 6, 8}),
    frozenset({0, 2, 3, 6, 9}),
    frozenset({0, 2, 3, 6, 10}),
    frozenset({0, 2, 3, 6, 11}),
    frozenset({0, 2, 3, 7, 8}),
    frozenset({0, 2, 3, 7, 9}),
    frozenset({0, 2, 3, 7, 10}),
    frozenset({0, 2, 3, 7, 11}),
    frozenset({0, 2, 3, 8, 9}),
    frozenset({0, 2, 3, 8, 10}),
    frozenset({0, 2, 3, 8, 11}),
    frozenset({0, 2, 3, 9, 10}),
    frozenset({0, 2, 3, 9, 11}),
    frozenset({0, 2, 3, 10, 11}),
    frozenset({0, 2, 4, 5, 6}),
    frozenset({0, 2, 4, 5, 7}),
    frozenset({0, 2, 4, 5, 8}),
    frozenset({0, 2, 4, 5, 9}),
    frozenset({0, 2, 4, 5, 10}),
    frozenset({0, 2, 4, 5, 11}),
    frozenset({0, 2, 4, 6, 7}),
    frozenset({0, 2, 4, 6, 8}),
    frozenset({0, 2, 4, 6, 9}),
    frozenset({0, 2, 4, 6, 10}),
    frozenset({0, 2, 4, 6, 11}),
    frozenset({0, 2, 4, 7, 8}),
    frozenset({0, 2, 4, 7, 9}),
    frozenset({0, 2, 4, 7, 10}),
    frozenset({0, 2, 4, 7, 11}),
    frozenset({0, 2, 4, 8, 9}),
    frozenset({0, 2, 4, 8, 10}),
    frozenset({0, 2, 4, 8, 11}),
    frozenset({0, 2, 4, 9, 10}),
    frozenset({0, 2, 4, 9, 11}),
    frozenset({0, 2, 4, 10, 11}),
    frozenset({0, 2, 5, 6, 7}),
    frozenset({0, 2, 5, 6, 8}),
    frozenset({0, 2, 5, 6, 9}),
    frozenset({0, 2, 5, 6, 10}),
    frozenset({0, 2, 5, 6, 11}),
    frozenset({0, 2, 5, 7, 8}),
    frozenset({0, 2, 5, 7, 9}),
    frozenset({0, 2, 5, 7, 10}),
    frozenset({0, 2, 5, 7, 11}),
    frozenset({0, 2, 5, 8, 9}),
    frozenset({0, 2, 5, 8, 10}),
    frozenset({0, 2, 5, 8, 11}),
    frozenset({0, 2, 5, 9, 10}),
    frozenset({0, 2, 5, 9, 11}),
    frozenset({0, 2, 5, 10, 11}),
    frozenset({0, 2, 6, 7, 8}),
    frozenset({0, 2, 6, 7, 9}),
    frozenset({0, 2, 6, 7, 10}),
    frozenset({0, 2, 6, 7, 11}),
    frozenset({0, 2, 6, 8, 9}),
    frozenset({0, 2, 6, 8, 10}),
    frozenset({0, 2, 6, 8, 11}),
    frozenset({0, 2, 6, 9, 10}),
    frozenset({0, 2, 6, 9, 11}),
    frozenset({0, 2, 6, 10, 11}),
    frozenset({0, 2, 7, 8, 9}),
    frozenset({0, 2, 7, 8, 10}),
    frozenset({0, 2, 7, 8, 11}),
    frozenset({0, 2, 7, 9, 10}),
    frozenset({0, 2, 7, 9, 11}),
    frozenset({0, 2, 7, 10, 11}),
    frozenset({0, 2, 8, 9, 10}),
    frozenset({0, 2, 8, 9, 11}),
    frozenset({0, 2, 8, 10, 11}),
    frozenset({0, 2, 9, 10, 11}),
    frozenset({0, 3, 4, 5, 6}),
    frozenset({0, 3, 4, 5, 7}),
    frozenset({0, 3, 4, 5, 8}),
    frozenset({0, 3, 4, 5, 9}),
    frozenset({0, 3, 4, 5, 10}),
    frozenset({0, 3, 4, 5, 11}),
    frozenset({0, 3, 4, 6, 7}),
    frozenset({0, 3, 4, 6, 8}),
    frozenset({0, 3, 4, 6, 9}),
    frozenset({0, 3, 4, 6, 10}),
    frozenset({0, 3, 4, 6, 11}),
    frozenset({0, 3, 4, 7, 8}),
    frozenset({0, 3, 4, 7, 9}),
    frozenset({0, 3, 4, 7, 10}),
    frozenset({0, 3, 4, 7, 11}),
    frozenset({0, 3, 4, 8, 9}),
    frozenset({0, 3, 4, 8, 10}),
    frozenset({0, 3, 4, 8, 11}),
    frozenset({0, 3, 4, 9, 10}),
    frozenset({0, 3, 4, 9, 11}),
    frozenset({0, 3, 4, 10, 11}),
    frozenset({0, 3, 5, 6, 7}),
    frozenset({0, 3, 5, 6, 8}),
    frozenset({0, 3, 5, 6, 9}),
    frozenset({0, 3, 5, 6, 10}),
    frozenset({0, 3, 5, 6, 11}),
    frozenset({0, 3, 5, 7, 8}),
    frozenset({0, 3, 5, 7, 9}),
    frozenset({0, 3, 5, 7, 10}),
    frozenset({0, 3, 5, 7, 11}),
    frozenset({0, 3, 5, 8, 9}),
    frozenset({0, 3, 5, 8, 10}),
    frozenset({0, 3, 5, 8, 11}),
    frozenset({0, 3, 5, 9, 10}),
    frozenset({0, 3, 5, 9, 11}),
    frozenset({0, 3, 5, 10, 11}),
    frozenset({0, 3, 6, 7, 8}),
    frozenset({0, 3, 6, 7, 9}),
    frozenset({0, 3, 6, 7, 10}),
    frozenset({0, 3, 6, 7, 11}),
    frozenset({0, 3, 6, 8, 9}),
    frozenset({0, 3, 6, 8, 10}),
    frozenset({0, 3, 6, 8, 11}),
    frozenset({0, 3, 6, 9, 10}),
    frozenset({0, 3, 6, 9, 11}),
    frozenset({0, 3, 6, 10, 11}),
    frozenset({0, 3, 7, 8, 9}),
    frozenset({0, 3, 7, 8, 10}),
    frozenset({0, 3, 7, 8, 11}),
    frozenset({0, 3, 7, 9, 10}),
    frozenset({0, 3, 7, 9, 11}),
    frozenset({0, 3, 7, 10, 11}),
    frozenset({0, 3, 8, 9, 10}),
    frozenset({0, 3, 8, 9, 11}),
    frozenset({0, 3, 8, 10, 11}),
    frozenset({0, 3, 9, 10, 11}),
    frozenset({0, 4, 5, 6, 7}),
    frozenset({0, 4, 5, 6, 8}),
    frozenset({0, 4, 5, 6, 9}),
    frozenset({0, 4, 5, 6, 10}),
    frozenset({0, 4, 5, 6, 11}),
    frozenset({0, 4, 5, 7, 8}),
    frozenset({0, 4, 5, 7, 9}),
    frozenset({0, 4, 5, 7, 10}),
    frozenset({0, 4, 5, 7, 11}),
    frozenset({0, 4, 5, 8, 9}),
    frozenset({0, 4, 5, 8, 10}),
    frozenset({0, 4, 5, 8, 11}),
    frozenset({0, 4, 5, 9, 10}),
    frozenset({0, 4, 5, 9, 11}),
    frozenset({0, 4, 5, 10, 11}),
    frozenset({0, 4, 6, 7, 8}),
    frozenset({0, 4, 6, 7, 9}),
    frozenset({0, 4, 6, 7, 10}),
    frozenset({0, 4, 6, 7, 11}),
    frozenset({0, 4, 6, 8, 9}),
    frozenset({0, 4, 6, 8, 10}),
    frozenset({0, 4, 6, 8, 11}),
    frozenset({0, 4, 6, 9, 10}),
    frozenset({0, 4, 6, 9, 11}),
    frozenset({0, 4, 6, 10, 11}),
    frozenset({0, 4, 7, 8, 9}),
    frozenset({0, 4, 7, 8, 10}),
    frozenset({0, 4, 7, 8, 11}),
    frozenset({0, 4, 7, 9, 10}),
    frozenset({0, 4, 7, 9, 11}),
    frozenset({0, 4, 7, 10, 11}),
    frozenset({0, 4, 8, 9, 10}),
    frozenset({0, 4, 8, 9, 11}),
    frozenset({0, 4, 8, 10, 11}),
    frozenset({0, 4, 9, 10, 11}),
    frozenset({0, 5, 6, 7, 8}),
    frozenset({0, 5, 6, 7, 9}),
    frozenset({0, 5, 6, 7, 10}),
    frozenset({0, 5, 6, 7, 11}),
    frozenset({0, 5, 6, 8, 9}),
    frozenset({0, 5, 6, 8, 10}),
    frozenset({0, 5, 6, 8, 11}),
    frozenset({0, 5, 6, 9, 10}),
    frozenset({0, 5, 6, 9, 11}),
    frozenset({0, 5, 6, 10, 11}),
    frozenset({0, 5, 7, 8, 9}),
    frozenset({0, 5, 7, 8, 10}),
    frozenset({0, 5, 7, 8, 11}),
    frozenset({0, 5, 7, 9, 10}),
    frozenset({0, 5, 7, 9, 11}),
    frozenset({0, 5, 7, 10, 11}),
    frozenset({0, 5, 8, 9, 10}),
    frozenset({0, 5, 8, 9, 11}),
    frozenset({0, 5, 8, 10, 11}),
    frozenset({0, 5, 9, 10, 11}),
    frozenset({0, 6, 7, 8, 9}),
    frozenset({0, 6, 7, 8, 10}),
    frozenset({0, 6, 7, 8, 11}),
    frozenset({0, 6, 7, 9, 10}),
    frozenset({0, 6, 7, 9, 11}),
    frozenset({0, 6, 7, 10, 11}),
    frozenset({0, 6, 8, 9, 10}),
    frozenset({0, 6, 8, 9, 11}),
    frozenset({0, 6, 8, 10, 11}),
    frozenset({0, 6, 9, 10, 11}),
    frozenset({0, 7, 8, 9, 10}),
    frozenset({0, 7, 8, 9, 11}),
    frozenset({0, 7, 8, 10, 11}),
    frozenset({0, 7, 9, 10, 11}),
    frozenset({0, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 5}),
    frozenset({1, 2, 3, 4, 6}),
    frozenset({1, 2, 3, 4, 7}),
    frozenset({1, 2, 3, 4, 8}),
    frozenset({1, 2, 3, 4, 9}),
    frozenset({1, 2, 3, 4, 10}),
    frozenset({1, 2, 3, 4, 11}),
    frozenset({1, 2, 3, 5, 6}),
    frozenset({1, 2, 3, 5, 7}),
    frozenset({1, 2, 3, 5, 8}),
    frozenset({1, 2, 3, 5, 9}),
    frozenset({1, 2, 3, 5, 10}),
    frozenset({1, 2, 3, 5, 11}),
    frozenset({1, 2, 3, 6, 7}),
    frozenset({1, 2, 3, 6, 8}),
    frozenset({1, 2, 3, 6, 9}),
    frozenset({1, 2, 3, 6, 10}),
    frozenset({1, 2, 3, 6, 11}),
    frozenset({1, 2, 3, 7, 8}),
    frozenset({1, 2, 3, 7, 9}),
    frozenset({1, 2, 3, 7, 10}),
    frozenset({1, 2, 3, 7, 11}),
    frozenset({1, 2, 3, 8, 9}),
    frozenset({1, 2, 3, 8, 10}),
    frozenset({1, 2, 3, 8, 11}),
    frozenset({1, 2, 3, 9, 10}),
    frozenset({1, 2, 3, 9, 11}),
    frozenset({1, 2, 3, 10, 11}),
    frozenset({1, 2, 4, 5, 6}),
    frozenset({1, 2, 4, 5, 7}),
    frozenset({1, 2, 4, 5, 8}),
    frozenset({1, 2, 4, 5, 9}),
    frozenset({1, 2, 4, 5, 10}),
    frozenset({1, 2, 4, 5, 11}),
    frozenset({1, 2, 4, 6, 7}),
    frozenset({1, 2, 4, 6, 8}),
    frozenset({1, 2, 4, 6, 9}),
    frozenset({1, 2, 4, 6, 10}),
    frozenset({1, 2, 4, 6, 11}),
    frozenset({1, 2, 4, 7, 8}),
    frozenset({1, 2, 4, 7, 9}),
    frozenset({1, 2, 4, 7, 10}),
    frozenset({1, 2, 4, 7, 11}),
    frozenset({1, 2, 4, 8, 9}),
    frozenset({1, 2, 4, 8, 10}),
    frozenset({1, 2, 4, 8, 11}),
    frozenset({1, 2, 4, 9, 10}),
    frozenset({1, 2, 4, 9, 11}),
    frozenset({1, 2, 4, 10, 11}),
    frozenset({1, 2, 5, 6, 7}),
    frozenset({1, 2, 5, 6, 8}),
    frozenset({1, 2, 5, 6, 9}),
    frozenset({1, 2, 5, 6, 10}),
    frozenset({1, 2, 5, 6, 11}),
    frozenset({1, 2, 5, 7, 8}),
    frozenset({1, 2, 5, 7, 9}),
    frozenset({1, 2, 5, 7, 10}),
    frozenset({1, 2, 5, 7, 11}),
    frozenset({1, 2, 5, 8, 9}),
    frozenset({1, 2, 5, 8, 10}),
    frozenset({1, 2, 5, 8, 11}),
    frozenset({1, 2, 5, 9, 10}),
    frozenset({1, 2, 5, 9, 11}),
    frozenset({1, 2, 5, 10, 11}),
    frozenset({1, 2, 6, 7, 8}),
    frozenset({1, 2, 6, 7, 9}),
    frozenset({1, 2, 6, 7, 10}),
    frozenset({1, 2, 6, 7, 11}),
    frozenset({1, 2, 6, 8, 9}),
    frozenset({1, 2, 6, 8, 10}),
    frozenset({1, 2, 6, 8, 11}),
    frozenset({1, 2, 6, 9, 10}),
    frozenset({1, 2, 6, 9, 11}),
    frozenset({1, 2, 6, 10, 11}),
    frozenset({1, 2, 7, 8, 9}),
    frozenset({1, 2, 7, 8, 10}),
    frozenset({1, 2, 7, 8, 11}),
    frozenset({1, 2, 7, 9, 10}),
    frozenset({1, 2, 7, 9, 11}),
    frozenset({1, 2, 7, 10, 11}),
    frozenset({1, 2, 8, 9, 10}),
    frozenset({1, 2, 8, 9, 11}),
    frozenset({1, 2, 8, 10, 11}),
    frozenset({1, 2, 9, 10, 11}),
    frozenset({1, 3, 4, 5, 6}),
    frozenset({1, 3, 4, 5, 7}),
    frozenset({1, 3, 4, 5, 8}),
    frozenset({1, 3, 4, 5, 9}),
    frozenset({1, 3, 4, 5, 10}),
    frozenset({1, 3, 4, 5, 11}),
    frozenset({1, 3, 4, 6, 7}),
    frozenset({1, 3, 4, 6, 8}),
    frozenset({1, 3, 4, 6, 9}),
    frozenset({1, 3, 4, 6, 10}),
    frozenset({1, 3, 4, 6, 11}),
    frozenset({1, 3, 4, 7, 8}),
    frozenset({1, 3, 4, 7, 9}),
    frozenset({1, 3, 4, 7, 10}),
    frozenset({1, 3, 4, 7, 11}),
    frozenset({1, 3, 4, 8, 9}),
    frozenset({1, 3, 4, 8, 10}),
    frozenset({1, 3, 4, 8, 11}),
    frozenset({1, 3, 4, 9, 10}),
    frozenset({1, 3, 4, 9, 11}),
    frozenset({1, 3, 4, 10, 11}),
    frozenset({1, 3, 5, 6, 7}),
    frozenset({1, 3, 5, 6, 8}),
    frozenset({1, 3, 5, 6, 9}),
    frozenset({1, 3, 5, 6, 10}),
    frozenset({1, 3, 5, 6, 11}),
    frozenset({1, 3, 5, 7, 8}),
    frozenset({1, 3, 5, 7, 9}),
    frozenset({1, 3, 5, 7, 10}),
    frozenset({1, 3, 5, 7, 11}),
    frozenset({1, 3, 5, 8, 9}),
    frozenset({1, 3, 5, 8, 10}),
    frozenset({1, 3, 5, 8, 11}),
    frozenset({1, 3, 5, 9, 10}),
    frozenset({1, 3, 5, 9, 11}),
    frozenset({1, 3, 5, 10, 11}),
    frozenset({1, 3, 6, 7, 8}),
    frozenset({1, 3, 6, 7, 9}),
    frozenset({1, 3, 6, 7, 10}),
    frozenset({1, 3, 6, 7, 11}),
    frozenset({1, 3, 6, 8, 9}),
    frozenset({1, 3, 6, 8, 10}),
    frozenset({1, 3, 6, 8, 11}),
    frozenset({1, 3, 6, 9, 10}),
    frozenset({1, 3, 6, 9, 11}),
    frozenset({1, 3, 6, 10, 11}),
    frozenset({1, 3, 7, 8, 9}),
    frozenset({1, 3, 7, 8, 10}),
    frozenset({1, 3, 7, 8, 11}),
    frozenset({1, 3, 7, 9, 10}),
    frozenset({1, 3, 7, 9, 11}),
    frozenset({1, 3, 7, 10, 11}),
    frozenset({1, 3, 8, 9, 10}),
    frozenset({1, 3, 8, 9, 11}),
    frozenset({1, 3, 8, 10, 11}),
    frozenset({1, 3, 9, 10, 11}),
    frozenset({1, 4, 5, 6, 7}),
    frozenset({1, 4, 5, 6, 8}),
    frozenset({1, 4, 5, 6, 9}),
    frozenset({1, 4, 5, 6, 10}),
    frozenset({1, 4, 5, 6, 11}),
    frozenset({1, 4, 5, 7, 8}),
    frozenset({1, 4, 5, 7, 9}),
    frozenset({1, 4, 5, 7, 10}),
    frozenset({1, 4, 5, 7, 11}),
    frozenset({1, 4, 5, 8, 9}),
    frozenset({1, 4, 5, 8, 10}),
    frozenset({1, 4, 5, 8, 11}),
    frozenset({1, 4, 5, 9, 10}),
    frozenset({1, 4, 5, 9, 11}),
    frozenset({1, 4, 5, 10, 11}),
    frozenset({1, 4, 6, 7, 8}),
    frozenset({1, 4, 6, 7, 9}),
    frozenset({1, 4, 6, 7, 10}),
    frozenset({1, 4, 6, 7, 11}),
    frozenset({1, 4, 6, 8, 9}),
    frozenset({1, 4, 6, 8, 10}),
    frozenset({1, 4, 6, 8, 11}),
    frozenset({1, 4, 6, 9, 10}),
    frozenset({1, 4, 6, 9, 11}),
    frozenset({1, 4, 6, 10, 11}),
    frozenset({1, 4, 7, 8, 9}),
    frozenset({1, 4, 7, 8, 10}),
    frozenset({1, 4, 7, 8, 11}),
    frozenset({1, 4, 7, 9, 10}),
    frozenset({1, 4, 7, 9, 11}),
    frozenset({1, 4, 7, 10, 11}),
    frozenset({1, 4, 8, 9, 10}),
    frozenset({1, 4, 8, 9, 11}),
    frozenset({1, 4, 8, 10, 11}),
    frozenset({1, 4, 9, 10, 11}),
    frozenset({1, 5, 6, 7, 8}),
    frozenset({1, 5, 6, 7, 9}),
    frozenset({1, 5, 6, 7, 10}),
    frozenset({1, 5, 6, 7, 11}),
    frozenset({1, 5, 6, 8, 9}),
    frozenset({1, 5, 6, 8, 10}),
    frozenset({1, 5, 6, 8, 11}),
    frozenset({1, 5, 6, 9, 10}),
    frozenset({1, 5, 6, 9, 11}),
    frozenset({1, 5, 6, 10, 11}),
    frozenset({1, 5, 7, 8, 9}),
    frozenset({1, 5, 7, 8, 10}),
    frozenset({1, 5, 7, 8, 11}),
    frozenset({1, 5, 7, 9, 10}),
    frozenset({1, 5, 7, 9, 11}),
    frozenset({1, 5, 7, 10, 11}),
    frozenset({1, 5, 8, 9, 10}),
    frozenset({1, 5, 8, 9, 11}),
    frozenset({1, 5, 8, 10, 11}),
    frozenset({1, 5, 9, 10, 11}),
    frozenset({1, 6, 7, 8, 9}),
    frozenset({1, 6, 7, 8, 10}),
    frozenset({1, 6, 7, 8, 11}),
    frozenset({1, 6, 7, 9, 10}),
    frozenset({1, 6, 7, 9, 11}),
    frozenset({1, 6, 7, 10, 11}),
    frozenset({1, 6, 8, 9, 10}),
    frozenset({1, 6, 8, 9, 11}),
    frozenset({1, 6, 8, 10, 11}),
    frozenset({1, 6, 9, 10, 11}),
    frozenset({1, 7, 8, 9, 10}),
    frozenset({1, 7, 8, 9, 11}),
    frozenset({1, 7, 8, 10, 11}),
    frozenset({1, 7, 9, 10, 11}),
    frozenset({1, 8, 9, 10, 11}),
    frozenset({2, 3, 4, 5, 6}),
    frozenset({2, 3, 4, 5, 7}),
    frozenset({2, 3, 4, 5, 8}),
    frozenset({2, 3, 4, 5, 9}),
    frozenset({2, 3, 4, 5, 10}),
    frozenset({2, 3, 4, 5, 11}),
    frozenset({2, 3, 4, 6, 7}),
    frozenset({2, 3, 4, 6, 8}),
    frozenset({2, 3, 4, 6, 9}),
    frozenset({2, 3, 4, 6, 10}),
    frozenset({2, 3, 4, 6, 11}),
    frozenset({2, 3, 4, 7, 8}),
    frozenset({2, 3, 4, 7, 9}),
    frozenset({2, 3, 4, 7, 10}),
    frozenset({2, 3, 4, 7, 11}),
    frozenset({2, 3, 4, 8, 9}),
    frozenset({2, 3, 4, 8, 10}),
    frozenset({2, 3, 4, 8, 11}),
    frozenset({2, 3, 4, 9, 10}),
    frozenset({2, 3, 4, 9, 11}),
    frozenset({2, 3, 4, 10, 11}),
    frozenset({2, 3, 5, 6, 7}),
    frozenset({2, 3, 5, 6, 8}),
    frozenset({2, 3, 5, 6, 9}),
    frozenset({2, 3, 5, 6, 10}),
    frozenset({2, 3, 5, 6, 11}),
    frozenset({2, 3, 5, 7, 8}),
    frozenset({2, 3, 5, 7, 9}),
    frozenset({2, 3, 5, 7, 10}),
    frozenset({2, 3, 5, 7, 11}),
    frozenset({2, 3, 5, 8, 9}),
    frozenset({2, 3, 5, 8, 10}),
    frozenset({2, 3, 5, 8, 11}),
    frozenset({2, 3, 5, 9, 10}),
    frozenset({2, 3, 5, 9, 11}),
    frozenset({2, 3, 5, 10, 11}),
    frozenset({2, 3, 6, 7, 8}),
    frozenset({2, 3, 6, 7, 9}),
    frozenset({2, 3, 6, 7, 10}),
    frozenset({2, 3, 6, 7, 11}),
    frozenset({2, 3, 6, 8, 9}),
    frozenset({2, 3, 6, 8, 10}),
    frozenset({2, 3, 6, 8, 11}),
    frozenset({2, 3, 6, 9, 10}),
    frozenset({2, 3, 6, 9, 11}),
    frozenset({2, 3, 6, 10, 11}),
    frozenset({2, 3, 7, 8, 9}),
    frozenset({2, 3, 7, 8, 10}),
    frozenset({2, 3, 7, 8, 11}),
    frozenset({2, 3, 7, 9, 10}),
    frozenset({2, 3, 7, 9, 11}),
    frozenset({2, 3, 7, 10, 11}),
    frozenset({2, 3, 8, 9, 10}),
    frozenset({2, 3, 8, 9, 11}),
    frozenset({2, 3, 8, 10, 11}),
    frozenset({2, 3, 9, 10, 11}),
    frozenset({2, 4, 5, 6, 7}),
    frozenset({2, 4, 5, 6, 8}),
    frozenset({2, 4, 5, 6, 9}),
    frozenset({2, 4, 5, 6, 10}),
    frozenset({2, 4, 5, 6, 11}),
    frozenset({2, 4, 5, 7, 8}),
    frozenset({2, 4, 5, 7, 9}),
    frozenset({2, 4, 5, 7, 10}),
    frozenset({2, 4, 5, 7, 11}),
    frozenset({2, 4, 5, 8, 9}),
    frozenset({2, 4, 5, 8, 10}),
    frozenset({2, 4, 5, 8, 11}),
    frozenset({2, 4, 5, 9, 10}),
    frozenset({2, 4, 5, 9, 11}),
    frozenset({2, 4, 5, 10, 11}),
    frozenset({2, 4, 6, 7, 8}),
    frozenset({2, 4, 6, 7, 9}),
    frozenset({2, 4, 6, 7, 10}),
    frozenset({2, 4, 6, 7, 11}),
    frozenset({2, 4, 6, 8, 9}),
    frozenset({2, 4, 6, 8, 10}),
    frozenset({2, 4, 6, 8, 11}),
    frozenset({2, 4, 6, 9, 10}),
    frozenset({2, 4, 6, 9, 11}),
    frozenset({2, 4, 6, 10, 11}),
    frozenset({2, 4, 7, 8, 9}),
    frozenset({2, 4, 7, 8, 10}),
    frozenset({2, 4, 7, 8, 11}),
    frozenset({2, 4, 7, 9, 10}),
    frozenset({2, 4, 7, 9, 11}),
    frozenset({2, 4, 7, 10, 11}),
    frozenset({2, 4, 8, 9, 10}),
    frozenset({2, 4, 8, 9, 11}),
    frozenset({2, 4, 8, 10, 11}),
    frozenset({2, 4, 9, 10, 11}),
    frozenset({2, 5, 6, 7, 8}),
    frozenset({2, 5, 6, 7, 9}),
    frozenset({2, 5, 6, 7, 10}),
    frozenset({2, 5, 6, 7, 11}),
    frozenset({2, 5, 6, 8, 9}),
    frozenset({2, 5, 6, 8, 10}),
    frozenset({2, 5, 6, 8, 11}),
    frozenset({2, 5, 6, 9, 10}),
    frozenset({2, 5, 6, 9, 11}),
    frozenset({2, 5, 6, 10, 11}),
    frozenset({2, 5, 7, 8, 9}),
    frozenset({2, 5, 7, 8, 10}),
    frozenset({2, 5, 7, 8, 11}),
    frozenset({2, 5, 7, 9, 10}),
    frozenset({2, 5, 7, 9, 11}),
    frozenset({2, 5, 7, 10, 11}),
    frozenset({2, 5, 8, 9, 10}),
    frozenset({2, 5, 8, 9, 11}),
    frozenset({2, 5, 8, 10, 11}),
    frozenset({2, 5, 9, 10, 11}),
    frozenset({2, 6, 7, 8, 9}),
    frozenset({2, 6, 7, 8, 10}),
    frozenset({2, 6, 7, 8, 11}),
    frozenset({2, 6, 7, 9, 10}),
    frozenset({2, 6, 7, 9, 11}),
    frozenset({2, 6, 7, 10, 11}),
    frozenset({2, 6, 8, 9, 10}),
    frozenset({2, 6, 8, 9, 11}),
    frozenset({2, 6, 8, 10, 11}),
    frozenset({2, 6, 9, 10, 11}),
    frozenset({2, 7, 8, 9, 10}),
    frozenset({2, 7, 8, 9, 11}),
    frozenset({2, 7, 8, 10, 11}),
    frozenset({2, 7, 9, 10, 11}),
    frozenset({2, 8, 9, 10, 11}),
    frozenset({3, 4, 5, 6, 7}),
    frozenset({3, 4, 5, 6, 8}),
    frozenset({3, 4, 5, 6, 9}),
    frozenset({3, 4, 5, 6, 10}),
    frozenset({3, 4, 5, 6, 11}),
    frozenset({3, 4, 5, 7, 8}),
    frozenset({3, 4, 5, 7, 9}),
    frozenset({3, 4, 5, 7, 10}),
    frozenset({3, 4, 5, 7, 11}),
    frozenset({3, 4, 5, 8, 9}),
    frozenset({3, 4, 5, 8, 10}),
    frozenset({3, 4, 5, 8, 11}),
    frozenset({3, 4, 5, 9, 10}),
    frozenset({3, 4, 5, 9, 11}),
    frozenset({3, 4, 5, 10, 11}),
    frozenset({3, 4, 6, 7, 8}),
    frozenset({3, 4, 6, 7, 9}),
    frozenset({3, 4, 6, 7, 10}),
    frozenset({3, 4, 6, 7, 11}),
    frozenset({3, 4, 6, 8, 9}),
    frozenset({3, 4, 6, 8, 10}),
    frozenset({3, 4, 6, 8, 11}),
    frozenset({3, 4, 6, 9, 10}),
    frozenset({3, 4, 6, 9, 11}),
    frozenset({3, 4, 6, 10, 11}),
    frozenset({3, 4, 7, 8, 9}),
    frozenset({3, 4, 7, 8, 10}),
    frozenset({3, 4, 7, 8, 11}),
    frozenset({3, 4, 7, 9, 10}),
    frozenset({3, 4, 7, 9, 11}),
    frozenset({3, 4, 7, 10, 11}),
    frozenset({3, 4, 8, 9, 10}),
    frozenset({3, 4, 8, 9, 11}),
    frozenset({3, 4, 8, 10, 11}),
    frozenset({3, 4, 9, 10, 11}),
    frozenset({3, 5, 6, 7, 8}),
    frozenset({3, 5, 6, 7, 9}),
    frozenset({3, 5, 6, 7, 10}),
    frozenset({3, 5, 6, 7, 11}),
    frozenset({3, 5, 6, 8, 9}),
    frozenset({3, 5, 6, 8, 10}),
    frozenset({3, 5, 6, 8, 11}),
    frozenset({3, 5, 6, 9, 10}),
    frozenset({3, 5, 6, 9, 11}),
    frozenset({3, 5, 6, 10, 11}),
    frozenset({3, 5, 7, 8, 9}),
    frozenset({3, 5, 7, 8, 10}),
    frozenset({3, 5, 7, 8, 11}),
    frozenset({3, 5, 7, 9, 10}),
    frozenset({3, 5, 7, 9, 11}),
    frozenset({3, 5, 7, 10, 11}),
    frozenset({3, 5, 8, 9, 10}),
    frozenset({3, 5, 8, 9, 11}),
    frozenset({3, 5, 8, 10, 11}),
    frozenset({3, 5, 9, 10, 11}),
    frozenset({3, 6, 7, 8, 9}),
    frozenset({3, 6, 7, 8, 10}),
    frozenset({3, 6, 7, 8, 11}),
    frozenset({3, 6, 7, 9, 10}),
    frozenset({3, 6, 7, 9, 11}),
    frozenset({3, 6, 7, 10, 11}),
    frozenset({3, 6, 8, 9, 10}),
    frozenset({3, 6, 8, 9, 11}),
    frozenset({3, 6, 8, 10, 11}),
    frozenset({3, 6, 9, 10, 11}),
    frozenset({3, 7, 8, 9, 10}),
    frozenset({3, 7, 8, 9, 11}),
    frozenset({3, 7, 8, 10, 11}),
    frozenset({3, 7, 9, 10, 11}),
    frozenset({3, 8, 9, 10, 11}),
    frozenset({4, 5, 6, 7, 8}),
    frozenset({4, 5, 6, 7, 9}),
    frozenset({4, 5, 6, 7, 10}),
    frozenset({4, 5, 6, 7, 11}),
    frozenset({4, 5, 6, 8, 9}),
    frozenset({4, 5, 6, 8, 10}),
    frozenset({4, 5, 6, 8, 11}),
    frozenset({4, 5, 6, 9, 10}),
    frozenset({4, 5, 6, 9, 11}),
    frozenset({4, 5, 6, 10, 11}),
    frozenset({4, 5, 7, 8, 9}),
    frozenset({4, 5, 7, 8, 10}),
    frozenset({4, 5, 7, 8, 11}),
    frozenset({4, 5, 7, 9, 10}),
    frozenset({4, 5, 7, 9, 11}),
    frozenset({4, 5, 7, 10, 11}),
    frozenset({4, 5, 8, 9, 10}),
    frozenset({4, 5, 8, 9, 11}),
    frozenset({4, 5, 8, 10, 11}),
    frozenset({4, 5, 9, 10, 11}),
    frozenset({4, 6, 7, 8, 9}),
    frozenset({4, 6, 7, 8, 10}),
    frozenset({4, 6, 7, 8, 11}),
    frozenset({4, 6, 7, 9, 10}),
    frozenset({4, 6, 7, 9, 11}),
    frozenset({4, 6, 7, 10, 11}),
    frozenset({4, 6, 8, 9, 10}),
    frozenset({4, 6, 8, 9, 11}),
    frozenset({4, 6, 8, 10, 11}),
    frozenset({4, 6, 9, 10, 11}),
    frozenset({4, 7, 8, 9, 10}),
    frozenset({4, 7, 8, 9, 11}),
    frozenset({4, 7, 8, 10, 11}),
    frozenset({4, 7, 9, 10, 11}),
    frozenset({4, 8, 9, 10, 11}),
    frozenset({5, 6, 7, 8, 9}),
    frozenset({5, 6, 7, 8, 10}),
    frozenset({5, 6, 7, 8, 11}),
    frozenset({5, 6, 7, 9, 10}),
    frozenset({5, 6, 7, 9, 11}),
    frozenset({5, 6, 7, 10, 11}),
    frozenset({5, 6, 8, 9, 10}),
    frozenset({5, 6, 8, 9, 11}),
    frozenset({5, 6, 8, 10, 11}),
    frozenset({5, 6, 9, 10, 11}),
    frozenset({5, 7, 8, 9, 10}),
    frozenset({5, 7, 8, 9, 11}),
    frozenset({5, 7, 8, 10, 11}),
    frozenset({5, 7, 9, 10, 11}),
    frozenset({5, 8, 9, 10, 11}),
    frozenset({6, 7, 8, 9, 10}),
    frozenset({6, 7, 8, 9, 11}),
    frozenset({6, 7, 8, 10, 11}),
    frozenset({6, 7, 9, 10, 11}),
    frozenset({6, 8, 9, 10, 11}),
    frozenset({7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5}),
    frozenset({0, 1, 2, 3, 4, 6}),
    frozenset({0, 1, 2, 3, 4, 7}),
    frozenset({0, 1, 2, 3, 4, 8}),
    frozenset({0, 1, 2, 3, 4, 9}),
    frozenset({0, 1, 2, 3, 4, 10}),
    frozenset({0, 1, 2, 3, 4, 11}),
    frozenset({0, 1, 2, 3, 5, 6}),
    frozenset({0, 1, 2, 3, 5, 7}),
    frozenset({0, 1, 2, 3, 5, 8}),
    frozenset({0, 1, 2, 3, 5, 9}),
    frozenset({0, 1, 2, 3, 5, 10}),
    frozenset({0, 1, 2, 3, 5, 11}),
    frozenset({0, 1, 2, 3, 6, 7}),
    frozenset({0, 1, 2, 3, 6, 8}),
    frozenset({0, 1, 2, 3, 6, 9}),
    frozenset({0, 1, 2, 3, 6, 10}),
    frozenset({0, 1, 2, 3, 6, 11}),
    frozenset({0, 1, 2, 3, 7, 8}),
    frozenset({0, 1, 2, 3, 7, 9}),
    frozenset({0, 1, 2, 3, 7, 10}),
    frozenset({0, 1, 2, 3, 7, 11}),
    frozenset({0, 1, 2, 3, 8, 9}),
    frozenset({0, 1, 2, 3, 8, 10}),
    frozenset({0, 1, 2, 3, 8, 11}),
    frozenset({0, 1, 2, 3, 9, 10}),
    frozenset({0, 1, 2, 3, 9, 11}),
    frozenset({0, 1, 2, 3, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 6}),
    frozenset({0, 1, 2, 4, 5, 7}),
    frozenset({0, 1, 2, 4, 5, 8}),
    frozenset({0, 1, 2, 4, 5, 9}),
    frozenset({0, 1, 2, 4, 5, 10}),
    frozenset({0, 1, 2, 4, 5, 11}),
    frozenset({0, 1, 2, 4, 6, 7}),
    frozenset({0, 1, 2, 4, 6, 8}),
    frozenset({0, 1, 2, 4, 6, 9}),
    frozenset({0, 1, 2, 4, 6, 10}),
    frozenset({0, 1, 2, 4, 6, 11}),
    frozenset({0, 1, 2, 4, 7, 8}),
    frozenset({0, 1, 2, 4, 7, 9}),
    frozenset({0, 1, 2, 4, 7, 10}),
    frozenset({0, 1, 2, 4, 7, 11}),
    frozenset({0, 1, 2, 4, 8, 9}),
    frozenset({0, 1, 2, 4, 8, 10}),
    frozenset({0, 1, 2, 4, 8, 11}),
    frozenset({0, 1, 2, 4, 9, 10}),
    frozenset({0, 1, 2, 4, 9, 11}),
    frozenset({0, 1, 2, 4, 10, 11}),
    frozenset({0, 1, 2, 5, 6, 7}),
    frozenset({0, 1, 2, 5, 6, 8}),
    frozenset({0, 1, 2, 5, 6, 9}),
    frozenset({0, 1, 2, 5, 6, 10}),
    frozenset({0, 1, 2, 5, 6, 11}),
    frozenset({0, 1, 2, 5, 7, 8}),
    frozenset({0, 1, 2, 5, 7, 9}),
    frozenset({0, 1, 2, 5, 7, 10}),
    frozenset({0, 1, 2, 5, 7, 11}),
    frozenset({0, 1, 2, 5, 8, 9}),
    frozenset({0, 1, 2, 5, 8, 10}),
    frozenset({0, 1, 2, 5, 8, 11}),
    frozenset({0, 1, 2, 5, 9, 10}),
    frozenset({0, 1, 2, 5, 9, 11}),
    frozenset({0, 1, 2, 5, 10, 11}),
    frozenset({0, 1, 2, 6, 7, 8}),
    frozenset({0, 1, 2, 6, 7, 9}),
    frozenset({0, 1, 2, 6, 7, 10}),
    frozenset({0, 1, 2, 6, 7, 11}),
    frozenset({0, 1, 2, 6, 8, 9}),
    frozenset({0, 1, 2, 6, 8, 10}),
    frozenset({0, 1, 2, 6, 8, 11}),
    frozenset({0, 1, 2, 6, 9, 10}),
    frozenset({0, 1, 2, 6, 9, 11}),
    frozenset({0, 1, 2, 6, 10, 11}),
    frozenset({0, 1, 2, 7, 8, 9}),
    frozenset({0, 1, 2, 7, 8, 10}),
    frozenset({0, 1, 2, 7, 8, 11}),
    frozenset({0, 1, 2, 7, 9, 10}),
    frozenset({0, 1, 2, 7, 9, 11}),
    frozenset({0, 1, 2, 7, 10, 11}),
    frozenset({0, 1, 2, 8, 9, 10}),
    frozenset({0, 1, 2, 8, 9, 11}),
    frozenset({0, 1, 2, 8, 10, 11}),
    frozenset({0, 1, 2, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 6}),
    frozenset({0, 1, 3, 4, 5, 7}),
    frozenset({0, 1, 3, 4, 5, 8}),
    frozenset({0, 1, 3, 4, 5, 9}),
    frozenset({0, 1, 3, 4, 5, 10}),
    frozenset({0, 1, 3, 4, 5, 11}),
    frozenset({0, 1, 3, 4, 6, 7}),
    frozenset({0, 1, 3, 4, 6, 8}),
    frozenset({0, 1, 3, 4, 6, 9}),
    frozenset({0, 1, 3, 4, 6, 10}),
    frozenset({0, 1, 3, 4, 6, 11}),
    frozenset({0, 1, 3, 4, 7, 8}),
    frozenset({0, 1, 3, 4, 7, 9}),
    frozenset({0, 1, 3, 4, 7, 10}),
    frozenset({0, 1, 3, 4, 7, 11}),
    frozenset({0, 1, 3, 4, 8, 9}),
    frozenset({0, 1, 3, 4, 8, 10}),
    frozenset({0, 1, 3, 4, 8, 11}),
    frozenset({0, 1, 3, 4, 9, 10}),
    frozenset({0, 1, 3, 4, 9, 11}),
    frozenset({0, 1, 3, 4, 10, 11}),
    frozenset({0, 1, 3, 5, 6, 7}),
    frozenset({0, 1, 3, 5, 6, 8}),
    frozenset({0, 1, 3, 5, 6, 9}),
    frozenset({0, 1, 3, 5, 6, 10}),
    frozenset({0, 1, 3, 5, 6, 11}),
    frozenset({0, 1, 3, 5, 7, 8}),
    frozenset({0, 1, 3, 5, 7, 9}),
    frozenset({0, 1, 3, 5, 7, 10}),
    frozenset({0, 1, 3, 5, 7, 11}),
    frozenset({0, 1, 3, 5, 8, 9}),
    frozenset({0, 1, 3, 5, 8, 10}),
    frozenset({0, 1, 3, 5, 8, 11}),
    frozenset({0, 1, 3, 5, 9, 10}),
    frozenset({0, 1, 3, 5, 9, 11}),
    frozenset({0, 1, 3, 5, 10, 11}),
    frozenset({0, 1, 3, 6, 7, 8}),
    frozenset({0, 1, 3, 6, 7, 9}),
    frozenset({0, 1, 3, 6, 7, 10}),
    frozenset({0, 1, 3, 6, 7, 11}),
    frozenset({0, 1, 3, 6, 8, 9}),
    frozenset({0, 1, 3, 6, 8, 10}),
    frozenset({0, 1, 3, 6, 8, 11}),
    frozenset({0, 1, 3, 6, 9, 10}),
    frozenset({0, 1, 3, 6, 9, 11}),
    frozenset({0, 1, 3, 6, 10, 11}),
    frozenset({0, 1, 3, 7, 8, 9}),
    frozenset({0, 1, 3, 7, 8, 10}),
    frozenset({0, 1, 3, 7, 8, 11}),
    frozenset({0, 1, 3, 7, 9, 10}),
    frozenset({0, 1, 3, 7, 9, 11}),
    frozenset({0, 1, 3, 7, 10, 11}),
    frozenset({0, 1, 3, 8, 9, 10}),
    frozenset({0, 1, 3, 8, 9, 11}),
    frozenset({0, 1, 3, 8, 10, 11}),
    frozenset({0, 1, 3, 9, 10, 11}),
    frozenset({0, 1, 4, 5, 6, 7}),
    frozenset({0, 1, 4, 5, 6, 8}),
    frozenset({0, 1, 4, 5, 6, 9}),
    frozenset({0, 1, 4, 5, 6, 10}),
    frozenset({0, 1, 4, 5, 6, 11}),
    frozenset({0, 1, 4, 5, 7, 8}),
    frozenset({0, 1, 4, 5, 7, 9}),
    frozenset({0, 1, 4, 5, 7, 10}),
    frozenset({0, 1, 4, 5, 7, 11}),
    frozenset({0, 1, 4, 5, 8, 9}),
    frozenset({0, 1, 4, 5, 8, 10}),
    frozenset({0, 1, 4, 5, 8, 11}),
    frozenset({0, 1, 4, 5, 9, 10}),
    frozenset({0, 1, 4, 5, 9, 11}),
    frozenset({0, 1, 4, 5, 10, 11}),
    frozenset({0, 1, 4, 6, 7, 8}),
    frozenset({0, 1, 4, 6, 7, 9}),
    frozenset({0, 1, 4, 6, 7, 10}),
    frozenset({0, 1, 4, 6, 7, 11}),
    frozenset({0, 1, 4, 6, 8, 9}),
    frozenset({0, 1, 4, 6, 8, 10}),
    frozenset({0, 1, 4, 6, 8, 11}),
    frozenset({0, 1, 4, 6, 9, 10}),
    frozenset({0, 1, 4, 6, 9, 11}),
    frozenset({0, 1, 4, 6, 10, 11}),
    frozenset({0, 1, 4, 7, 8, 9}),
    frozenset({0, 1, 4, 7, 8, 10}),
    frozenset({0, 1, 4, 7, 8, 11}),
    frozenset({0, 1, 4, 7, 9, 10}),
    frozenset({0, 1, 4, 7, 9, 11}),
    frozenset({0, 1, 4, 7, 10, 11}),
    frozenset({0, 1, 4, 8, 9, 10}),
    frozenset({0, 1, 4, 8, 9, 11}),
    frozenset({0, 1, 4, 8, 10, 11}),
    frozenset({0, 1, 4, 9, 10, 11}),
    frozenset({0, 1, 5, 6, 7, 8}),
    frozenset({0, 1, 5, 6, 7, 9}),
    frozenset({0, 1, 5, 6, 7, 10}),
    frozenset({0, 1, 5, 6, 7, 11}),
    frozenset({0, 1, 5, 6, 8, 9}),
    frozenset({0, 1, 5, 6, 8, 10}),
    frozenset({0, 1, 5, 6, 8, 11}),
    frozenset({0, 1, 5, 6, 9, 10}),
    frozenset({0, 1, 5, 6, 9, 11}),
    frozenset({0, 1, 5, 6, 10, 11}),
    frozenset({0, 1, 5, 7, 8, 9}),
    frozenset({0, 1, 5, 7, 8, 10}),
    frozenset({0, 1, 5, 7, 8, 11}),
    frozenset({0, 1, 5, 7, 9, 10}),
    frozenset({0, 1, 5, 7, 9, 11}),
    frozenset({0, 1, 5, 7, 10, 11}),
    frozenset({0, 1, 5, 8, 9, 10}),
    frozenset({0, 1, 5, 8, 9, 11}),
    frozenset({0, 1, 5, 8, 10, 11}),
    frozenset({0, 1, 5, 9, 10, 11}),
    frozenset({0, 1, 6, 7, 8, 9}),
    frozenset({0, 1, 6, 7, 8, 10}),
    frozenset({0, 1, 6, 7, 8, 11}),
    frozenset({0, 1, 6, 7, 9, 10}),
    frozenset({0, 1, 6, 7, 9, 11}),
    frozenset({0, 1, 6, 7, 10, 11}),
    frozenset({0, 1, 6, 8, 9, 10}),
    frozenset({0, 1, 6, 8, 9, 11}),
    frozenset({0, 1, 6, 8, 10, 11}),
    frozenset({0, 1, 6, 9, 10, 11}),
    frozenset({0, 1, 7, 8, 9, 10}),
    frozenset({0, 1, 7, 8, 9, 11}),
    frozenset({0, 1, 7, 8, 10, 11}),
    frozenset({0, 1, 7, 9, 10, 11}),
    frozenset({0, 1, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 6}),
    frozenset({0, 2, 3, 4, 5, 7}),
    frozenset({0, 2, 3, 4, 5, 8}),
    frozenset({0, 2, 3, 4, 5, 9}),
    frozenset({0, 2, 3, 4, 5, 10}),
    frozenset({0, 2, 3, 4, 5, 11}),
    frozenset({0, 2, 3, 4, 6, 7}),
    frozenset({0, 2, 3, 4, 6, 8}),
    frozenset({0, 2, 3, 4, 6, 9}),
    frozenset({0, 2, 3, 4, 6, 10}),
    frozenset({0, 2, 3, 4, 6, 11}),
    frozenset({0, 2, 3, 4, 7, 8}),
    frozenset({0, 2, 3, 4, 7, 9}),
    frozenset({0, 2, 3, 4, 7, 10}),
    frozenset({0, 2, 3, 4, 7, 11}),
    frozenset({0, 2, 3, 4, 8, 9}),
    frozenset({0, 2, 3, 4, 8, 10}),
    frozenset({0, 2, 3, 4, 8, 11}),
    frozenset({0, 2, 3, 4, 9, 10}),
    frozenset({0, 2, 3, 4, 9, 11}),
    frozenset({0, 2, 3, 4, 10, 11}),
    frozenset({0, 2, 3, 5, 6, 7}),
    frozenset({0, 2, 3, 5, 6, 8}),
    frozenset({0, 2, 3, 5, 6, 9}),
    frozenset({0, 2, 3, 5, 6, 10}),
    frozenset({0, 2, 3, 5, 6, 11}),
    frozenset({0, 2, 3, 5, 7, 8}),
    frozenset({0, 2, 3, 5, 7, 9}),
    frozenset({0, 2, 3, 5, 7, 10}),
    frozenset({0, 2, 3, 5, 7, 11}),
    frozenset({0, 2, 3, 5, 8, 9}),
    frozenset({0, 2, 3, 5, 8, 10}),
    frozenset({0, 2, 3, 5, 8, 11}),
    frozenset({0, 2, 3, 5, 9, 10}),
    frozenset({0, 2, 3, 5, 9, 11}),
    frozenset({0, 2, 3, 5, 10, 11}),
    frozenset({0, 2, 3, 6, 7, 8}),
    frozenset({0, 2, 3, 6, 7, 9}),
    frozenset({0, 2, 3, 6, 7, 10}),
    frozenset({0, 2, 3, 6, 7, 11}),
    frozenset({0, 2, 3, 6, 8, 9}),
    frozenset({0, 2, 3, 6, 8, 10}),
    frozenset({0, 2, 3, 6, 8, 11}),
    frozenset({0, 2, 3, 6, 9, 10}),
    frozenset({0, 2, 3, 6, 9, 11}),
    frozenset({0, 2, 3, 6, 10, 11}),
    frozenset({0, 2, 3, 7, 8, 9}),
    frozenset({0, 2, 3, 7, 8, 10}),
    frozenset({0, 2, 3, 7, 8, 11}),
    frozenset({0, 2, 3, 7, 9, 10}),
    frozenset({0, 2, 3, 7, 9, 11}),
    frozenset({0, 2, 3, 7, 10, 11}),
    frozenset({0, 2, 3, 8, 9, 10}),
    frozenset({0, 2, 3, 8, 9, 11}),
    frozenset({0, 2, 3, 8, 10, 11}),
    frozenset({0, 2, 3, 9, 10, 11}),
    frozenset({0, 2, 4, 5, 6, 7}),
    frozenset({0, 2, 4, 5, 6, 8}),
    frozenset({0, 2, 4, 5, 6, 9}),
    frozenset({0, 2, 4, 5, 6, 10}),
    frozenset({0, 2, 4, 5, 6, 11}),
    frozenset({0, 2, 4, 5, 7, 8}),
    frozenset({0, 2, 4, 5, 7, 9}),
    frozenset({0, 2, 4, 5, 7, 10}),
    frozenset({0, 2, 4, 5, 7, 11}),
    frozenset({0, 2, 4, 5, 8, 9}),
    frozenset({0, 2, 4, 5, 8, 10}),
    frozenset({0, 2, 4, 5, 8, 11}),
    frozenset({0, 2, 4, 5, 9, 10}),
    frozenset({0, 2, 4, 5, 9, 11}),
    frozenset({0, 2, 4, 5, 10, 11}),
    frozenset({0, 2, 4, 6, 7, 8}),
    frozenset({0, 2, 4, 6, 7, 9}),
    frozenset({0, 2, 4, 6, 7, 10}),
    frozenset({0, 2, 4, 6, 7, 11}),
    frozenset({0, 2, 4, 6, 8, 9}),
    frozenset({0, 2, 4, 6, 8, 10}),
    frozenset({0, 2, 4, 6, 8, 11}),
    frozenset({0, 2, 4, 6, 9, 10}),
    frozenset({0, 2, 4, 6, 9, 11}),
    frozenset({0, 2, 4, 6, 10, 11}),
    frozenset({0, 2, 4, 7, 8, 9}),
    frozenset({0, 2, 4, 7, 8, 10}),
    frozenset({0, 2, 4, 7, 8, 11}),
    frozenset({0, 2, 4, 7, 9, 10}),
    frozenset({0, 2, 4, 7, 9, 11}),
    frozenset({0, 2, 4, 7, 10, 11}),
    frozenset({0, 2, 4, 8, 9, 10}),
    frozenset({0, 2, 4, 8, 9, 11}),
    frozenset({0, 2, 4, 8, 10, 11}),
    frozenset({0, 2, 4, 9, 10, 11}),
    frozenset({0, 2, 5, 6, 7, 8}),
    frozenset({0, 2, 5, 6, 7, 9}),
    frozenset({0, 2, 5, 6, 7, 10}),
    frozenset({0, 2, 5, 6, 7, 11}),
    frozenset({0, 2, 5, 6, 8, 9}),
    frozenset({0, 2, 5, 6, 8, 10}),
    frozenset({0, 2, 5, 6, 8, 11}),
    frozenset({0, 2, 5, 6, 9, 10}),
    frozenset({0, 2, 5, 6, 9, 11}),
    frozenset({0, 2, 5, 6, 10, 11}),
    frozenset({0, 2, 5, 7, 8, 9}),
    frozenset({0, 2, 5, 7, 8, 10}),
    frozenset({0, 2, 5, 7, 8, 11}),
    frozenset({0, 2, 5, 7, 9, 10}),
    frozenset({0, 2, 5, 7, 9, 11}),
    frozenset({0, 2, 5, 7, 10, 11}),
    frozenset({0, 2, 5, 8, 9, 10}),
    frozenset({0, 2, 5, 8, 9, 11}),
    frozenset({0, 2, 5, 8, 10, 11}),
    frozenset({0, 2, 5, 9, 10, 11}),
    frozenset({0, 2, 6, 7, 8, 9}),
    frozenset({0, 2, 6, 7, 8, 10}),
    frozenset({0, 2, 6, 7, 8, 11}),
    frozenset({0, 2, 6, 7, 9, 10}),
    frozenset({0, 2, 6, 7, 9, 11}),
    frozenset({0, 2, 6, 7, 10, 11}),
    frozenset({0, 2, 6, 8, 9, 10}),
    frozenset({0, 2, 6, 8, 9, 11}),
    frozenset({0, 2, 6, 8, 10, 11}),
    frozenset({0, 2, 6, 9, 10, 11}),
    frozenset({0, 2, 7, 8, 9, 10}),
    frozenset({0, 2, 7, 8, 9, 11}),
    frozenset({0, 2, 7, 8, 10, 11}),
    frozenset({0, 2, 7, 9, 10, 11}),
    frozenset({0, 2, 8, 9, 10, 11}),
    frozenset({0, 3, 4, 5, 6, 7}),
    frozenset({0, 3, 4, 5, 6, 8}),
    frozenset({0, 3, 4, 5, 6, 9}),
    frozenset({0, 3, 4, 5, 6, 10}),
    frozenset({0, 3, 4, 5, 6, 11}),
    frozenset({0, 3, 4, 5, 7, 8}),
    frozenset({0, 3, 4, 5, 7, 9}),
    frozenset({0, 3, 4, 5, 7, 10}),
    frozenset({0, 3, 4, 5, 7, 11}),
    frozenset({0, 3, 4, 5, 8, 9}),
    frozenset({0, 3, 4, 5, 8, 10}),
    frozenset({0, 3, 4, 5, 8, 11}),
    frozenset({0, 3, 4, 5, 9, 10}),
    frozenset({0, 3, 4, 5, 9, 11}),
    frozenset({0, 3, 4, 5, 10, 11}),
    frozenset({0, 3, 4, 6, 7, 8}),
    frozenset({0, 3, 4, 6, 7, 9}),
    frozenset({0, 3, 4, 6, 7, 10}),
    frozenset({0, 3, 4, 6, 7, 11}),
    frozenset({0, 3, 4, 6, 8, 9}),
    frozenset({0, 3, 4, 6, 8, 10}),
    frozenset({0, 3, 4, 6, 8, 11}),
    frozenset({0, 3, 4, 6, 9, 10}),
    frozenset({0, 3, 4, 6, 9, 11}),
    frozenset({0, 3, 4, 6, 10, 11}),
    frozenset({0, 3, 4, 7, 8, 9}),
    frozenset({0, 3, 4, 7, 8, 10}),
    frozenset({0, 3, 4, 7, 8, 11}),
    frozenset({0, 3, 4, 7, 9, 10}),
    frozenset({0, 3, 4, 7, 9, 11}),
    frozenset({0, 3, 4, 7, 10, 11}),
    frozenset({0, 3, 4, 8, 9, 10}),
    frozenset({0, 3, 4, 8, 9, 11}),
    frozenset({0, 3, 4, 8, 10, 11}),
    frozenset({0, 3, 4, 9, 10, 11}),
    frozenset({0, 3, 5, 6, 7, 8}),
    frozenset({0, 3, 5, 6, 7, 9}),
    frozenset({0, 3, 5, 6, 7, 10}),
    frozenset({0, 3, 5, 6, 7, 11}),
    frozenset({0, 3, 5, 6, 8, 9}),
    frozenset({0, 3, 5, 6, 8, 10}),
    frozenset({0, 3, 5, 6, 8, 11}),
    frozenset({0, 3, 5, 6, 9, 10}),
    frozenset({0, 3, 5, 6, 9, 11}),
    frozenset({0, 3, 5, 6, 10, 11}),
    frozenset({0, 3, 5, 7, 8, 9}),
    frozenset({0, 3, 5, 7, 8, 10}),
    frozenset({0, 3, 5, 7, 8, 11}),
    frozenset({0, 3, 5, 7, 9, 10}),
    frozenset({0, 3, 5, 7, 9, 11}),
    frozenset({0, 3, 5, 7, 10, 11}),
    frozenset({0, 3, 5, 8, 9, 10}),
    frozenset({0, 3, 5, 8, 9, 11}),
    frozenset({0, 3, 5, 8, 10, 11}),
    frozenset({0, 3, 5, 9, 10, 11}),
    frozenset({0, 3, 6, 7, 8, 9}),
    frozenset({0, 3, 6, 7, 8, 10}),
    frozenset({0, 3, 6, 7, 8, 11}),
    frozenset({0, 3, 6, 7, 9, 10}),
    frozenset({0, 3, 6, 7, 9, 11}),
    frozenset({0, 3, 6, 7, 10, 11}),
    frozenset({0, 3, 6, 8, 9, 10}),
    frozenset({0, 3, 6, 8, 9, 11}),
    frozenset({0, 3, 6, 8, 10, 11}),
    frozenset({0, 3, 6, 9, 10, 11}),
    frozenset({0, 3, 7, 8, 9, 10}),
    frozenset({0, 3, 7, 8, 9, 11}),
    frozenset({0, 3, 7, 8, 10, 11}),
    frozenset({0, 3, 7, 9, 10, 11}),
    frozenset({0, 3, 8, 9, 10, 11}),
    frozenset({0, 4, 5, 6, 7, 8}),
    frozenset({0, 4, 5, 6, 7, 9}),
    frozenset({0, 4, 5, 6, 7, 10}),
    frozenset({0, 4, 5, 6, 7, 11}),
    frozenset({0, 4, 5, 6, 8, 9}),
    frozenset({0, 4, 5, 6, 8, 10}),
    frozenset({0, 4, 5, 6, 8, 11}),
    frozenset({0, 4, 5, 6, 9, 10}),
    frozenset({0, 4, 5, 6, 9, 11}),
    frozenset({0, 4, 5, 6, 10, 11}),
    frozenset({0, 4, 5, 7, 8, 9}),
    frozenset({0, 4, 5, 7, 8, 10}),
    frozenset({0, 4, 5, 7, 8, 11}),
    frozenset({0, 4, 5, 7, 9, 10}),
    frozenset({0, 4, 5, 7, 9, 11}),
    frozenset({0, 4, 5, 7, 10, 11}),
    frozenset({0, 4, 5, 8, 9, 10}),
    frozenset({0, 4, 5, 8, 9, 11}),
    frozenset({0, 4, 5, 8, 10, 11}),
    frozenset({0, 4, 5, 9, 10, 11}),
    frozenset({0, 4, 6, 7, 8, 9}),
    frozenset({0, 4, 6, 7, 8, 10}),
    frozenset({0, 4, 6, 7, 8, 11}),
    frozenset({0, 4, 6, 7, 9, 10}),
    frozenset({0, 4, 6, 7, 9, 11}),
    frozenset({0, 4, 6, 7, 10, 11}),
    frozenset({0, 4, 6, 8, 9, 10}),
    frozenset({0, 4, 6, 8, 9, 11}),
    frozenset({0, 4, 6, 8, 10, 11}),
    frozenset({0, 4, 6, 9, 10, 11}),
    frozenset({0, 4, 7, 8, 9, 10}),
    frozenset({0, 4, 7, 8, 9, 11}),
    frozenset({0, 4, 7, 8, 10, 11}),
    frozenset({0, 4, 7, 9, 10, 11}),
    frozenset({0, 4, 8, 9, 10, 11}),
    frozenset({0, 5, 6, 7, 8, 9}),
    frozenset({0, 5, 6, 7, 8, 10}),
    frozenset({0, 5, 6, 7, 8, 11}),
    frozenset({0, 5, 6, 7, 9, 10}),
    frozenset({0, 5, 6, 7, 9, 11}),
    frozenset({0, 5, 6, 7, 10, 11}),
    frozenset({0, 5, 6, 8, 9, 10}),
    frozenset({0, 5, 6, 8, 9, 11}),
    frozenset({0, 5, 6, 8, 10, 11}),
    frozenset({0, 5, 6, 9, 10, 11}),
    frozenset({0, 5, 7, 8, 9, 10}),
    frozenset({0, 5, 7, 8, 9, 11}),
    frozenset({0, 5, 7, 8, 10, 11}),
    frozenset({0, 5, 7, 9, 10, 11}),
    frozenset({0, 5, 8, 9, 10, 11}),
    frozenset({0, 6, 7, 8, 9, 10}),
    frozenset({0, 6, 7, 8, 9, 11}),
    frozenset({0, 6, 7, 8, 10, 11}),
    frozenset({0, 6, 7, 9, 10, 11}),
    frozenset({0, 6, 8, 9, 10, 11}),
    frozenset({0, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 6}),
    frozenset({1, 2, 3, 4, 5, 7}),
    frozenset({1, 2, 3, 4, 5, 8}),
    frozenset({1, 2, 3, 4, 5, 9}),
    frozenset({1, 2, 3, 4, 5, 10}),
    frozenset({1, 2, 3, 4, 5, 11}),
    frozenset({1, 2, 3, 4, 6, 7}),
    frozenset({1, 2, 3, 4, 6, 8}),
    frozenset({1, 2, 3, 4, 6, 9}),
    frozenset({1, 2, 3, 4, 6, 10}),
    frozenset({1, 2, 3, 4, 6, 11}),
    frozenset({1, 2, 3, 4, 7, 8}),
    frozenset({1, 2, 3, 4, 7, 9}),
    frozenset({1, 2, 3, 4, 7, 10}),
    frozenset({1, 2, 3, 4, 7, 11}),
    frozenset({1, 2, 3, 4, 8, 9}),
    frozenset({1, 2, 3, 4, 8, 10}),
    frozenset({1, 2, 3, 4, 8, 11}),
    frozenset({1, 2, 3, 4, 9, 10}),
    frozenset({1, 2, 3, 4, 9, 11}),
    frozenset({1, 2, 3, 4, 10, 11}),
    frozenset({1, 2, 3, 5, 6, 7}),
    frozenset({1, 2, 3, 5, 6, 8}),
    frozenset({1, 2, 3, 5, 6, 9}),
    frozenset({1, 2, 3, 5, 6, 10}),
    frozenset({1, 2, 3, 5, 6, 11}),
    frozenset({1, 2, 3, 5, 7, 8}),
    frozenset({1, 2, 3, 5, 7, 9}),
    frozenset({1, 2, 3, 5, 7, 10}),
    frozenset({1, 2, 3, 5, 7, 11}),
    frozenset({1, 2, 3, 5, 8, 9}),
    frozenset({1, 2, 3, 5, 8, 10}),
    frozenset({1, 2, 3, 5, 8, 11}),
    frozenset({1, 2, 3, 5, 9, 10}),
    frozenset({1, 2, 3, 5, 9, 11}),
    frozenset({1, 2, 3, 5, 10, 11}),
    frozenset({1, 2, 3, 6, 7, 8}),
    frozenset({1, 2, 3, 6, 7, 9}),
    frozenset({1, 2, 3, 6, 7, 10}),
    frozenset({1, 2, 3, 6, 7, 11}),
    frozenset({1, 2, 3, 6, 8, 9}),
    frozenset({1, 2, 3, 6, 8, 10}),
    frozenset({1, 2, 3, 6, 8, 11}),
    frozenset({1, 2, 3, 6, 9, 10}),
    frozenset({1, 2, 3, 6, 9, 11}),
    frozenset({1, 2, 3, 6, 10, 11}),
    frozenset({1, 2, 3, 7, 8, 9}),
    frozenset({1, 2, 3, 7, 8, 10}),
    frozenset({1, 2, 3, 7, 8, 11}),
    frozenset({1, 2, 3, 7, 9, 10}),
    frozenset({1, 2, 3, 7, 9, 11}),
    frozenset({1, 2, 3, 7, 10, 11}),
    frozenset({1, 2, 3, 8, 9, 10}),
    frozenset({1, 2, 3, 8, 9, 11}),
    frozenset({1, 2, 3, 8, 10, 11}),
    frozenset({1, 2, 3, 9, 10, 11}),
    frozenset({1, 2, 4, 5, 6, 7}),
    frozenset({1, 2, 4, 5, 6, 8}),
    frozenset({1, 2, 4, 5, 6, 9}),
    frozenset({1, 2, 4, 5, 6, 10}),
    frozenset({1, 2, 4, 5, 6, 11}),
    frozenset({1, 2, 4, 5, 7, 8}),
    frozenset({1, 2, 4, 5, 7, 9}),
    frozenset({1, 2, 4, 5, 7, 10}),
    frozenset({1, 2, 4, 5, 7, 11}),
    frozenset({1, 2, 4, 5, 8, 9}),
    frozenset({1, 2, 4, 5, 8, 10}),
    frozenset({1, 2, 4, 5, 8, 11}),
    frozenset({1, 2, 4, 5, 9, 10}),
    frozenset({1, 2, 4, 5, 9, 11}),
    frozenset({1, 2, 4, 5, 10, 11}),
    frozenset({1, 2, 4, 6, 7, 8}),
    frozenset({1, 2, 4, 6, 7, 9}),
    frozenset({1, 2, 4, 6, 7, 10}),
    frozenset({1, 2, 4, 6, 7, 11}),
    frozenset({1, 2, 4, 6, 8, 9}),
    frozenset({1, 2, 4, 6, 8, 10}),
    frozenset({1, 2, 4, 6, 8, 11}),
    frozenset({1, 2, 4, 6, 9, 10}),
    frozenset({1, 2, 4, 6, 9, 11}),
    frozenset({1, 2, 4, 6, 10, 11}),
    frozenset({1, 2, 4, 7, 8, 9}),
    frozenset({1, 2, 4, 7, 8, 10}),
    frozenset({1, 2, 4, 7, 8, 11}),
    frozenset({1, 2, 4, 7, 9, 10}),
    frozenset({1, 2, 4, 7, 9, 11}),
    frozenset({1, 2, 4, 7, 10, 11}),
    frozenset({1, 2, 4, 8, 9, 10}),
    frozenset({1, 2, 4, 8, 9, 11}),
    frozenset({1, 2, 4, 8, 10, 11}),
    frozenset({1, 2, 4, 9, 10, 11}),
    frozenset({1, 2, 5, 6, 7, 8}),
    frozenset({1, 2, 5, 6, 7, 9}),
    frozenset({1, 2, 5, 6, 7, 10}),
    frozenset({1, 2, 5, 6, 7, 11}),
    frozenset({1, 2, 5, 6, 8, 9}),
    frozenset({1, 2, 5, 6, 8, 10}),
    frozenset({1, 2, 5, 6, 8, 11}),
    frozenset({1, 2, 5, 6, 9, 10}),
    frozenset({1, 2, 5, 6, 9, 11}),
    frozenset({1, 2, 5, 6, 10, 11}),
    frozenset({1, 2, 5, 7, 8, 9}),
    frozenset({1, 2, 5, 7, 8, 10}),
    frozenset({1, 2, 5, 7, 8, 11}),
    frozenset({1, 2, 5, 7, 9, 10}),
    frozenset({1, 2, 5, 7, 9, 11}),
    frozenset({1, 2, 5, 7, 10, 11}),
    frozenset({1, 2, 5, 8, 9, 10}),
    frozenset({1, 2, 5, 8, 9, 11}),
    frozenset({1, 2, 5, 8, 10, 11}),
    frozenset({1, 2, 5, 9, 10, 11}),
    frozenset({1, 2, 6, 7, 8, 9}),
    frozenset({1, 2, 6, 7, 8, 10}),
    frozenset({1, 2, 6, 7, 8, 11}),
    frozenset({1, 2, 6, 7, 9, 10}),
    frozenset({1, 2, 6, 7, 9, 11}),
    frozenset({1, 2, 6, 7, 10, 11}),
    frozenset({1, 2, 6, 8, 9, 10}),
    frozenset({1, 2, 6, 8, 9, 11}),
    frozenset({1, 2, 6, 8, 10, 11}),
    frozenset({1, 2, 6, 9, 10, 11}),
    frozenset({1, 2, 7, 8, 9, 10}),
    frozenset({1, 2, 7, 8, 9, 11}),
    frozenset({1, 2, 7, 8, 10, 11}),
    frozenset({1, 2, 7, 9, 10, 11}),
    frozenset({1, 2, 8, 9, 10, 11}),
    frozenset({1, 3, 4, 5, 6, 7}),
    frozenset({1, 3, 4, 5, 6, 8}),
    frozenset({1, 3, 4, 5, 6, 9}),
    frozenset({1, 3, 4, 5, 6, 10}),
    frozenset({1, 3, 4, 5, 6, 11}),
    frozenset({1, 3, 4, 5, 7, 8}),
    frozenset({1, 3, 4, 5, 7, 9}),
    frozenset({1, 3, 4, 5, 7, 10}),
    frozenset({1, 3, 4, 5, 7, 11}),
    frozenset({1, 3, 4, 5, 8, 9}),
    frozenset({1, 3, 4, 5, 8, 10}),
    frozenset({1, 3, 4, 5, 8, 11}),
    frozenset({1, 3, 4, 5, 9, 10}),
    frozenset({1, 3, 4, 5, 9, 11}),
    frozenset({1, 3, 4, 5, 10, 11}),
    frozenset({1, 3, 4, 6, 7, 8}),
    frozenset({1, 3, 4, 6, 7, 9}),
    frozenset({1, 3, 4, 6, 7, 10}),
    frozenset({1, 3, 4, 6, 7, 11}),
    frozenset({1, 3, 4, 6, 8, 9}),
    frozenset({1, 3, 4, 6, 8, 10}),
    frozenset({1, 3, 4, 6, 8, 11}),
    frozenset({1, 3, 4, 6, 9, 10}),
    frozenset({1, 3, 4, 6, 9, 11}),
    frozenset({1, 3, 4, 6, 10, 11}),
    frozenset({1, 3, 4, 7, 8, 9}),
    frozenset({1, 3, 4, 7, 8, 10}),
    frozenset({1, 3, 4, 7, 8, 11}),
    frozenset({1, 3, 4, 7, 9, 10}),
    frozenset({1, 3, 4, 7, 9, 11}),
    frozenset({1, 3, 4, 7, 10, 11}),
    frozenset({1, 3, 4, 8, 9, 10}),
    frozenset({1, 3, 4, 8, 9, 11}),
    frozenset({1, 3, 4, 8, 10, 11}),
    frozenset({1, 3, 4, 9, 10, 11}),
    frozenset({1, 3, 5, 6, 7, 8}),
    frozenset({1, 3, 5, 6, 7, 9}),
    frozenset({1, 3, 5, 6, 7, 10}),
    frozenset({1, 3, 5, 6, 7, 11}),
    frozenset({1, 3, 5, 6, 8, 9}),
    frozenset({1, 3, 5, 6, 8, 10}),
    frozenset({1, 3, 5, 6, 8, 11}),
    frozenset({1, 3, 5, 6, 9, 10}),
    frozenset({1, 3, 5, 6, 9, 11}),
    frozenset({1, 3, 5, 6, 10, 11}),
    frozenset({1, 3, 5, 7, 8, 9}),
    frozenset({1, 3, 5, 7, 8, 10}),
    frozenset({1, 3, 5, 7, 8, 11}),
    frozenset({1, 3, 5, 7, 9, 10}),
    frozenset({1, 3, 5, 7, 9, 11}),
    frozenset({1, 3, 5, 7, 10, 11}),
    frozenset({1, 3, 5, 8, 9, 10}),
    frozenset({1, 3, 5, 8, 9, 11}),
    frozenset({1, 3, 5, 8, 10, 11}),
    frozenset({1, 3, 5, 9, 10, 11}),
    frozenset({1, 3, 6, 7, 8, 9}),
    frozenset({1, 3, 6, 7, 8, 10}),
    frozenset({1, 3, 6, 7, 8, 11}),
    frozenset({1, 3, 6, 7, 9, 10}),
    frozenset({1, 3, 6, 7, 9, 11}),
    frozenset({1, 3, 6, 7, 10, 11}),
    frozenset({1, 3, 6, 8, 9, 10}),
    frozenset({1, 3, 6, 8, 9, 11}),
    frozenset({1, 3, 6, 8, 10, 11}),
    frozenset({1, 3, 6, 9, 10, 11}),
    frozenset({1, 3, 7, 8, 9, 10}),
    frozenset({1, 3, 7, 8, 9, 11}),
    frozenset({1, 3, 7, 8, 10, 11}),
    frozenset({1, 3, 7, 9, 10, 11}),
    frozenset({1, 3, 8, 9, 10, 11}),
    frozenset({1, 4, 5, 6, 7, 8}),
    frozenset({1, 4, 5, 6, 7, 9}),
    frozenset({1, 4, 5, 6, 7, 10}),
    frozenset({1, 4, 5, 6, 7, 11}),
    frozenset({1, 4, 5, 6, 8, 9}),
    frozenset({1, 4, 5, 6, 8, 10}),
    frozenset({1, 4, 5, 6, 8, 11}),
    frozenset({1, 4, 5, 6, 9, 10}),
    frozenset({1, 4, 5, 6, 9, 11}),
    frozenset({1, 4, 5, 6, 10, 11}),
    frozenset({1, 4, 5, 7, 8, 9}),
    frozenset({1, 4, 5, 7, 8, 10}),
    frozenset({1, 4, 5, 7, 8, 11}),
    frozenset({1, 4, 5, 7, 9, 10}),
    frozenset({1, 4, 5, 7, 9, 11}),
    frozenset({1, 4, 5, 7, 10, 11}),
    frozenset({1, 4, 5, 8, 9, 10}),
    frozenset({1, 4, 5, 8, 9, 11}),
    frozenset({1, 4, 5, 8, 10, 11}),
    frozenset({1, 4, 5, 9, 10, 11}),
    frozenset({1, 4, 6, 7, 8, 9}),
    frozenset({1, 4, 6, 7, 8, 10}),
    frozenset({1, 4, 6, 7, 8, 11}),
    frozenset({1, 4, 6, 7, 9, 10}),
    frozenset({1, 4, 6, 7, 9, 11}),
    frozenset({1, 4, 6, 7, 10, 11}),
    frozenset({1, 4, 6, 8, 9, 10}),
    frozenset({1, 4, 6, 8, 9, 11}),
    frozenset({1, 4, 6, 8, 10, 11}),
    frozenset({1, 4, 6, 9, 10, 11}),
    frozenset({1, 4, 7, 8, 9, 10}),
    frozenset({1, 4, 7, 8, 9, 11}),
    frozenset({1, 4, 7, 8, 10, 11}),
    frozenset({1, 4, 7, 9, 10, 11}),
    frozenset({1, 4, 8, 9, 10, 11}),
    frozenset({1, 5, 6, 7, 8, 9}),
    frozenset({1, 5, 6, 7, 8, 10}),
    frozenset({1, 5, 6, 7, 8, 11}),
    frozenset({1, 5, 6, 7, 9, 10}),
    frozenset({1, 5, 6, 7, 9, 11}),
    frozenset({1, 5, 6, 7, 10, 11}),
    frozenset({1, 5, 6, 8, 9, 10}),
    frozenset({1, 5, 6, 8, 9, 11}),
    frozenset({1, 5, 6, 8, 10, 11}),
    frozenset({1, 5, 6, 9, 10, 11}),
    frozenset({1, 5, 7, 8, 9, 10}),
    frozenset({1, 5, 7, 8, 9, 11}),
    frozenset({1, 5, 7, 8, 10, 11}),
    frozenset({1, 5, 7, 9, 10, 11}),
    frozenset({1, 5, 8, 9, 10, 11}),
    frozenset({1, 6, 7, 8, 9, 10}),
    frozenset({1, 6, 7, 8, 9, 11}),
    frozenset({1, 6, 7, 8, 10, 11}),
    frozenset({1, 6, 7, 9, 10, 11}),
    frozenset({1, 6, 8, 9, 10, 11}),
    frozenset({1, 7, 8, 9, 10, 11}),
    frozenset({2, 3, 4, 5, 6, 7}),
    frozenset({2, 3, 4, 5, 6, 8}),
    frozenset({2, 3, 4, 5, 6, 9}),
    frozenset({2, 3, 4, 5, 6, 10}),
    frozenset({2, 3, 4, 5, 6, 11}),
    frozenset({2, 3, 4, 5, 7, 8}),
    frozenset({2, 3, 4, 5, 7, 9}),
    frozenset({2, 3, 4, 5, 7, 10}),
    frozenset({2, 3, 4, 5, 7, 11}),
    frozenset({2, 3, 4, 5, 8, 9}),
    frozenset({2, 3, 4, 5, 8, 10}),
    frozenset({2, 3, 4, 5, 8, 11}),
    frozenset({2, 3, 4, 5, 9, 10}),
    frozenset({2, 3, 4, 5, 9, 11}),
    frozenset({2, 3, 4, 5, 10, 11}),
    frozenset({2, 3, 4, 6, 7, 8}),
    frozenset({2, 3, 4, 6, 7, 9}),
    frozenset({2, 3, 4, 6, 7, 10}),
    frozenset({2, 3, 4, 6, 7, 11}),
    frozenset({2, 3, 4, 6, 8, 9}),
    frozenset({2, 3, 4, 6, 8, 10}),
    frozenset({2, 3, 4, 6, 8, 11}),
    frozenset({2, 3, 4, 6, 9, 10}),
    frozenset({2, 3, 4, 6, 9, 11}),
    frozenset({2, 3, 4, 6, 10, 11}),
    frozenset({2, 3, 4, 7, 8, 9}),
    frozenset({2, 3, 4, 7, 8, 10}),
    frozenset({2, 3, 4, 7, 8, 11}),
    frozenset({2, 3, 4, 7, 9, 10}),
    frozenset({2, 3, 4, 7, 9, 11}),
    frozenset({2, 3, 4, 7, 10, 11}),
    frozenset({2, 3, 4, 8, 9, 10}),
    frozenset({2, 3, 4, 8, 9, 11}),
    frozenset({2, 3, 4, 8, 10, 11}),
    frozenset({2, 3, 4, 9, 10, 11}),
    frozenset({2, 3, 5, 6, 7, 8}),
    frozenset({2, 3, 5, 6, 7, 9}),
    frozenset({2, 3, 5, 6, 7, 10}),
    frozenset({2, 3, 5, 6, 7, 11}),
    frozenset({2, 3, 5, 6, 8, 9}),
    frozenset({2, 3, 5, 6, 8, 10}),
    frozenset({2, 3, 5, 6, 8, 11}),
    frozenset({2, 3, 5, 6, 9, 10}),
    frozenset({2, 3, 5, 6, 9, 11}),
    frozenset({2, 3, 5, 6, 10, 11}),
    frozenset({2, 3, 5, 7, 8, 9}),
    frozenset({2, 3, 5, 7, 8, 10}),
    frozenset({2, 3, 5, 7, 8, 11}),
    frozenset({2, 3, 5, 7, 9, 10}),
    frozenset({2, 3, 5, 7, 9, 11}),
    frozenset({2, 3, 5, 7, 10, 11}),
    frozenset({2, 3, 5, 8, 9, 10}),
    frozenset({2, 3, 5, 8, 9, 11}),
    frozenset({2, 3, 5, 8, 10, 11}),
    frozenset({2, 3, 5, 9, 10, 11}),
    frozenset({2, 3, 6, 7, 8, 9}),
    frozenset({2, 3, 6, 7, 8, 10}),
    frozenset({2, 3, 6, 7, 8, 11}),
    frozenset({2, 3, 6, 7, 9, 10}),
    frozenset({2, 3, 6, 7, 9, 11}),
    frozenset({2, 3, 6, 7, 10, 11}),
    frozenset({2, 3, 6, 8, 9, 10}),
    frozenset({2, 3, 6, 8, 9, 11}),
    frozenset({2, 3, 6, 8, 10, 11}),
    frozenset({2, 3, 6, 9, 10, 11}),
    frozenset({2, 3, 7, 8, 9, 10}),
    frozenset({2, 3, 7, 8, 9, 11}),
    frozenset({2, 3, 7, 8, 10, 11}),
    frozenset({2, 3, 7, 9, 10, 11}),
    frozenset({2, 3, 8, 9, 10, 11}),
    frozenset({2, 4, 5, 6, 7, 8}),
    frozenset({2, 4, 5, 6, 7, 9}),
    frozenset({2, 4, 5, 6, 7, 10}),
    frozenset({2, 4, 5, 6, 7, 11}),
    frozenset({2, 4, 5, 6, 8, 9}),
    frozenset({2, 4, 5, 6, 8, 10}),
    frozenset({2, 4, 5, 6, 8, 11}),
    frozenset({2, 4, 5, 6, 9, 10}),
    frozenset({2, 4, 5, 6, 9, 11}),
    frozenset({2, 4, 5, 6, 10, 11}),
    frozenset({2, 4, 5, 7, 8, 9}),
    frozenset({2, 4, 5, 7, 8, 10}),
    frozenset({2, 4, 5, 7, 8, 11}),
    frozenset({2, 4, 5, 7, 9, 10}),
    frozenset({2, 4, 5, 7, 9, 11}),
    frozenset({2, 4, 5, 7, 10, 11}),
    frozenset({2, 4, 5, 8, 9, 10}),
    frozenset({2, 4, 5, 8, 9, 11}),
    frozenset({2, 4, 5, 8, 10, 11}),
    frozenset({2, 4, 5, 9, 10, 11}),
    frozenset({2, 4, 6, 7, 8, 9}),
    frozenset({2, 4, 6, 7, 8, 10}),
    frozenset({2, 4, 6, 7, 8, 11}),
    frozenset({2, 4, 6, 7, 9, 10}),
    frozenset({2, 4, 6, 7, 9, 11}),
    frozenset({2, 4, 6, 7, 10, 11}),
    frozenset({2, 4, 6, 8, 9, 10}),
    frozenset({2, 4, 6, 8, 9, 11}),
    frozenset({2, 4, 6, 8, 10, 11}),
    frozenset({2, 4, 6, 9, 10, 11}),
    frozenset({2, 4, 7, 8, 9, 10}),
    frozenset({2, 4, 7, 8, 9, 11}),
    frozenset({2, 4, 7, 8, 10, 11}),
    frozenset({2, 4, 7, 9, 10, 11}),
    frozenset({2, 4, 8, 9, 10, 11}),
    frozenset({2, 5, 6, 7, 8, 9}),
    frozenset({2, 5, 6, 7, 8, 10}),
    frozenset({2, 5, 6, 7, 8, 11}),
    frozenset({2, 5, 6, 7, 9, 10}),
    frozenset({2, 5, 6, 7, 9, 11}),
    frozenset({2, 5, 6, 7, 10, 11}),
    frozenset({2, 5, 6, 8, 9, 10}),
    frozenset({2, 5, 6, 8, 9, 11}),
    frozenset({2, 5, 6, 8, 10, 11}),
    frozenset({2, 5, 6, 9, 10, 11}),
    frozenset({2, 5, 7, 8, 9, 10}),
    frozenset({2, 5, 7, 8, 9, 11}),
    frozenset({2, 5, 7, 8, 10, 11}),
    frozenset({2, 5, 7, 9, 10, 11}),
    frozenset({2, 5, 8, 9, 10, 11}),
    frozenset({2, 6, 7, 8, 9, 10}),
    frozenset({2, 6, 7, 8, 9, 11}),
    frozenset({2, 6, 7, 8, 10, 11}),
    frozenset({2, 6, 7, 9, 10, 11}),
    frozenset({2, 6, 8, 9, 10, 11}),
    frozenset({2, 7, 8, 9, 10, 11}),
    frozenset({3, 4, 5, 6, 7, 8}),
    frozenset({3, 4, 5, 6, 7, 9}),
    frozenset({3, 4, 5, 6, 7, 10}),
    frozenset({3, 4, 5, 6, 7, 11}),
    frozenset({3, 4, 5, 6, 8, 9}),
    frozenset({3, 4, 5, 6, 8, 10}),
    frozenset({3, 4, 5, 6, 8, 11}),
    frozenset({3, 4, 5, 6, 9, 10}),
    frozenset({3, 4, 5, 6, 9, 11}),
    frozenset({3, 4, 5, 6, 10, 11}),
    frozenset({3, 4, 5, 7, 8, 9}),
    frozenset({3, 4, 5, 7, 8, 10}),
    frozenset({3, 4, 5, 7, 8, 11}),
    frozenset({3, 4, 5, 7, 9, 10}),
    frozenset({3, 4, 5, 7, 9, 11}),
    frozenset({3, 4, 5, 7, 10, 11}),
    frozenset({3, 4, 5, 8, 9, 10}),
    frozenset({3, 4, 5, 8, 9, 11}),
    frozenset({3, 4, 5, 8, 10, 11}),
    frozenset({3, 4, 5, 9, 10, 11}),
    frozenset({3, 4, 6, 7, 8, 9}),
    frozenset({3, 4, 6, 7, 8, 10}),
    frozenset({3, 4, 6, 7, 8, 11}),
    frozenset({3, 4, 6, 7, 9, 10}),
    frozenset({3, 4, 6, 7, 9, 11}),
    frozenset({3, 4, 6, 7, 10, 11}),
    frozenset({3, 4, 6, 8, 9, 10}),
    frozenset({3, 4, 6, 8, 9, 11}),
    frozenset({3, 4, 6, 8, 10, 11}),
    frozenset({3, 4, 6, 9, 10, 11}),
    frozenset({3, 4, 7, 8, 9, 10}),
    frozenset({3, 4, 7, 8, 9, 11}),
    frozenset({3, 4, 7, 8, 10, 11}),
    frozenset({3, 4, 7, 9, 10, 11}),
    frozenset({3, 4, 8, 9, 10, 11}),
    frozenset({3, 5, 6, 7, 8, 9}),
    frozenset({3, 5, 6, 7, 8, 10}),
    frozenset({3, 5, 6, 7, 8, 11}),
    frozenset({3, 5, 6, 7, 9, 10}),
    frozenset({3, 5, 6, 7, 9, 11}),
    frozenset({3, 5, 6, 7, 10, 11}),
    frozenset({3, 5, 6, 8, 9, 10}),
    frozenset({3, 5, 6, 8, 9, 11}),
    frozenset({3, 5, 6, 8, 10, 11}),
    frozenset({3, 5, 6, 9, 10, 11}),
    frozenset({3, 5, 7, 8, 9, 10}),
    frozenset({3, 5, 7, 8, 9, 11}),
    frozenset({3, 5, 7, 8, 10, 11}),
    frozenset({3, 5, 7, 9, 10, 11}),
    frozenset({3, 5, 8, 9, 10, 11}),
    frozenset({3, 6, 7, 8, 9, 10}),
    frozenset({3, 6, 7, 8, 9, 11}),
    frozenset({3, 6, 7, 8, 10, 11}),
    frozenset({3, 6, 7, 9, 10, 11}),
    frozenset({3, 6, 8, 9, 10, 11}),
    frozenset({3, 7, 8, 9, 10, 11}),
    frozenset({4, 5, 6, 7, 8, 9}),
    frozenset({4, 5, 6, 7, 8, 10}),
    frozenset({4, 5, 6, 7, 8, 11}),
    frozenset({4, 5, 6, 7, 9, 10}),
    frozenset({4, 5, 6, 7, 9, 11}),
    frozenset({4, 5, 6, 7, 10, 11}),
    frozenset({4, 5, 6, 8, 9, 10}),
    frozenset({4, 5, 6, 8, 9, 11}),
    frozenset({4, 5, 6, 8, 10, 11}),
    frozenset({4, 5, 6, 9, 10, 11}),
    frozenset({4, 5, 7, 8, 9, 10}),
    frozenset({4, 5, 7, 8, 9, 11}),
    frozenset({4, 5, 7, 8, 10, 11}),
    frozenset({4, 5, 7, 9, 10, 11}),
    frozenset({4, 5, 8, 9, 10, 11}),
    frozenset({4, 6, 7, 8, 9, 10}),
    frozenset({4, 6, 7, 8, 9, 11}),
    frozenset({4, 6, 7, 8, 10, 11}),
    frozenset({4, 6, 7, 9, 10, 11}),
    frozenset({4, 6, 8, 9, 10, 11}),
    frozenset({4, 7, 8, 9, 10, 11}),
    frozenset({5, 6, 7, 8, 9, 10}),
    frozenset({5, 6, 7, 8, 9, 11}),
    frozenset({5, 6, 7, 8, 10, 11}),
    frozenset({5, 6, 7, 9, 10, 11}),
    frozenset({5, 6, 8, 9, 10, 11}),
    frozenset({5, 7, 8, 9, 10, 11}),
    frozenset({6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6}),
    frozenset({0, 1, 2, 3, 4, 5, 7}),
    frozenset({0, 1, 2, 3, 4, 5, 8}),
    frozenset({0, 1, 2, 3, 4, 5, 9}),
    frozenset({0, 1, 2, 3, 4, 5, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 7}),
    frozenset({0, 1, 2, 3, 4, 6, 8}),
    frozenset({0, 1, 2, 3, 4, 6, 9}),
    frozenset({0, 1, 2, 3, 4, 6, 10}),
    frozenset({0, 1, 2, 3, 4, 6, 11}),
    frozenset({0, 1, 2, 3, 4, 7, 8}),
    frozenset({0, 1, 2, 3, 4, 7, 9}),
    frozenset({0, 1, 2, 3, 4, 7, 10}),
    frozenset({0, 1, 2, 3, 4, 7, 11}),
    frozenset({0, 1, 2, 3, 4, 8, 9}),
    frozenset({0, 1, 2, 3, 4, 8, 10}),
    frozenset({0, 1, 2, 3, 4, 8, 11}),
    frozenset({0, 1, 2, 3, 4, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 7}),
    frozenset({0, 1, 2, 3, 5, 6, 8}),
    frozenset({0, 1, 2, 3, 5, 6, 9}),
    frozenset({0, 1, 2, 3, 5, 6, 10}),
    frozenset({0, 1, 2, 3, 5, 6, 11}),
    frozenset({0, 1, 2, 3, 5, 7, 8}),
    frozenset({0, 1, 2, 3, 5, 7, 9}),
    frozenset({0, 1, 2, 3, 5, 7, 10}),
    frozenset({0, 1, 2, 3, 5, 7, 11}),
    frozenset({0, 1, 2, 3, 5, 8, 9}),
    frozenset({0, 1, 2, 3, 5, 8, 10}),
    frozenset({0, 1, 2, 3, 5, 8, 11}),
    frozenset({0, 1, 2, 3, 5, 9, 10}),
    frozenset({0, 1, 2, 3, 5, 9, 11}),
    frozenset({0, 1, 2, 3, 5, 10, 11}),
    frozenset({0, 1, 2, 3, 6, 7, 8}),
    frozenset({0, 1, 2, 3, 6, 7, 9}),
    frozenset({0, 1, 2, 3, 6, 7, 10}),
    frozenset({0, 1, 2, 3, 6, 7, 11}),
    frozenset({0, 1, 2, 3, 6, 8, 9}),
    frozenset({0, 1, 2, 3, 6, 8, 10}),
    frozenset({0, 1, 2, 3, 6, 8, 11}),
    frozenset({0, 1, 2, 3, 6, 9, 10}),
    frozenset({0, 1, 2, 3, 6, 9, 11}),
    frozenset({0, 1, 2, 3, 6, 10, 11}),
    frozenset({0, 1, 2, 3, 7, 8, 9}),
    frozenset({0, 1, 2, 3, 7, 8, 10}),
    frozenset({0, 1, 2, 3, 7, 8, 11}),
    frozenset({0, 1, 2, 3, 7, 9, 10}),
    frozenset({0, 1, 2, 3, 7, 9, 11}),
    frozenset({0, 1, 2, 3, 7, 10, 11}),
    frozenset({0, 1, 2, 3, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 7}),
    frozenset({0, 1, 2, 4, 5, 6, 8}),
    frozenset({0, 1, 2, 4, 5, 6, 9}),
    frozenset({0, 1, 2, 4, 5, 6, 10}),
    frozenset({0, 1, 2, 4, 5, 6, 11}),
    frozenset({0, 1, 2, 4, 5, 7, 8}),
    frozenset({0, 1, 2, 4, 5, 7, 9}),
    frozenset({0, 1, 2, 4, 5, 7, 10}),
    frozenset({0, 1, 2, 4, 5, 7, 11}),
    frozenset({0, 1, 2, 4, 5, 8, 9}),
    frozenset({0, 1, 2, 4, 5, 8, 10}),
    frozenset({0, 1, 2, 4, 5, 8, 11}),
    frozenset({0, 1, 2, 4, 5, 9, 10}),
    frozenset({0, 1, 2, 4, 5, 9, 11}),
    frozenset({0, 1, 2, 4, 5, 10, 11}),
    frozenset({0, 1, 2, 4, 6, 7, 8}),
    frozenset({0, 1, 2, 4, 6, 7, 9}),
    frozenset({0, 1, 2, 4, 6, 7, 10}),
    frozenset({0, 1, 2, 4, 6, 7, 11}),
    frozenset({0, 1, 2, 4, 6, 8, 9}),
    frozenset({0, 1, 2, 4, 6, 8, 10}),
    frozenset({0, 1, 2, 4, 6, 8, 11}),
    frozenset({0, 1, 2, 4, 6, 9, 10}),
    frozenset({0, 1, 2, 4, 6, 9, 11}),
    frozenset({0, 1, 2, 4, 6, 10, 11}),
    frozenset({0, 1, 2, 4, 7, 8, 9}),
    frozenset({0, 1, 2, 4, 7, 8, 10}),
    frozenset({0, 1, 2, 4, 7, 8, 11}),
    frozenset({0, 1, 2, 4, 7, 9, 10}),
    frozenset({0, 1, 2, 4, 7, 9, 11}),
    frozenset({0, 1, 2, 4, 7, 10, 11}),
    frozenset({0, 1, 2, 4, 8, 9, 10}),
    frozenset({0, 1, 2, 4, 8, 9, 11}),
    frozenset({0, 1, 2, 4, 8, 10, 11}),
    frozenset({0, 1, 2, 4, 9, 10, 11}),
    frozenset({0, 1, 2, 5, 6, 7, 8}),
    frozenset({0, 1, 2, 5, 6, 7, 9}),
    frozenset({0, 1, 2, 5, 6, 7, 10}),
    frozenset({0, 1, 2, 5, 6, 7, 11}),
    frozenset({0, 1, 2, 5, 6, 8, 9}),
    frozenset({0, 1, 2, 5, 6, 8, 10}),
    frozenset({0, 1, 2, 5, 6, 8, 11}),
    frozenset({0, 1, 2, 5, 6, 9, 10}),
    frozenset({0, 1, 2, 5, 6, 9, 11}),
    frozenset({0, 1, 2, 5, 6, 10, 11}),
    frozenset({0, 1, 2, 5, 7, 8, 9}),
    frozenset({0, 1, 2, 5, 7, 8, 10}),
    frozenset({0, 1, 2, 5, 7, 8, 11}),
    frozenset({0, 1, 2, 5, 7, 9, 10}),
    frozenset({0, 1, 2, 5, 7, 9, 11}),
    frozenset({0, 1, 2, 5, 7, 10, 11}),
    frozenset({0, 1, 2, 5, 8, 9, 10}),
    frozenset({0, 1, 2, 5, 8, 9, 11}),
    frozenset({0, 1, 2, 5, 8, 10, 11}),
    frozenset({0, 1, 2, 5, 9, 10, 11}),
    frozenset({0, 1, 2, 6, 7, 8, 9}),
    frozenset({0, 1, 2, 6, 7, 8, 10}),
    frozenset({0, 1, 2, 6, 7, 8, 11}),
    frozenset({0, 1, 2, 6, 7, 9, 10}),
    frozenset({0, 1, 2, 6, 7, 9, 11}),
    frozenset({0, 1, 2, 6, 7, 10, 11}),
    frozenset({0, 1, 2, 6, 8, 9, 10}),
    frozenset({0, 1, 2, 6, 8, 9, 11}),
    frozenset({0, 1, 2, 6, 8, 10, 11}),
    frozenset({0, 1, 2, 6, 9, 10, 11}),
    frozenset({0, 1, 2, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 7}),
    frozenset({0, 1, 3, 4, 5, 6, 8}),
    frozenset({0, 1, 3, 4, 5, 6, 9}),
    frozenset({0, 1, 3, 4, 5, 6, 10}),
    frozenset({0, 1, 3, 4, 5, 6, 11}),
    frozenset({0, 1, 3, 4, 5, 7, 8}),
    frozenset({0, 1, 3, 4, 5, 7, 9}),
    frozenset({0, 1, 3, 4, 5, 7, 10}),
    frozenset({0, 1, 3, 4, 5, 7, 11}),
    frozenset({0, 1, 3, 4, 5, 8, 9}),
    frozenset({0, 1, 3, 4, 5, 8, 10}),
    frozenset({0, 1, 3, 4, 5, 8, 11}),
    frozenset({0, 1, 3, 4, 5, 9, 10}),
    frozenset({0, 1, 3, 4, 5, 9, 11}),
    frozenset({0, 1, 3, 4, 5, 10, 11}),
    frozenset({0, 1, 3, 4, 6, 7, 8}),
    frozenset({0, 1, 3, 4, 6, 7, 9}),
    frozenset({0, 1, 3, 4, 6, 7, 10}),
    frozenset({0, 1, 3, 4, 6, 7, 11}),
    frozenset({0, 1, 3, 4, 6, 8, 9}),
    frozenset({0, 1, 3, 4, 6, 8, 10}),
    frozenset({0, 1, 3, 4, 6, 8, 11}),
    frozenset({0, 1, 3, 4, 6, 9, 10}),
    frozenset({0, 1, 3, 4, 6, 9, 11}),
    frozenset({0, 1, 3, 4, 6, 10, 11}),
    frozenset({0, 1, 3, 4, 7, 8, 9}),
    frozenset({0, 1, 3, 4, 7, 8, 10}),
    frozenset({0, 1, 3, 4, 7, 8, 11}),
    frozenset({0, 1, 3, 4, 7, 9, 10}),
    frozenset({0, 1, 3, 4, 7, 9, 11}),
    frozenset({0, 1, 3, 4, 7, 10, 11}),
    frozenset({0, 1, 3, 4, 8, 9, 10}),
    frozenset({0, 1, 3, 4, 8, 9, 11}),
    frozenset({0, 1, 3, 4, 8, 10, 11}),
    frozenset({0, 1, 3, 4, 9, 10, 11}),
    frozenset({0, 1, 3, 5, 6, 7, 8}),
    frozenset({0, 1, 3, 5, 6, 7, 9}),
    frozenset({0, 1, 3, 5, 6, 7, 10}),
    frozenset({0, 1, 3, 5, 6, 7, 11}),
    frozenset({0, 1, 3, 5, 6, 8, 9}),
    frozenset({0, 1, 3, 5, 6, 8, 10}),
    frozenset({0, 1, 3, 5, 6, 8, 11}),
    frozenset({0, 1, 3, 5, 6, 9, 10}),
    frozenset({0, 1, 3, 5, 6, 9, 11}),
    frozenset({0, 1, 3, 5, 6, 10, 11}),
    frozenset({0, 1, 3, 5, 7, 8, 9}),
    frozenset({0, 1, 3, 5, 7, 8, 10}),
    frozenset({0, 1, 3, 5, 7, 8, 11}),
    frozenset({0, 1, 3, 5, 7, 9, 10}),
    frozenset({0, 1, 3, 5, 7, 9, 11}),
    frozenset({0, 1, 3, 5, 7, 10, 11}),
    frozenset({0, 1, 3, 5, 8, 9, 10}),
    frozenset({0, 1, 3, 5, 8, 9, 11}),
    frozenset({0, 1, 3, 5, 8, 10, 11}),
    frozenset({0, 1, 3, 5, 9, 10, 11}),
    frozenset({0, 1, 3, 6, 7, 8, 9}),
    frozenset({0, 1, 3, 6, 7, 8, 10}),
    frozenset({0, 1, 3, 6, 7, 8, 11}),
    frozenset({0, 1, 3, 6, 7, 9, 10}),
    frozenset({0, 1, 3, 6, 7, 9, 11}),
    frozenset({0, 1, 3, 6, 7, 10, 11}),
    frozenset({0, 1, 3, 6, 8, 9, 10}),
    frozenset({0, 1, 3, 6, 8, 9, 11}),
    frozenset({0, 1, 3, 6, 8, 10, 11}),
    frozenset({0, 1, 3, 6, 9, 10, 11}),
    frozenset({0, 1, 3, 7, 8, 9, 10}),
    frozenset({0, 1, 3, 7, 8, 9, 11}),
    frozenset({0, 1, 3, 7, 8, 10, 11}),
    frozenset({0, 1, 3, 7, 9, 10, 11}),
    frozenset({0, 1, 3, 8, 9, 10, 11}),
    frozenset({0, 1, 4, 5, 6, 7, 8}),
    frozenset({0, 1, 4, 5, 6, 7, 9}),
    frozenset({0, 1, 4, 5, 6, 7, 10}),
    frozenset({0, 1, 4, 5, 6, 7, 11}),
    frozenset({0, 1, 4, 5, 6, 8, 9}),
    frozenset({0, 1, 4, 5, 6, 8, 10}),
    frozenset({0, 1, 4, 5, 6, 8, 11}),
    frozenset({0, 1, 4, 5, 6, 9, 10}),
    frozenset({0, 1, 4, 5, 6, 9, 11}),
    frozenset({0, 1, 4, 5, 6, 10, 11}),
    frozenset({0, 1, 4, 5, 7, 8, 9}),
    frozenset({0, 1, 4, 5, 7, 8, 10}),
    frozenset({0, 1, 4, 5, 7, 8, 11}),
    frozenset({0, 1, 4, 5, 7, 9, 10}),
    frozenset({0, 1, 4, 5, 7, 9, 11}),
    frozenset({0, 1, 4, 5, 7, 10, 11}),
    frozenset({0, 1, 4, 5, 8, 9, 10}),
    frozenset({0, 1, 4, 5, 8, 9, 11}),
    frozenset({0, 1, 4, 5, 8, 10, 11}),
    frozenset({0, 1, 4, 5, 9, 10, 11}),
    frozenset({0, 1, 4, 6, 7, 8, 9}),
    frozenset({0, 1, 4, 6, 7, 8, 10}),
    frozenset({0, 1, 4, 6, 7, 8, 11}),
    frozenset({0, 1, 4, 6, 7, 9, 10}),
    frozenset({0, 1, 4, 6, 7, 9, 11}),
    frozenset({0, 1, 4, 6, 7, 10, 11}),
    frozenset({0, 1, 4, 6, 8, 9, 10}),
    frozenset({0, 1, 4, 6, 8, 9, 11}),
    frozenset({0, 1, 4, 6, 8, 10, 11}),
    frozenset({0, 1, 4, 6, 9, 10, 11}),
    frozenset({0, 1, 4, 7, 8, 9, 10}),
    frozenset({0, 1, 4, 7, 8, 9, 11}),
    frozenset({0, 1, 4, 7, 8, 10, 11}),
    frozenset({0, 1, 4, 7, 9, 10, 11}),
    frozenset({0, 1, 4, 8, 9, 10, 11}),
    frozenset({0, 1, 5, 6, 7, 8, 9}),
    frozenset({0, 1, 5, 6, 7, 8, 10}),
    frozenset({0, 1, 5, 6, 7, 8, 11}),
    frozenset({0, 1, 5, 6, 7, 9, 10}),
    frozenset({0, 1, 5, 6, 7, 9, 11}),
    frozenset({0, 1, 5, 6, 7, 10, 11}),
    frozenset({0, 1, 5, 6, 8, 9, 10}),
    frozenset({0, 1, 5, 6, 8, 9, 11}),
    frozenset({0, 1, 5, 6, 8, 10, 11}),
    frozenset({0, 1, 5, 6, 9, 10, 11}),
    frozenset({0, 1, 5, 7, 8, 9, 10}),
    frozenset({0, 1, 5, 7, 8, 9, 11}),
    frozenset({0, 1, 5, 7, 8, 10, 11}),
    frozenset({0, 1, 5, 7, 9, 10, 11}),
    frozenset({0, 1, 5, 8, 9, 10, 11}),
    frozenset({0, 1, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 7}),
    frozenset({0, 2, 3, 4, 5, 6, 8}),
    frozenset({0, 2, 3, 4, 5, 6, 9}),
    frozenset({0, 2, 3, 4, 5, 6, 10}),
    frozenset({0, 2, 3, 4, 5, 6, 11}),
    frozenset({0, 2, 3, 4, 5, 7, 8}),
    frozenset({0, 2, 3, 4, 5, 7, 9}),
    frozenset({0, 2, 3, 4, 5, 7, 10}),
    frozenset({0, 2, 3, 4, 5, 7, 11}),
    frozenset({0, 2, 3, 4, 5, 8, 9}),
    frozenset({0, 2, 3, 4, 5, 8, 10}),
    frozenset({0, 2, 3, 4, 5, 8, 11}),
    frozenset({0, 2, 3, 4, 5, 9, 10}),
    frozenset({0, 2, 3, 4, 5, 9, 11}),
    frozenset({0, 2, 3, 4, 5, 10, 11}),
    frozenset({0, 2, 3, 4, 6, 7, 8}),
    frozenset({0, 2, 3, 4, 6, 7, 9}),
    frozenset({0, 2, 3, 4, 6, 7, 10}),
    frozenset({0, 2, 3, 4, 6, 7, 11}),
    frozenset({0, 2, 3, 4, 6, 8, 9}),
    frozenset({0, 2, 3, 4, 6, 8, 10}),
    frozenset({0, 2, 3, 4, 6, 8, 11}),
    frozenset({0, 2, 3, 4, 6, 9, 10}),
    frozenset({0, 2, 3, 4, 6, 9, 11}),
    frozenset({0, 2, 3, 4, 6, 10, 11}),
    frozenset({0, 2, 3, 4, 7, 8, 9}),
    frozenset({0, 2, 3, 4, 7, 8, 10}),
    frozenset({0, 2, 3, 4, 7, 8, 11}),
    frozenset({0, 2, 3, 4, 7, 9, 10}),
    frozenset({0, 2, 3, 4, 7, 9, 11}),
    frozenset({0, 2, 3, 4, 7, 10, 11}),
    frozenset({0, 2, 3, 4, 8, 9, 10}),
    frozenset({0, 2, 3, 4, 8, 9, 11}),
    frozenset({0, 2, 3, 4, 8, 10, 11}),
    frozenset({0, 2, 3, 4, 9, 10, 11}),
    frozenset({0, 2, 3, 5, 6, 7, 8}),
    frozenset({0, 2, 3, 5, 6, 7, 9}),
    frozenset({0, 2, 3, 5, 6, 7, 10}),
    frozenset({0, 2, 3, 5, 6, 7, 11}),
    frozenset({0, 2, 3, 5, 6, 8, 9}),
    frozenset({0, 2, 3, 5, 6, 8, 10}),
    frozenset({0, 2, 3, 5, 6, 8, 11}),
    frozenset({0, 2, 3, 5, 6, 9, 10}),
    frozenset({0, 2, 3, 5, 6, 9, 11}),
    frozenset({0, 2, 3, 5, 6, 10, 11}),
    frozenset({0, 2, 3, 5, 7, 8, 9}),
    frozenset({0, 2, 3, 5, 7, 8, 10}),
    frozenset({0, 2, 3, 5, 7, 8, 11}),
    frozenset({0, 2, 3, 5, 7, 9, 10}),
    frozenset({0, 2, 3, 5, 7, 9, 11}),
    frozenset({0, 2, 3, 5, 7, 10, 11}),
    frozenset({0, 2, 3, 5, 8, 9, 10}),
    frozenset({0, 2, 3, 5, 8, 9, 11}),
    frozenset({0, 2, 3, 5, 8, 10, 11}),
    frozenset({0, 2, 3, 5, 9, 10, 11}),
    frozenset({0, 2, 3, 6, 7, 8, 9}),
    frozenset({0, 2, 3, 6, 7, 8, 10}),
    frozenset({0, 2, 3, 6, 7, 8, 11}),
    frozenset({0, 2, 3, 6, 7, 9, 10}),
    frozenset({0, 2, 3, 6, 7, 9, 11}),
    frozenset({0, 2, 3, 6, 7, 10, 11}),
    frozenset({0, 2, 3, 6, 8, 9, 10}),
    frozenset({0, 2, 3, 6, 8, 9, 11}),
    frozenset({0, 2, 3, 6, 8, 10, 11}),
    frozenset({0, 2, 3, 6, 9, 10, 11}),
    frozenset({0, 2, 3, 7, 8, 9, 10}),
    frozenset({0, 2, 3, 7, 8, 9, 11}),
    frozenset({0, 2, 3, 7, 8, 10, 11}),
    frozenset({0, 2, 3, 7, 9, 10, 11}),
    frozenset({0, 2, 3, 8, 9, 10, 11}),
    frozenset({0, 2, 4, 5, 6, 7, 8}),
    frozenset({0, 2, 4, 5, 6, 7, 9}),
    frozenset({0, 2, 4, 5, 6, 7, 10}),
    frozenset({0, 2, 4, 5, 6, 7, 11}),
    frozenset({0, 2, 4, 5, 6, 8, 9}),
    frozenset({0, 2, 4, 5, 6, 8, 10}),
    frozenset({0, 2, 4, 5, 6, 8, 11}),
    frozenset({0, 2, 4, 5, 6, 9, 10}),
    frozenset({0, 2, 4, 5, 6, 9, 11}),
    frozenset({0, 2, 4, 5, 6, 10, 11}),
    frozenset({0, 2, 4, 5, 7, 8, 9}),
    frozenset({0, 2, 4, 5, 7, 8, 10}),
    frozenset({0, 2, 4, 5, 7, 8, 11}),
    frozenset({0, 2, 4, 5, 7, 9, 10}),
    frozenset({0, 2, 4, 5, 7, 9, 11}),
    frozenset({0, 2, 4, 5, 7, 10, 11}),
    frozenset({0, 2, 4, 5, 8, 9, 10}),
    frozenset({0, 2, 4, 5, 8, 9, 11}),
    frozenset({0, 2, 4, 5, 8, 10, 11}),
    frozenset({0, 2, 4, 5, 9, 10, 11}),
    frozenset({0, 2, 4, 6, 7, 8, 9}),
    frozenset({0, 2, 4, 6, 7, 8, 10}),
    frozenset({0, 2, 4, 6, 7, 8, 11}),
    frozenset({0, 2, 4, 6, 7, 9, 10}),
    frozenset({0, 2, 4, 6, 7, 9, 11}),
    frozenset({0, 2, 4, 6, 7, 10, 11}),
    frozenset({0, 2, 4, 6, 8, 9, 10}),
    frozenset({0, 2, 4, 6, 8, 9, 11}),
    frozenset({0, 2, 4, 6, 8, 10, 11}),
    frozenset({0, 2, 4, 6, 9, 10, 11}),
    frozenset({0, 2, 4, 7, 8, 9, 10}),
    frozenset({0, 2, 4, 7, 8, 9, 11}),
    frozenset({0, 2, 4, 7, 8, 10, 11}),
    frozenset({0, 2, 4, 7, 9, 10, 11}),
    frozenset({0, 2, 4, 8, 9, 10, 11}),
    frozenset({0, 2, 5, 6, 7, 8, 9}),
    frozenset({0, 2, 5, 6, 7, 8, 10}),
    frozenset({0, 2, 5, 6, 7, 8, 11}),
    frozenset({0, 2, 5, 6, 7, 9, 10}),
    frozenset({0, 2, 5, 6, 7, 9, 11}),
    frozenset({0, 2, 5, 6, 7, 10, 11}),
    frozenset({0, 2, 5, 6, 8, 9, 10}),
    frozenset({0, 2, 5, 6, 8, 9, 11}),
    frozenset({0, 2, 5, 6, 8, 10, 11}),
    frozenset({0, 2, 5, 6, 9, 10, 11}),
    frozenset({0, 2, 5, 7, 8, 9, 10}),
    frozenset({0, 2, 5, 7, 8, 9, 11}),
    frozenset({0, 2, 5, 7, 8, 10, 11}),
    frozenset({0, 2, 5, 7, 9, 10, 11}),
    frozenset({0, 2, 5, 8, 9, 10, 11}),
    frozenset({0, 2, 6, 7, 8, 9, 10}),
    frozenset({0, 2, 6, 7, 8, 9, 11}),
    frozenset({0, 2, 6, 7, 8, 10, 11}),
    frozenset({0, 2, 6, 7, 9, 10, 11}),
    frozenset({0, 2, 6, 8, 9, 10, 11}),
    frozenset({0, 2, 7, 8, 9, 10, 11}),
    frozenset({0, 3, 4, 5, 6, 7, 8}),
    frozenset({0, 3, 4, 5, 6, 7, 9}),
    frozenset({0, 3, 4, 5, 6, 7, 10}),
    frozenset({0, 3, 4, 5, 6, 7, 11}),
    frozenset({0, 3, 4, 5, 6, 8, 9}),
    frozenset({0, 3, 4, 5, 6, 8, 10}),
    frozenset({0, 3, 4, 5, 6, 8, 11}),
    frozenset({0, 3, 4, 5, 6, 9, 10}),
    frozenset({0, 3, 4, 5, 6, 9, 11}),
    frozenset({0, 3, 4, 5, 6, 10, 11}),
    frozenset({0, 3, 4, 5, 7, 8, 9}),
    frozenset({0, 3, 4, 5, 7, 8, 10}),
    frozenset({0, 3, 4, 5, 7, 8, 11}),
    frozenset({0, 3, 4, 5, 7, 9, 10}),
    frozenset({0, 3, 4, 5, 7, 9, 11}),
    frozenset({0, 3, 4, 5, 7, 10, 11}),
    frozenset({0, 3, 4, 5, 8, 9, 10}),
    frozenset({0, 3, 4, 5, 8, 9, 11}),
    frozenset({0, 3, 4, 5, 8, 10, 11}),
    frozenset({0, 3, 4, 5, 9, 10, 11}),
    frozenset({0, 3, 4, 6, 7, 8, 9}),
    frozenset({0, 3, 4, 6, 7, 8, 10}),
    frozenset({0, 3, 4, 6, 7, 8, 11}),
    frozenset({0, 3, 4, 6, 7, 9, 10}),
    frozenset({0, 3, 4, 6, 7, 9, 11}),
    frozenset({0, 3, 4, 6, 7, 10, 11}),
    frozenset({0, 3, 4, 6, 8, 9, 10}),
    frozenset({0, 3, 4, 6, 8, 9, 11}),
    frozenset({0, 3, 4, 6, 8, 10, 11}),
    frozenset({0, 3, 4, 6, 9, 10, 11}),
    frozenset({0, 3, 4, 7, 8, 9, 10}),
    frozenset({0, 3, 4, 7, 8, 9, 11}),
    frozenset({0, 3, 4, 7, 8, 10, 11}),
    frozenset({0, 3, 4, 7, 9, 10, 11}),
    frozenset({0, 3, 4, 8, 9, 10, 11}),
    frozenset({0, 3, 5, 6, 7, 8, 9}),
    frozenset({0, 3, 5, 6, 7, 8, 10}),
    frozenset({0, 3, 5, 6, 7, 8, 11}),
    frozenset({0, 3, 5, 6, 7, 9, 10}),
    frozenset({0, 3, 5, 6, 7, 9, 11}),
    frozenset({0, 3, 5, 6, 7, 10, 11}),
    frozenset({0, 3, 5, 6, 8, 9, 10}),
    frozenset({0, 3, 5, 6, 8, 9, 11}),
    frozenset({0, 3, 5, 6, 8, 10, 11}),
    frozenset({0, 3, 5, 6, 9, 10, 11}),
    frozenset({0, 3, 5, 7, 8, 9, 10}),
    frozenset({0, 3, 5, 7, 8, 9, 11}),
    frozenset({0, 3, 5, 7, 8, 10, 11}),
    frozenset({0, 3, 5, 7, 9, 10, 11}),
    frozenset({0, 3, 5, 8, 9, 10, 11}),
    frozenset({0, 3, 6, 7, 8, 9, 10}),
    frozenset({0, 3, 6, 7, 8, 9, 11}),
    frozenset({0, 3, 6, 7, 8, 10, 11}),
    frozenset({0, 3, 6, 7, 9, 10, 11}),
    frozenset({0, 3, 6, 8, 9, 10, 11}),
    frozenset({0, 3, 7, 8, 9, 10, 11}),
    frozenset({0, 4, 5, 6, 7, 8, 9}),
    frozenset({0, 4, 5, 6, 7, 8, 10}),
    frozenset({0, 4, 5, 6, 7, 8, 11}),
    frozenset({0, 4, 5, 6, 7, 9, 10}),
    frozenset({0, 4, 5, 6, 7, 9, 11}),
    frozenset({0, 4, 5, 6, 7, 10, 11}),
    frozenset({0, 4, 5, 6, 8, 9, 10}),
    frozenset({0, 4, 5, 6, 8, 9, 11}),
    frozenset({0, 4, 5, 6, 8, 10, 11}),
    frozenset({0, 4, 5, 6, 9, 10, 11}),
    frozenset({0, 4, 5, 7, 8, 9, 10}),
    frozenset({0, 4, 5, 7, 8, 9, 11}),
    frozenset({0, 4, 5, 7, 8, 10, 11}),
    frozenset({0, 4, 5, 7, 9, 10, 11}),
    frozenset({0, 4, 5, 8, 9, 10, 11}),
    frozenset({0, 4, 6, 7, 8, 9, 10}),
    frozenset({0, 4, 6, 7, 8, 9, 11}),
    frozenset({0, 4, 6, 7, 8, 10, 11}),
    frozenset({0, 4, 6, 7, 9, 10, 11}),
    frozenset({0, 4, 6, 8, 9, 10, 11}),
    frozenset({0, 4, 7, 8, 9, 10, 11}),
    frozenset({0, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 7}),
    frozenset({1, 2, 3, 4, 5, 6, 8}),
    frozenset({1, 2, 3, 4, 5, 6, 9}),
    frozenset({1, 2, 3, 4, 5, 6, 10}),
    frozenset({1, 2, 3, 4, 5, 6, 11}),
    frozenset({1, 2, 3, 4, 5, 7, 8}),
    frozenset({1, 2, 3, 4, 5, 7, 9}),
    frozenset({1, 2, 3, 4, 5, 7, 10}),
    frozenset({1, 2, 3, 4, 5, 7, 11}),
    frozenset({1, 2, 3, 4, 5, 8, 9}),
    frozenset({1, 2, 3, 4, 5, 8, 10}),
    frozenset({1, 2, 3, 4, 5, 8, 11}),
    frozenset({1, 2, 3, 4, 5, 9, 10}),
    frozenset({1, 2, 3, 4, 5, 9, 11}),
    frozenset({1, 2, 3, 4, 5, 10, 11}),
    frozenset({1, 2, 3, 4, 6, 7, 8}),
    frozenset({1, 2, 3, 4, 6, 7, 9}),
    frozenset({1, 2, 3, 4, 6, 7, 10}),
    frozenset({1, 2, 3, 4, 6, 7, 11}),
    frozenset({1, 2, 3, 4, 6, 8, 9}),
    frozenset({1, 2, 3, 4, 6, 8, 10}),
    frozenset({1, 2, 3, 4, 6, 8, 11}),
    frozenset({1, 2, 3, 4, 6, 9, 10}),
    frozenset({1, 2, 3, 4, 6, 9, 11}),
    frozenset({1, 2, 3, 4, 6, 10, 11}),
    frozenset({1, 2, 3, 4, 7, 8, 9}),
    frozenset({1, 2, 3, 4, 7, 8, 10}),
    frozenset({1, 2, 3, 4, 7, 8, 11}),
    frozenset({1, 2, 3, 4, 7, 9, 10}),
    frozenset({1, 2, 3, 4, 7, 9, 11}),
    frozenset({1, 2, 3, 4, 7, 10, 11}),
    frozenset({1, 2, 3, 4, 8, 9, 10}),
    frozenset({1, 2, 3, 4, 8, 9, 11}),
    frozenset({1, 2, 3, 4, 8, 10, 11}),
    frozenset({1, 2, 3, 4, 9, 10, 11}),
    frozenset({1, 2, 3, 5, 6, 7, 8}),
    frozenset({1, 2, 3, 5, 6, 7, 9}),
    frozenset({1, 2, 3, 5, 6, 7, 10}),
    frozenset({1, 2, 3, 5, 6, 7, 11}),
    frozenset({1, 2, 3, 5, 6, 8, 9}),
    frozenset({1, 2, 3, 5, 6, 8, 10}),
    frozenset({1, 2, 3, 5, 6, 8, 11}),
    frozenset({1, 2, 3, 5, 6, 9, 10}),
    frozenset({1, 2, 3, 5, 6, 9, 11}),
    frozenset({1, 2, 3, 5, 6, 10, 11}),
    frozenset({1, 2, 3, 5, 7, 8, 9}),
    frozenset({1, 2, 3, 5, 7, 8, 10}),
    frozenset({1, 2, 3, 5, 7, 8, 11}),
    frozenset({1, 2, 3, 5, 7, 9, 10}),
    frozenset({1, 2, 3, 5, 7, 9, 11}),
    frozenset({1, 2, 3, 5, 7, 10, 11}),
    frozenset({1, 2, 3, 5, 8, 9, 10}),
    frozenset({1, 2, 3, 5, 8, 9, 11}),
    frozenset({1, 2, 3, 5, 8, 10, 11}),
    frozenset({1, 2, 3, 5, 9, 10, 11}),
    frozenset({1, 2, 3, 6, 7, 8, 9}),
    frozenset({1, 2, 3, 6, 7, 8, 10}),
    frozenset({1, 2, 3, 6, 7, 8, 11}),
    frozenset({1, 2, 3, 6, 7, 9, 10}),
    frozenset({1, 2, 3, 6, 7, 9, 11}),
    frozenset({1, 2, 3, 6, 7, 10, 11}),
    frozenset({1, 2, 3, 6, 8, 9, 10}),
    frozenset({1, 2, 3, 6, 8, 9, 11}),
    frozenset({1, 2, 3, 6, 8, 10, 11}),
    frozenset({1, 2, 3, 6, 9, 10, 11}),
    frozenset({1, 2, 3, 7, 8, 9, 10}),
    frozenset({1, 2, 3, 7, 8, 9, 11}),
    frozenset({1, 2, 3, 7, 8, 10, 11}),
    frozenset({1, 2, 3, 7, 9, 10, 11}),
    frozenset({1, 2, 3, 8, 9, 10, 11}),
    frozenset({1, 2, 4, 5, 6, 7, 8}),
    frozenset({1, 2, 4, 5, 6, 7, 9}),
    frozenset({1, 2, 4, 5, 6, 7, 10}),
    frozenset({1, 2, 4, 5, 6, 7, 11}),
    frozenset({1, 2, 4, 5, 6, 8, 9}),
    frozenset({1, 2, 4, 5, 6, 8, 10}),
    frozenset({1, 2, 4, 5, 6, 8, 11}),
    frozenset({1, 2, 4, 5, 6, 9, 10}),
    frozenset({1, 2, 4, 5, 6, 9, 11}),
    frozenset({1, 2, 4, 5, 6, 10, 11}),
    frozenset({1, 2, 4, 5, 7, 8, 9}),
    frozenset({1, 2, 4, 5, 7, 8, 10}),
    frozenset({1, 2, 4, 5, 7, 8, 11}),
    frozenset({1, 2, 4, 5, 7, 9, 10}),
    frozenset({1, 2, 4, 5, 7, 9, 11}),
    frozenset({1, 2, 4, 5, 7, 10, 11}),
    frozenset({1, 2, 4, 5, 8, 9, 10}),
    frozenset({1, 2, 4, 5, 8, 9, 11}),
    frozenset({1, 2, 4, 5, 8, 10, 11}),
    frozenset({1, 2, 4, 5, 9, 10, 11}),
    frozenset({1, 2, 4, 6, 7, 8, 9}),
    frozenset({1, 2, 4, 6, 7, 8, 10}),
    frozenset({1, 2, 4, 6, 7, 8, 11}),
    frozenset({1, 2, 4, 6, 7, 9, 10}),
    frozenset({1, 2, 4, 6, 7, 9, 11}),
    frozenset({1, 2, 4, 6, 7, 10, 11}),
    frozenset({1, 2, 4, 6, 8, 9, 10}),
    frozenset({1, 2, 4, 6, 8, 9, 11}),
    frozenset({1, 2, 4, 6, 8, 10, 11}),
    frozenset({1, 2, 4, 6, 9, 10, 11}),
    frozenset({1, 2, 4, 7, 8, 9, 10}),
    frozenset({1, 2, 4, 7, 8, 9, 11}),
    frozenset({1, 2, 4, 7, 8, 10, 11}),
    frozenset({1, 2, 4, 7, 9, 10, 11}),
    frozenset({1, 2, 4, 8, 9, 10, 11}),
    frozenset({1, 2, 5, 6, 7, 8, 9}),
    frozenset({1, 2, 5, 6, 7, 8, 10}),
    frozenset({1, 2, 5, 6, 7, 8, 11}),
    frozenset({1, 2, 5, 6, 7, 9, 10}),
    frozenset({1, 2, 5, 6, 7, 9, 11}),
    frozenset({1, 2, 5, 6, 7, 10, 11}),
    frozenset({1, 2, 5, 6, 8, 9, 10}),
    frozenset({1, 2, 5, 6, 8, 9, 11}),
    frozenset({1, 2, 5, 6, 8, 10, 11}),
    frozenset({1, 2, 5, 6, 9, 10, 11}),
    frozenset({1, 2, 5, 7, 8, 9, 10}),
    frozenset({1, 2, 5, 7, 8, 9, 11}),
    frozenset({1, 2, 5, 7, 8, 10, 11}),
    frozenset({1, 2, 5, 7, 9, 10, 11}),
    frozenset({1, 2, 5, 8, 9, 10, 11}),
    frozenset({1, 2, 6, 7, 8, 9, 10}),
    frozenset({1, 2, 6, 7, 8, 9, 11}),
    frozenset({1, 2, 6, 7, 8, 10, 11}),
    frozenset({1, 2, 6, 7, 9, 10, 11}),
    frozenset({1, 2, 6, 8, 9, 10, 11}),
    frozenset({1, 2, 7, 8, 9, 10, 11}),
    frozenset({1, 3, 4, 5, 6, 7, 8}),
    frozenset({1, 3, 4, 5, 6, 7, 9}),
    frozenset({1, 3, 4, 5, 6, 7, 10}),
    frozenset({1, 3, 4, 5, 6, 7, 11}),
    frozenset({1, 3, 4, 5, 6, 8, 9}),
    frozenset({1, 3, 4, 5, 6, 8, 10}),
    frozenset({1, 3, 4, 5, 6, 8, 11}),
    frozenset({1, 3, 4, 5, 6, 9, 10}),
    frozenset({1, 3, 4, 5, 6, 9, 11}),
    frozenset({1, 3, 4, 5, 6, 10, 11}),
    frozenset({1, 3, 4, 5, 7, 8, 9}),
    frozenset({1, 3, 4, 5, 7, 8, 10}),
    frozenset({1, 3, 4, 5, 7, 8, 11}),
    frozenset({1, 3, 4, 5, 7, 9, 10}),
    frozenset({1, 3, 4, 5, 7, 9, 11}),
    frozenset({1, 3, 4, 5, 7, 10, 11}),
    frozenset({1, 3, 4, 5, 8, 9, 10}),
    frozenset({1, 3, 4, 5, 8, 9, 11}),
    frozenset({1, 3, 4, 5, 8, 10, 11}),
    frozenset({1, 3, 4, 5, 9, 10, 11}),
    frozenset({1, 3, 4, 6, 7, 8, 9}),
    frozenset({1, 3, 4, 6, 7, 8, 10}),
    frozenset({1, 3, 4, 6, 7, 8, 11}),
    frozenset({1, 3, 4, 6, 7, 9, 10}),
    frozenset({1, 3, 4, 6, 7, 9, 11}),
    frozenset({1, 3, 4, 6, 7, 10, 11}),
    frozenset({1, 3, 4, 6, 8, 9, 10}),
    frozenset({1, 3, 4, 6, 8, 9, 11}),
    frozenset({1, 3, 4, 6, 8, 10, 11}),
    frozenset({1, 3, 4, 6, 9, 10, 11}),
    frozenset({1, 3, 4, 7, 8, 9, 10}),
    frozenset({1, 3, 4, 7, 8, 9, 11}),
    frozenset({1, 3, 4, 7, 8, 10, 11}),
    frozenset({1, 3, 4, 7, 9, 10, 11}),
    frozenset({1, 3, 4, 8, 9, 10, 11}),
    frozenset({1, 3, 5, 6, 7, 8, 9}),
    frozenset({1, 3, 5, 6, 7, 8, 10}),
    frozenset({1, 3, 5, 6, 7, 8, 11}),
    frozenset({1, 3, 5, 6, 7, 9, 10}),
    frozenset({1, 3, 5, 6, 7, 9, 11}),
    frozenset({1, 3, 5, 6, 7, 10, 11}),
    frozenset({1, 3, 5, 6, 8, 9, 10}),
    frozenset({1, 3, 5, 6, 8, 9, 11}),
    frozenset({1, 3, 5, 6, 8, 10, 11}),
    frozenset({1, 3, 5, 6, 9, 10, 11}),
    frozenset({1, 3, 5, 7, 8, 9, 10}),
    frozenset({1, 3, 5, 7, 8, 9, 11}),
    frozenset({1, 3, 5, 7, 8, 10, 11}),
    frozenset({1, 3, 5, 7, 9, 10, 11}),
    frozenset({1, 3, 5, 8, 9, 10, 11}),
    frozenset({1, 3, 6, 7, 8, 9, 10}),
    frozenset({1, 3, 6, 7, 8, 9, 11}),
    frozenset({1, 3, 6, 7, 8, 10, 11}),
    frozenset({1, 3, 6, 7, 9, 10, 11}),
    frozenset({1, 3, 6, 8, 9, 10, 11}),
    frozenset({1, 3, 7, 8, 9, 10, 11}),
    frozenset({1, 4, 5, 6, 7, 8, 9}),
    frozenset({1, 4, 5, 6, 7, 8, 10}),
    frozenset({1, 4, 5, 6, 7, 8, 11}),
    frozenset({1, 4, 5, 6, 7, 9, 10}),
    frozenset({1, 4, 5, 6, 7, 9, 11}),
    frozenset({1, 4, 5, 6, 7, 10, 11}),
    frozenset({1, 4, 5, 6, 8, 9, 10}),
    frozenset({1, 4, 5, 6, 8, 9, 11}),
    frozenset({1, 4, 5, 6, 8, 10, 11}),
    frozenset({1, 4, 5, 6, 9, 10, 11}),
    frozenset({1, 4, 5, 7, 8, 9, 10}),
    frozenset({1, 4, 5, 7, 8, 9, 11}),
    frozenset({1, 4, 5, 7, 8, 10, 11}),
    frozenset({1, 4, 5, 7, 9, 10, 11}),
    frozenset({1, 4, 5, 8, 9, 10, 11}),
    frozenset({1, 4, 6, 7, 8, 9, 10}),
    frozenset({1, 4, 6, 7, 8, 9, 11}),
    frozenset({1, 4, 6, 7, 8, 10, 11}),
    frozenset({1, 4, 6, 7, 9, 10, 11}),
    frozenset({1, 4, 6, 8, 9, 10, 11}),
    frozenset({1, 4, 7, 8, 9, 10, 11}),
    frozenset({1, 5, 6, 7, 8, 9, 10}),
    frozenset({1, 5, 6, 7, 8, 9, 11}),
    frozenset({1, 5, 6, 7, 8, 10, 11}),
    frozenset({1, 5, 6, 7, 9, 10, 11}),
    frozenset({1, 5, 6, 8, 9, 10, 11}),
    frozenset({1, 5, 7, 8, 9, 10, 11}),
    frozenset({1, 6, 7, 8, 9, 10, 11}),
    frozenset({2, 3, 4, 5, 6, 7, 8}),
    frozenset({2, 3, 4, 5, 6, 7, 9}),
    frozenset({2, 3, 4, 5, 6, 7, 10}),
    frozenset({2, 3, 4, 5, 6, 7, 11}),
    frozenset({2, 3, 4, 5, 6, 8, 9}),
    frozenset({2, 3, 4, 5, 6, 8, 10}),
    frozenset({2, 3, 4, 5, 6, 8, 11}),
    frozenset({2, 3, 4, 5, 6, 9, 10}),
    frozenset({2, 3, 4, 5, 6, 9, 11}),
    frozenset({2, 3, 4, 5, 6, 10, 11}),
    frozenset({2, 3, 4, 5, 7, 8, 9}),
    frozenset({2, 3, 4, 5, 7, 8, 10}),
    frozenset({2, 3, 4, 5, 7, 8, 11}),
    frozenset({2, 3, 4, 5, 7, 9, 10}),
    frozenset({2, 3, 4, 5, 7, 9, 11}),
    frozenset({2, 3, 4, 5, 7, 10, 11}),
    frozenset({2, 3, 4, 5, 8, 9, 10}),
    frozenset({2, 3, 4, 5, 8, 9, 11}),
    frozenset({2, 3, 4, 5, 8, 10, 11}),
    frozenset({2, 3, 4, 5, 9, 10, 11}),
    frozenset({2, 3, 4, 6, 7, 8, 9}),
    frozenset({2, 3, 4, 6, 7, 8, 10}),
    frozenset({2, 3, 4, 6, 7, 8, 11}),
    frozenset({2, 3, 4, 6, 7, 9, 10}),
    frozenset({2, 3, 4, 6, 7, 9, 11}),
    frozenset({2, 3, 4, 6, 7, 10, 11}),
    frozenset({2, 3, 4, 6, 8, 9, 10}),
    frozenset({2, 3, 4, 6, 8, 9, 11}),
    frozenset({2, 3, 4, 6, 8, 10, 11}),
    frozenset({2, 3, 4, 6, 9, 10, 11}),
    frozenset({2, 3, 4, 7, 8, 9, 10}),
    frozenset({2, 3, 4, 7, 8, 9, 11}),
    frozenset({2, 3, 4, 7, 8, 10, 11}),
    frozenset({2, 3, 4, 7, 9, 10, 11}),
    frozenset({2, 3, 4, 8, 9, 10, 11}),
    frozenset({2, 3, 5, 6, 7, 8, 9}),
    frozenset({2, 3, 5, 6, 7, 8, 10}),
    frozenset({2, 3, 5, 6, 7, 8, 11}),
    frozenset({2, 3, 5, 6, 7, 9, 10}),
    frozenset({2, 3, 5, 6, 7, 9, 11}),
    frozenset({2, 3, 5, 6, 7, 10, 11}),
    frozenset({2, 3, 5, 6, 8, 9, 10}),
    frozenset({2, 3, 5, 6, 8, 9, 11}),
    frozenset({2, 3, 5, 6, 8, 10, 11}),
    frozenset({2, 3, 5, 6, 9, 10, 11}),
    frozenset({2, 3, 5, 7, 8, 9, 10}),
    frozenset({2, 3, 5, 7, 8, 9, 11}),
    frozenset({2, 3, 5, 7, 8, 10, 11}),
    frozenset({2, 3, 5, 7, 9, 10, 11}),
    frozenset({2, 3, 5, 8, 9, 10, 11}),
    frozenset({2, 3, 6, 7, 8, 9, 10}),
    frozenset({2, 3, 6, 7, 8, 9, 11}),
    frozenset({2, 3, 6, 7, 8, 10, 11}),
    frozenset({2, 3, 6, 7, 9, 10, 11}),
    frozenset({2, 3, 6, 8, 9, 10, 11}),
    frozenset({2, 3, 7, 8, 9, 10, 11}),
    frozenset({2, 4, 5, 6, 7, 8, 9}),
    frozenset({2, 4, 5, 6, 7, 8, 10}),
    frozenset({2, 4, 5, 6, 7, 8, 11}),
    frozenset({2, 4, 5, 6, 7, 9, 10}),
    frozenset({2, 4, 5, 6, 7, 9, 11}),
    frozenset({2, 4, 5, 6, 7, 10, 11}),
    frozenset({2, 4, 5, 6, 8, 9, 10}),
    frozenset({2, 4, 5, 6, 8, 9, 11}),
    frozenset({2, 4, 5, 6, 8, 10, 11}),
    frozenset({2, 4, 5, 6, 9, 10, 11}),
    frozenset({2, 4, 5, 7, 8, 9, 10}),
    frozenset({2, 4, 5, 7, 8, 9, 11}),
    frozenset({2, 4, 5, 7, 8, 10, 11}),
    frozenset({2, 4, 5, 7, 9, 10, 11}),
    frozenset({2, 4, 5, 8, 9, 10, 11}),
    frozenset({2, 4, 6, 7, 8, 9, 10}),
    frozenset({2, 4, 6, 7, 8, 9, 11}),
    frozenset({2, 4, 6, 7, 8, 10, 11}),
    frozenset({2, 4, 6, 7, 9, 10, 11}),
    frozenset({2, 4, 6, 8, 9, 10, 11}),
    frozenset({2, 4, 7, 8, 9, 10, 11}),
    frozenset({2, 5, 6, 7, 8, 9, 10}),
    frozenset({2, 5, 6, 7, 8, 9, 11}),
    frozenset({2, 5, 6, 7, 8, 10, 11}),
    frozenset({2, 5, 6, 7, 9, 10, 11}),
    frozenset({2, 5, 6, 8, 9, 10, 11}),
    frozenset({2, 5, 7, 8, 9, 10, 11}),
    frozenset({2, 6, 7, 8, 9, 10, 11}),
    frozenset({3, 4, 5, 6, 7, 8, 9}),
    frozenset({3, 4, 5, 6, 7, 8, 10}),
    frozenset({3, 4, 5, 6, 7, 8, 11}),
    frozenset({3, 4, 5, 6, 7, 9, 10}),
    frozenset({3, 4, 5, 6, 7, 9, 11}),
    frozenset({3, 4, 5, 6, 7, 10, 11}),
    frozenset({3, 4, 5, 6, 8, 9, 10}),
    frozenset({3, 4, 5, 6, 8, 9, 11}),
    frozenset({3, 4, 5, 6, 8, 10, 11}),
    frozenset({3, 4, 5, 6, 9, 10, 11}),
    frozenset({3, 4, 5, 7, 8, 9, 10}),
    frozenset({3, 4, 5, 7, 8, 9, 11}),
    frozenset({3, 4, 5, 7, 8, 10, 11}),
    frozenset({3, 4, 5, 7, 9, 10, 11}),
    frozenset({3, 4, 5, 8, 9, 10, 11}),
    frozenset({3, 4, 6, 7, 8, 9, 10}),
    frozenset({3, 4, 6, 7, 8, 9, 11}),
    frozenset({3, 4, 6, 7, 8, 10, 11}),
    frozenset({3, 4, 6, 7, 9, 10, 11}),
    frozenset({3, 4, 6, 8, 9, 10, 11}),
    frozenset({3, 4, 7, 8, 9, 10, 11}),
    frozenset({3, 5, 6, 7, 8, 9, 10}),
    frozenset({3, 5, 6, 7, 8, 9, 11}),
    frozenset({3, 5, 6, 7, 8, 10, 11}),
    frozenset({3, 5, 6, 7, 9, 10, 11}),
    frozenset({3, 5, 6, 8, 9, 10, 11}),
    frozenset({3, 5, 7, 8, 9, 10, 11}),
    frozenset({3, 6, 7, 8, 9, 10, 11}),
    frozenset({4, 5, 6, 7, 8, 9, 10}),
    frozenset({4, 5, 6, 7, 8, 9, 11}),
    frozenset({4, 5, 6, 7, 8, 10, 11}),
    frozenset({4, 5, 6, 7, 9, 10, 11}),
    frozenset({4, 5, 6, 8, 9, 10, 11}),
    frozenset({4, 5, 7, 8, 9, 10, 11}),
    frozenset({4, 6, 7, 8, 9, 10, 11}),
    frozenset({5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 8}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 9}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 8}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 9}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 8, 9}),
    frozenset({0, 1, 2, 3, 4, 5, 8, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 8, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 8}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 9}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 10}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 8, 9}),
    frozenset({0, 1, 2, 3, 4, 6, 8, 10}),
    frozenset({0, 1, 2, 3, 4, 6, 8, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 6, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 7, 8, 9}),
    frozenset({0, 1, 2, 3, 4, 7, 8, 10}),
    frozenset({0, 1, 2, 3, 4, 7, 8, 11}),
    frozenset({0, 1, 2, 3, 4, 7, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 7, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 7, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 8}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 9}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 10}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 8, 9}),
    frozenset({0, 1, 2, 3, 5, 6, 8, 10}),
    frozenset({0, 1, 2, 3, 5, 6, 8, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 9, 10}),
    frozenset({0, 1, 2, 3, 5, 6, 9, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 7, 8, 9}),
    frozenset({0, 1, 2, 3, 5, 7, 8, 10}),
    frozenset({0, 1, 2, 3, 5, 7, 8, 11}),
    frozenset({0, 1, 2, 3, 5, 7, 9, 10}),
    frozenset({0, 1, 2, 3, 5, 7, 9, 11}),
    frozenset({0, 1, 2, 3, 5, 7, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 5, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 5, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 6, 7, 8, 9}),
    frozenset({0, 1, 2, 3, 6, 7, 8, 10}),
    frozenset({0, 1, 2, 3, 6, 7, 8, 11}),
    frozenset({0, 1, 2, 3, 6, 7, 9, 10}),
    frozenset({0, 1, 2, 3, 6, 7, 9, 11}),
    frozenset({0, 1, 2, 3, 6, 7, 10, 11}),
    frozenset({0, 1, 2, 3, 6, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 6, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 6, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 6, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 8}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 9}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 10}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 8, 9}),
    frozenset({0, 1, 2, 4, 5, 6, 8, 10}),
    frozenset({0, 1, 2, 4, 5, 6, 8, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 9, 10}),
    frozenset({0, 1, 2, 4, 5, 6, 9, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 7, 8, 9}),
    frozenset({0, 1, 2, 4, 5, 7, 8, 10}),
    frozenset({0, 1, 2, 4, 5, 7, 8, 11}),
    frozenset({0, 1, 2, 4, 5, 7, 9, 10}),
    frozenset({0, 1, 2, 4, 5, 7, 9, 11}),
    frozenset({0, 1, 2, 4, 5, 7, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 8, 9, 10}),
    frozenset({0, 1, 2, 4, 5, 8, 9, 11}),
    frozenset({0, 1, 2, 4, 5, 8, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 6, 7, 8, 9}),
    frozenset({0, 1, 2, 4, 6, 7, 8, 10}),
    frozenset({0, 1, 2, 4, 6, 7, 8, 11}),
    frozenset({0, 1, 2, 4, 6, 7, 9, 10}),
    frozenset({0, 1, 2, 4, 6, 7, 9, 11}),
    frozenset({0, 1, 2, 4, 6, 7, 10, 11}),
    frozenset({0, 1, 2, 4, 6, 8, 9, 10}),
    frozenset({0, 1, 2, 4, 6, 8, 9, 11}),
    frozenset({0, 1, 2, 4, 6, 8, 10, 11}),
    frozenset({0, 1, 2, 4, 6, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 4, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 4, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 4, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 5, 6, 7, 8, 9}),
    frozenset({0, 1, 2, 5, 6, 7, 8, 10}),
    frozenset({0, 1, 2, 5, 6, 7, 8, 11}),
    frozenset({0, 1, 2, 5, 6, 7, 9, 10}),
    frozenset({0, 1, 2, 5, 6, 7, 9, 11}),
    frozenset({0, 1, 2, 5, 6, 7, 10, 11}),
    frozenset({0, 1, 2, 5, 6, 8, 9, 10}),
    frozenset({0, 1, 2, 5, 6, 8, 9, 11}),
    frozenset({0, 1, 2, 5, 6, 8, 10, 11}),
    frozenset({0, 1, 2, 5, 6, 9, 10, 11}),
    frozenset({0, 1, 2, 5, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 5, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 5, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 5, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 5, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 8}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 9}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 10}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 8, 9}),
    frozenset({0, 1, 3, 4, 5, 6, 8, 10}),
    frozenset({0, 1, 3, 4, 5, 6, 8, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 9, 10}),
    frozenset({0, 1, 3, 4, 5, 6, 9, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 7, 8, 9}),
    frozenset({0, 1, 3, 4, 5, 7, 8, 10}),
    frozenset({0, 1, 3, 4, 5, 7, 8, 11}),
    frozenset({0, 1, 3, 4, 5, 7, 9, 10}),
    frozenset({0, 1, 3, 4, 5, 7, 9, 11}),
    frozenset({0, 1, 3, 4, 5, 7, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 8, 9, 10}),
    frozenset({0, 1, 3, 4, 5, 8, 9, 11}),
    frozenset({0, 1, 3, 4, 5, 8, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 6, 7, 8, 9}),
    frozenset({0, 1, 3, 4, 6, 7, 8, 10}),
    frozenset({0, 1, 3, 4, 6, 7, 8, 11}),
    frozenset({0, 1, 3, 4, 6, 7, 9, 10}),
    frozenset({0, 1, 3, 4, 6, 7, 9, 11}),
    frozenset({0, 1, 3, 4, 6, 7, 10, 11}),
    frozenset({0, 1, 3, 4, 6, 8, 9, 10}),
    frozenset({0, 1, 3, 4, 6, 8, 9, 11}),
    frozenset({0, 1, 3, 4, 6, 8, 10, 11}),
    frozenset({0, 1, 3, 4, 6, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 7, 8, 9, 10}),
    frozenset({0, 1, 3, 4, 7, 8, 9, 11}),
    frozenset({0, 1, 3, 4, 7, 8, 10, 11}),
    frozenset({0, 1, 3, 4, 7, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 5, 6, 7, 8, 9}),
    frozenset({0, 1, 3, 5, 6, 7, 8, 10}),
    frozenset({0, 1, 3, 5, 6, 7, 8, 11}),
    frozenset({0, 1, 3, 5, 6, 7, 9, 10}),
    frozenset({0, 1, 3, 5, 6, 7, 9, 11}),
    frozenset({0, 1, 3, 5, 6, 7, 10, 11}),
    frozenset({0, 1, 3, 5, 6, 8, 9, 10}),
    frozenset({0, 1, 3, 5, 6, 8, 9, 11}),
    frozenset({0, 1, 3, 5, 6, 8, 10, 11}),
    frozenset({0, 1, 3, 5, 6, 9, 10, 11}),
    frozenset({0, 1, 3, 5, 7, 8, 9, 10}),
    frozenset({0, 1, 3, 5, 7, 8, 9, 11}),
    frozenset({0, 1, 3, 5, 7, 8, 10, 11}),
    frozenset({0, 1, 3, 5, 7, 9, 10, 11}),
    frozenset({0, 1, 3, 5, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 3, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 3, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 3, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 3, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 4, 5, 6, 7, 8, 9}),
    frozenset({0, 1, 4, 5, 6, 7, 8, 10}),
    frozenset({0, 1, 4, 5, 6, 7, 8, 11}),
    frozenset({0, 1, 4, 5, 6, 7, 9, 10}),
    frozenset({0, 1, 4, 5, 6, 7, 9, 11}),
    frozenset({0, 1, 4, 5, 6, 7, 10, 11}),
    frozenset({0, 1, 4, 5, 6, 8, 9, 10}),
    frozenset({0, 1, 4, 5, 6, 8, 9, 11}),
    frozenset({0, 1, 4, 5, 6, 8, 10, 11}),
    frozenset({0, 1, 4, 5, 6, 9, 10, 11}),
    frozenset({0, 1, 4, 5, 7, 8, 9, 10}),
    frozenset({0, 1, 4, 5, 7, 8, 9, 11}),
    frozenset({0, 1, 4, 5, 7, 8, 10, 11}),
    frozenset({0, 1, 4, 5, 7, 9, 10, 11}),
    frozenset({0, 1, 4, 5, 8, 9, 10, 11}),
    frozenset({0, 1, 4, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 4, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 4, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 4, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 4, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 4, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 8}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 9}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 10}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 8, 9}),
    frozenset({0, 2, 3, 4, 5, 6, 8, 10}),
    frozenset({0, 2, 3, 4, 5, 6, 8, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 9, 10}),
    frozenset({0, 2, 3, 4, 5, 6, 9, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 7, 8, 9}),
    frozenset({0, 2, 3, 4, 5, 7, 8, 10}),
    frozenset({0, 2, 3, 4, 5, 7, 8, 11}),
    frozenset({0, 2, 3, 4, 5, 7, 9, 10}),
    frozenset({0, 2, 3, 4, 5, 7, 9, 11}),
    frozenset({0, 2, 3, 4, 5, 7, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 8, 9, 10}),
    frozenset({0, 2, 3, 4, 5, 8, 9, 11}),
    frozenset({0, 2, 3, 4, 5, 8, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 6, 7, 8, 9}),
    frozenset({0, 2, 3, 4, 6, 7, 8, 10}),
    frozenset({0, 2, 3, 4, 6, 7, 8, 11}),
    frozenset({0, 2, 3, 4, 6, 7, 9, 10}),
    frozenset({0, 2, 3, 4, 6, 7, 9, 11}),
    frozenset({0, 2, 3, 4, 6, 7, 10, 11}),
    frozenset({0, 2, 3, 4, 6, 8, 9, 10}),
    frozenset({0, 2, 3, 4, 6, 8, 9, 11}),
    frozenset({0, 2, 3, 4, 6, 8, 10, 11}),
    frozenset({0, 2, 3, 4, 6, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 7, 8, 9, 10}),
    frozenset({0, 2, 3, 4, 7, 8, 9, 11}),
    frozenset({0, 2, 3, 4, 7, 8, 10, 11}),
    frozenset({0, 2, 3, 4, 7, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 5, 6, 7, 8, 9}),
    frozenset({0, 2, 3, 5, 6, 7, 8, 10}),
    frozenset({0, 2, 3, 5, 6, 7, 8, 11}),
    frozenset({0, 2, 3, 5, 6, 7, 9, 10}),
    frozenset({0, 2, 3, 5, 6, 7, 9, 11}),
    frozenset({0, 2, 3, 5, 6, 7, 10, 11}),
    frozenset({0, 2, 3, 5, 6, 8, 9, 10}),
    frozenset({0, 2, 3, 5, 6, 8, 9, 11}),
    frozenset({0, 2, 3, 5, 6, 8, 10, 11}),
    frozenset({0, 2, 3, 5, 6, 9, 10, 11}),
    frozenset({0, 2, 3, 5, 7, 8, 9, 10}),
    frozenset({0, 2, 3, 5, 7, 8, 9, 11}),
    frozenset({0, 2, 3, 5, 7, 8, 10, 11}),
    frozenset({0, 2, 3, 5, 7, 9, 10, 11}),
    frozenset({0, 2, 3, 5, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 6, 7, 8, 9, 10}),
    frozenset({0, 2, 3, 6, 7, 8, 9, 11}),
    frozenset({0, 2, 3, 6, 7, 8, 10, 11}),
    frozenset({0, 2, 3, 6, 7, 9, 10, 11}),
    frozenset({0, 2, 3, 6, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 4, 5, 6, 7, 8, 9}),
    frozenset({0, 2, 4, 5, 6, 7, 8, 10}),
    frozenset({0, 2, 4, 5, 6, 7, 8, 11}),
    frozenset({0, 2, 4, 5, 6, 7, 9, 10}),
    frozenset({0, 2, 4, 5, 6, 7, 9, 11}),
    frozenset({0, 2, 4, 5, 6, 7, 10, 11}),
    frozenset({0, 2, 4, 5, 6, 8, 9, 10}),
    frozenset({0, 2, 4, 5, 6, 8, 9, 11}),
    frozenset({0, 2, 4, 5, 6, 8, 10, 11}),
    frozenset({0, 2, 4, 5, 6, 9, 10, 11}),
    frozenset({0, 2, 4, 5, 7, 8, 9, 10}),
    frozenset({0, 2, 4, 5, 7, 8, 9, 11}),
    frozenset({0, 2, 4, 5, 7, 8, 10, 11}),
    frozenset({0, 2, 4, 5, 7, 9, 10, 11}),
    frozenset({0, 2, 4, 5, 8, 9, 10, 11}),
    frozenset({0, 2, 4, 6, 7, 8, 9, 10}),
    frozenset({0, 2, 4, 6, 7, 8, 9, 11}),
    frozenset({0, 2, 4, 6, 7, 8, 10, 11}),
    frozenset({0, 2, 4, 6, 7, 9, 10, 11}),
    frozenset({0, 2, 4, 6, 8, 9, 10, 11}),
    frozenset({0, 2, 4, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 2, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 2, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 2, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 2, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 2, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 3, 4, 5, 6, 7, 8, 9}),
    frozenset({0, 3, 4, 5, 6, 7, 8, 10}),
    frozenset({0, 3, 4, 5, 6, 7, 8, 11}),
    frozenset({0, 3, 4, 5, 6, 7, 9, 10}),
    frozenset({0, 3, 4, 5, 6, 7, 9, 11}),
    frozenset({0, 3, 4, 5, 6, 7, 10, 11}),
    frozenset({0, 3, 4, 5, 6, 8, 9, 10}),
    frozenset({0, 3, 4, 5, 6, 8, 9, 11}),
    frozenset({0, 3, 4, 5, 6, 8, 10, 11}),
    frozenset({0, 3, 4, 5, 6, 9, 10, 11}),
    frozenset({0, 3, 4, 5, 7, 8, 9, 10}),
    frozenset({0, 3, 4, 5, 7, 8, 9, 11}),
    frozenset({0, 3, 4, 5, 7, 8, 10, 11}),
    frozenset({0, 3, 4, 5, 7, 9, 10, 11}),
    frozenset({0, 3, 4, 5, 8, 9, 10, 11}),
    frozenset({0, 3, 4, 6, 7, 8, 9, 10}),
    frozenset({0, 3, 4, 6, 7, 8, 9, 11}),
    frozenset({0, 3, 4, 6, 7, 8, 10, 11}),
    frozenset({0, 3, 4, 6, 7, 9, 10, 11}),
    frozenset({0, 3, 4, 6, 8, 9, 10, 11}),
    frozenset({0, 3, 4, 7, 8, 9, 10, 11}),
    frozenset({0, 3, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 3, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 3, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 3, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 3, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 3, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 3, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 8}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 9}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 10}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 8, 9}),
    frozenset({1, 2, 3, 4, 5, 6, 8, 10}),
    frozenset({1, 2, 3, 4, 5, 6, 8, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 9, 10}),
    frozenset({1, 2, 3, 4, 5, 6, 9, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 7, 8, 9}),
    frozenset({1, 2, 3, 4, 5, 7, 8, 10}),
    frozenset({1, 2, 3, 4, 5, 7, 8, 11}),
    frozenset({1, 2, 3, 4, 5, 7, 9, 10}),
    frozenset({1, 2, 3, 4, 5, 7, 9, 11}),
    frozenset({1, 2, 3, 4, 5, 7, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 8, 9, 10}),
    frozenset({1, 2, 3, 4, 5, 8, 9, 11}),
    frozenset({1, 2, 3, 4, 5, 8, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 6, 7, 8, 9}),
    frozenset({1, 2, 3, 4, 6, 7, 8, 10}),
    frozenset({1, 2, 3, 4, 6, 7, 8, 11}),
    frozenset({1, 2, 3, 4, 6, 7, 9, 10}),
    frozenset({1, 2, 3, 4, 6, 7, 9, 11}),
    frozenset({1, 2, 3, 4, 6, 7, 10, 11}),
    frozenset({1, 2, 3, 4, 6, 8, 9, 10}),
    frozenset({1, 2, 3, 4, 6, 8, 9, 11}),
    frozenset({1, 2, 3, 4, 6, 8, 10, 11}),
    frozenset({1, 2, 3, 4, 6, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 7, 8, 9, 10}),
    frozenset({1, 2, 3, 4, 7, 8, 9, 11}),
    frozenset({1, 2, 3, 4, 7, 8, 10, 11}),
    frozenset({1, 2, 3, 4, 7, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 5, 6, 7, 8, 9}),
    frozenset({1, 2, 3, 5, 6, 7, 8, 10}),
    frozenset({1, 2, 3, 5, 6, 7, 8, 11}),
    frozenset({1, 2, 3, 5, 6, 7, 9, 10}),
    frozenset({1, 2, 3, 5, 6, 7, 9, 11}),
    frozenset({1, 2, 3, 5, 6, 7, 10, 11}),
    frozenset({1, 2, 3, 5, 6, 8, 9, 10}),
    frozenset({1, 2, 3, 5, 6, 8, 9, 11}),
    frozenset({1, 2, 3, 5, 6, 8, 10, 11}),
    frozenset({1, 2, 3, 5, 6, 9, 10, 11}),
    frozenset({1, 2, 3, 5, 7, 8, 9, 10}),
    frozenset({1, 2, 3, 5, 7, 8, 9, 11}),
    frozenset({1, 2, 3, 5, 7, 8, 10, 11}),
    frozenset({1, 2, 3, 5, 7, 9, 10, 11}),
    frozenset({1, 2, 3, 5, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 6, 7, 8, 9, 10}),
    frozenset({1, 2, 3, 6, 7, 8, 9, 11}),
    frozenset({1, 2, 3, 6, 7, 8, 10, 11}),
    frozenset({1, 2, 3, 6, 7, 9, 10, 11}),
    frozenset({1, 2, 3, 6, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 4, 5, 6, 7, 8, 9}),
    frozenset({1, 2, 4, 5, 6, 7, 8, 10}),
    frozenset({1, 2, 4, 5, 6, 7, 8, 11}),
    frozenset({1, 2, 4, 5, 6, 7, 9, 10}),
    frozenset({1, 2, 4, 5, 6, 7, 9, 11}),
    frozenset({1, 2, 4, 5, 6, 7, 10, 11}),
    frozenset({1, 2, 4, 5, 6, 8, 9, 10}),
    frozenset({1, 2, 4, 5, 6, 8, 9, 11}),
    frozenset({1, 2, 4, 5, 6, 8, 10, 11}),
    frozenset({1, 2, 4, 5, 6, 9, 10, 11}),
    frozenset({1, 2, 4, 5, 7, 8, 9, 10}),
    frozenset({1, 2, 4, 5, 7, 8, 9, 11}),
    frozenset({1, 2, 4, 5, 7, 8, 10, 11}),
    frozenset({1, 2, 4, 5, 7, 9, 10, 11}),
    frozenset({1, 2, 4, 5, 8, 9, 10, 11}),
    frozenset({1, 2, 4, 6, 7, 8, 9, 10}),
    frozenset({1, 2, 4, 6, 7, 8, 9, 11}),
    frozenset({1, 2, 4, 6, 7, 8, 10, 11}),
    frozenset({1, 2, 4, 6, 7, 9, 10, 11}),
    frozenset({1, 2, 4, 6, 8, 9, 10, 11}),
    frozenset({1, 2, 4, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 5, 6, 7, 8, 9, 10}),
    frozenset({1, 2, 5, 6, 7, 8, 9, 11}),
    frozenset({1, 2, 5, 6, 7, 8, 10, 11}),
    frozenset({1, 2, 5, 6, 7, 9, 10, 11}),
    frozenset({1, 2, 5, 6, 8, 9, 10, 11}),
    frozenset({1, 2, 5, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 3, 4, 5, 6, 7, 8, 9}),
    frozenset({1, 3, 4, 5, 6, 7, 8, 10}),
    frozenset({1, 3, 4, 5, 6, 7, 8, 11}),
    frozenset({1, 3, 4, 5, 6, 7, 9, 10}),
    frozenset({1, 3, 4, 5, 6, 7, 9, 11}),
    frozenset({1, 3, 4, 5, 6, 7, 10, 11}),
    frozenset({1, 3, 4, 5, 6, 8, 9, 10}),
    frozenset({1, 3, 4, 5, 6, 8, 9, 11}),
    frozenset({1, 3, 4, 5, 6, 8, 10, 11}),
    frozenset({1, 3, 4, 5, 6, 9, 10, 11}),
    frozenset({1, 3, 4, 5, 7, 8, 9, 10}),
    frozenset({1, 3, 4, 5, 7, 8, 9, 11}),
    frozenset({1, 3, 4, 5, 7, 8, 10, 11}),
    frozenset({1, 3, 4, 5, 7, 9, 10, 11}),
    frozenset({1, 3, 4, 5, 8, 9, 10, 11}),
    frozenset({1, 3, 4, 6, 7, 8, 9, 10}),
    frozenset({1, 3, 4, 6, 7, 8, 9, 11}),
    frozenset({1, 3, 4, 6, 7, 8, 10, 11}),
    frozenset({1, 3, 4, 6, 7, 9, 10, 11}),
    frozenset({1, 3, 4, 6, 8, 9, 10, 11}),
    frozenset({1, 3, 4, 7, 8, 9, 10, 11}),
    frozenset({1, 3, 5, 6, 7, 8, 9, 10}),
    frozenset({1, 3, 5, 6, 7, 8, 9, 11}),
    frozenset({1, 3, 5, 6, 7, 8, 10, 11}),
    frozenset({1, 3, 5, 6, 7, 9, 10, 11}),
    frozenset({1, 3, 5, 6, 8, 9, 10, 11}),
    frozenset({1, 3, 5, 7, 8, 9, 10, 11}),
    frozenset({1, 3, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({1, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({1, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({1, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({1, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({1, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({1, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({2, 3, 4, 5, 6, 7, 8, 9}),
    frozenset({2, 3, 4, 5, 6, 7, 8, 10}),
    frozenset({2, 3, 4, 5, 6, 7, 8, 11}),
    frozenset({2, 3, 4, 5, 6, 7, 9, 10}),
    frozenset({2, 3, 4, 5, 6, 7, 9, 11}),
    frozenset({2, 3, 4, 5, 6, 7, 10, 11}),
    frozenset({2, 3, 4, 5, 6, 8, 9, 10}),
    frozenset({2, 3, 4, 5, 6, 8, 9, 11}),
    frozenset({2, 3, 4, 5, 6, 8, 10, 11}),
    frozenset({2, 3, 4, 5, 6, 9, 10, 11}),
    frozenset({2, 3, 4, 5, 7, 8, 9, 10}),
    frozenset({2, 3, 4, 5, 7, 8, 9, 11}),
    frozenset({2, 3, 4, 5, 7, 8, 10, 11}),
    frozenset({2, 3, 4, 5, 7, 9, 10, 11}),
    frozenset({2, 3, 4, 5, 8, 9, 10, 11}),
    frozenset({2, 3, 4, 6, 7, 8, 9, 10}),
    frozenset({2, 3, 4, 6, 7, 8, 9, 11}),
    frozenset({2, 3, 4, 6, 7, 8, 10, 11}),
    frozenset({2, 3, 4, 6, 7, 9, 10, 11}),
    frozenset({2, 3, 4, 6, 8, 9, 10, 11}),
    frozenset({2, 3, 4, 7, 8, 9, 10, 11}),
    frozenset({2, 3, 5, 6, 7, 8, 9, 10}),
    frozenset({2, 3, 5, 6, 7, 8, 9, 11}),
    frozenset({2, 3, 5, 6, 7, 8, 10, 11}),
    frozenset({2, 3, 5, 6, 7, 9, 10, 11}),
    frozenset({2, 3, 5, 6, 8, 9, 10, 11}),
    frozenset({2, 3, 5, 7, 8, 9, 10, 11}),
    frozenset({2, 3, 6, 7, 8, 9, 10, 11}),
    frozenset({2, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({2, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({2, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({2, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({2, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({2, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({2, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({2, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({3, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({3, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({3, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({3, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({3, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({3, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({3, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({3, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 8}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 9}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 8, 9}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 8, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 8, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 8, 9}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 8, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 8, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 8, 9}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 8, 10}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 8, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 6, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 8, 9}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 8, 10}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 8, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 9, 10}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 9, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 5, 6, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 5, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 5, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 8, 9}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 8, 10}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 8, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 9, 10}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 9, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 8, 9, 10}),
    frozenset({0, 1, 2, 4, 5, 6, 8, 9, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 8, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 4, 5, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 4, 5, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 4, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 4, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 4, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 8, 9}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 8, 10}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 8, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 9, 10}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 9, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 8, 9, 10}),
    frozenset({0, 1, 3, 4, 5, 6, 8, 9, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 8, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 7, 8, 9, 10}),
    frozenset({0, 1, 3, 4, 5, 7, 8, 9, 11}),
    frozenset({0, 1, 3, 4, 5, 7, 8, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 7, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 3, 4, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 3, 4, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 3, 4, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 3, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 3, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 3, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 3, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 8, 9}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 8, 10}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 8, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 9, 10}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 9, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 8, 9, 10}),
    frozenset({0, 2, 3, 4, 5, 6, 8, 9, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 8, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 7, 8, 9, 10}),
    frozenset({0, 2, 3, 4, 5, 7, 8, 9, 11}),
    frozenset({0, 2, 3, 4, 5, 7, 8, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 7, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 6, 7, 8, 9, 10}),
    frozenset({0, 2, 3, 4, 6, 7, 8, 9, 11}),
    frozenset({0, 2, 3, 4, 6, 7, 8, 10, 11}),
    frozenset({0, 2, 3, 4, 6, 7, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 6, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 2, 3, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 2, 3, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 2, 3, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 2, 3, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 2, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 2, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 2, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 2, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 2, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 3, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 3, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 3, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 3, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 3, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 3, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 3, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 3, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 8, 9}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 8, 10}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 8, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 9, 10}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 9, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 8, 9, 10}),
    frozenset({1, 2, 3, 4, 5, 6, 8, 9, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 8, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 7, 8, 9, 10}),
    frozenset({1, 2, 3, 4, 5, 7, 8, 9, 11}),
    frozenset({1, 2, 3, 4, 5, 7, 8, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 7, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 6, 7, 8, 9, 10}),
    frozenset({1, 2, 3, 4, 6, 7, 8, 9, 11}),
    frozenset({1, 2, 3, 4, 6, 7, 8, 10, 11}),
    frozenset({1, 2, 3, 4, 6, 7, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 6, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 5, 6, 7, 8, 9, 10}),
    frozenset({1, 2, 3, 5, 6, 7, 8, 9, 11}),
    frozenset({1, 2, 3, 5, 6, 7, 8, 10, 11}),
    frozenset({1, 2, 3, 5, 6, 7, 9, 10, 11}),
    frozenset({1, 2, 3, 5, 6, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 5, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({1, 2, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({1, 2, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({1, 2, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({1, 2, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({1, 2, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 3, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({1, 3, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({1, 3, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({1, 3, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({1, 3, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({1, 3, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({1, 3, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 3, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({2, 3, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({2, 3, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({2, 3, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({2, 3, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({2, 3, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({2, 3, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({2, 3, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({2, 3, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({2, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({3, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 8, 9}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 8, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 8, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 3, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 3, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({2, 3, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 8, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 3, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11}),
    frozenset({0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11})
]
